<?php

/* set system paths */
define('DS',               DIRECTORY_SEPARATOR);
define('ROOT_PATH',        dirname(__FILE__));
define('CACHE_PATH',       ROOT_PATH . DS . 'cache');
define('APPLICATION_PATH', ROOT_PATH . DS . 'application');
define('LIBRARY_PATH',     ROOT_PATH . DS . 'library');
define('MODULES_PATH',     APPLICATION_PATH . DS . 'modules');
define('FILES_TEMP_PATH',  ROOT_PATH . DS . 'public' . DS . 'files' . DS . 'temp');
define('FILES_TEMP_URI',   '/public/files/temp');
define('AVATAR_PATH',      ROOT_PATH . DS . 'public' . DS . 'files' . DS . 'avatars');
define('AVATAR_URI',       '/public/files/avatars');

/* set include path */
set_include_path(LIBRARY_PATH);

/* load Singular autostart instructions */
require_once 'SingularAutostart.php';

/* set application environment */
define(
    'APPLICATION_ENV', getenv('APPLICATION_ENV')
        ? getenv('APPLICATION_ENV')
        : (getenv('REDIRECT_APPLICATION_ENV')
                ? getenv('REDIRECT_APPLICATION_ENV')
                : 'production')
);

/* application start */
require_once 'Singular/Bootstrap.php';
require_once 'Zend/Config.php';
$config = include APPLICATION_PATH . '/configs/application.inc';
$config['resources']['frontController']['plugins'][] = 'System_Controller_Plugin_ApiHandler';
$application = new Singular_Bootstrap(
    APPLICATION_ENV, new Zend_Config($config, true)
);
require_once 'Useresponse.php';
$application->executeResource('api');
$application->bootstrap();
$application->run();