<?php
/**
 * WARNING!
 * Do not edit this file directly!
 */

$bootstrap = array(

    /* PHP directives */
    'phpSettings' => array(
        'display_startup_errors' => 1,
        'display_errors'         => 1
    ),

    'perfomance_test' => false,

    /* Application resources */
    'resources' => array(

        /* Database */
        'db' => array(
            'adapter' => 'pdo_mysql',
            'params'  => array(
                'host'        => "localhost",
                'port'        => 3306,
                'dbname'      => '',
                'username'    => '',
                'password'    => '',
                'prefix'      => 'sglr_',
                'profiler' => 
                array (
                  'enabled' => false,
                  'class' => 'Zend_Db_Profiler_Firebug',
                ),
                'charset'     => 'utf8',
                'date_format' => 'YYYY-MM-ddTHH:mm:ss',
                'options' => array(
                    'caseFolding'          => false,
                    'autoQuoteIdentifiers' => true
                )
            ),
            'isDefaultTableAdapter' => true
        ),

        /* Date */
        'date' => array(
            // php, iso
            'format_type' => 'php',
            'enable'      => true
        ),

        /* ACL */
        'acl' => array(
            'enable' => true,
            'error'  => array(
                'moduleName'     => 'system',
                'controllerName' => 'error',
                'actionName'     => 'access-denied'
            ),
            'navigationInject' => true
        ),

        /* Auth */
        'auth' => array(
            'table_name' => 'users',
            'columns'    => array(
                'identity'   => 'email',
                'credential' => 'password',
                'is_active'  => 'is_active'
            ),
            'allow_value' => '1',
            'enable'      => true
        ),

        /* FrontController */
        'frontController' => array(
            'moduleDirectory'               => APPLICATION_PATH . '/modules',
            'moduleControllerDirectoryName' => 'controllers',
            'defaultModule'                 => 'homes',
            'defaultControllerName'         => 'index',
            'defaultAction'                 => 'index',
            'baseUrl'                       => '/',
            'throwExceptions'               => false,
            'params' => array(
                'disableOutputBuffering' => true
            ),
            'actionHelperPaths' => array(
                'Singular_Controller_Action_Helper_' => 'Singular/Controller/Action/Helper'
            ),
            'plugins' => array(
                'errorhandler' => array(
                    'classname' => 'Zend_Controller_Plugin_ErrorHandler',
                    'options'   => array(
                        'module'     => 'system',
                        'controller' => 'error',
                        'action'     => 'error'
                    )
                ),
                'Singular_Controller_Plugin_Layout',
                'Singular_Controller_Plugin_Head',
                'Singular_Controller_Plugin_AppClient',
                'Singular_Controller_Plugin_PageDefaults',
                'Singular_Controller_Plugin_Quotes',
                /*'Singular_Controller_Plugin_Acl',*/
                /*'Singular_Controller_Plugin_Debug',*/
                'Singular_Controller_Plugin_Themes',
                'Singular_Controller_Plugin_Events'
            )
        ),

        /* Router */
        'router' => array(
            'routes' => array(
                'default' => array(
                    'type'     => 'Zend_Controller_Router_Route',
                    'route'    => '/*',
                    'defaults' => array(
                        'module'     => 'home',
                        'controller' => 'index',
                        'action'     => 'index'
                    )
                )
            ),
            //'useRequestParametersAsGlobal' => false
        ),

        /* Autoloader */
        'autoloader' => array(
            'autoloader' => 'Singular',

            /* Singular autoloader */
            'singular'   => array(
                'cache'  => array(
                    'enable'   => true,
                    /* frontend */
                    'frontend' => array(
                        'name'                 => 'Core',
                        'customFrontendNaming' => false,
                        'options' => array(
                            'lifetime'                => 864000,
                            'automatic_serialization' => true,
                            'cache_id_prefix'         => 'autoloader_',
                            'ignore_user_abort'       => true
                        )
                    ),
                    /* backend */
                    'backend'  => array(
                        'name'                => 'File',
                        'customBackendNaming' => false,
                        'options' => array(
                            'cache_dir'                  => ROOT_PATH . "/cache",
                            'hashed_directory_level'     => 0,
                            'read_control'               => false,
                            'read_control_type'          => 'adler32',
                            'metatadatas_array_max_size' => 10,

                        )
                    ),
                    'frontendBackendAutoload' => false
                )
            ),

            /* Zend autoloader */
            'zend' => array(
                'params' => array(
                    'enableFallbackAutoloader' => true,
                    'suppressNotFoundWarnings' => false,
                    'noZendX' => true,
                ),
                'registry_key' => 'autoloader',
                'modules' => array(
                    'system'
                )
            )
        ),

        /* Cachemanager */
        'cachemanager' => array(
            'globalCacheEnabled' => false,

            /* default cache */
            'default' => array(
                /* frontend */
                'frontend' => array(
                    'name'                 => 'Core',
                    'customFrontendNaming' => false,
                    'options' => array(
                        'caching'                 => true,
                        'lifetime'                => 864000,
                        'automatic_serialization' => true,
                        'cache_id_prefix'         => 'default_',
                        'ignore_user_abort'       => true
                    )
                ),
                /* backend */
                'backend'  => array(
                    'name'                => 'File',
                    'customBackendNaming' => false,
                    'options' => array(
                        'cache_dir'                  => CACHE_PATH,
                        'hashed_directory_level'     => 2,
                        'read_control'               => false,
                        'read_control_type'          => 'adler32',
                        'metatadatas_array_max_size' => 10,

                    )
                ),
                'frontendBackendAutoload' => false
            ),

            /* acl cache */
            'acl' => array(
                /* frontend */
                'frontend' => array(
                    'name'                 => 'Core',
                    'customFrontendNaming' => false,
                    'options' => array(
                        'caching'                 => true,
                        'lifetime'                => 864000,
                        'automatic_serialization' => true,
                        'cache_id_prefix'         => 'acl_',
                        'ignore_user_abort'       => true
                    )
                ),
                /* backend */
                'backend'  => array(
                    'name'                => 'File',
                    'customBackendNaming' => false,
                    'options' => array(
                        'cache_dir'                  => CACHE_PATH,
                        'hashed_directory_level'     => 0,
                        'read_control'               => false,
                        'read_control_type'          => 'adler32',
                        'metatadatas_array_max_size' => 10,

                    )
                ),
                'frontendBackendAutoload' => false
            ),

            /* database cache */
            'database' => array(
                /* frontend */
                'frontend' => array(
                    'name'                 => 'Core',
                    'customFrontendNaming' => false,
                    'options' => array(
                        'caching'                 => true,
                        'lifetime'                => 864000,
                        'automatic_serialization' => true,
                        'cache_id_prefix'         => 'db_',
                        'ignore_user_abort'       => true
                    )
                ),
                /* backend */
                'backend'  => array(
                    'name'                => 'File',
                    'customBackendNaming' => false,
                    'options' => array(
                        'cache_dir'                  => CACHE_PATH,
                        'hashed_directory_level'     => 2,
                        'read_control'               => false,
                        'read_control_type'          => 'adler32',
                        'metatadatas_array_max_size' => 10,

                    )
                ),
                'frontendBackendAutoload' => false
            ),

            /* router cache */
            'router' => array(
                /* frontend */
                'frontend' => array(
                    'name'                 => 'Core',
                    'customFrontendNaming' => false,
                    'options' => array(
                        'caching'                 => true,
                        'lifetime'                => 864000,
                        'automatic_serialization' => true,
                        'cache_id_prefix'         => 'router_',
                        'ignore_user_abort'       => true
                    )
                ),
                /* backend */
                'backend'  => array(
                    'name'                => 'File',
                    'customBackendNaming' => false,
                    'options' => array(
                        'cache_dir'                  => CACHE_PATH,
                        'hashed_directory_level'     => 0,
                        'read_control'               => false,
                        'read_control_type'          => 'adler32',
                        'metatadatas_array_max_size' => 10,

                    )
                ),
                'frontendBackendAutoload' => false
            ),

            /* translate cache */
            'translate' => array(
                /* frontend */
                'frontend' => array(
                    'name'                 => 'Core',
                    'customFrontendNaming' => false,
                    'options' => array(
                        'caching'                 => true,
                        'lifetime'                => 864000,
                        'automatic_serialization' => true,
                        'cache_id_prefix'         => 'translate_',
                        'ignore_user_abort'       => true
                    )
                ),
                /* backend */
                'backend'  => array(
                    'name'                => 'File',
                    'customBackendNaming' => false,
                    'options' => array(
                        'cache_dir'                  => CACHE_PATH,
                        'hashed_directory_level'     => 0,
                        'read_control'               => false,
                        'read_control_type'          => 'adler32',
                        'metatadatas_array_max_size' => 10,

                    )
                ),
                'frontendBackendAutoload' => false
            ),

            /* paginator cache */
            'paginator' => array(
                /* frontend */
                'frontend' => array(
                    'name'                 => 'Core',
                    'customFrontendNaming' => false,
                    'options' => array(
                        'caching'                 => true,
                        'lifetime'                => 864000,
                        'automatic_serialization' => true,
                        'cache_id_prefix'         => 'paginator_',
                        'ignore_user_abort'       => true
                    )
                ),
                /* backend */
                'backend'  => array(
                    'name'                => 'File',
                    'customBackendNaming' => false,
                    'options' => array(
                        'cache_dir'                  => CACHE_PATH,
                        'hashed_directory_level'     => 1,
                        'read_control'               => false,
                        'read_control_type'          => 'adler32',
                        'metatadatas_array_max_size' => 10,

                    )
                ),
                'frontendBackendAutoload' => false
            ),

            /* eventHandlers cache */
            'eventHandlers' => array(
                /* frontend */
                'frontend' => array(
                    'name'                 => 'Core',
                    'customFrontendNaming' => false,
                    'options' => array(
                        'caching'                 => true,
                        'lifetime'                => 864000,
                        'automatic_serialization' => true,
                        'cache_id_prefix'         => 'events_',
                        'ignore_user_abort'       => true
                    )
                ),
                /* backend */
                'backend'  => array(
                    'name'                => 'File',
                    'customBackendNaming' => false,
                    'options' => array(
                        'cache_dir'                  => CACHE_PATH,
                        'hashed_directory_level'     => 0,
                        'read_control'               => false,
                        'read_control_type'          => 'adler32',
                        'metatadatas_array_max_size' => 10,

                    )
                ),
                'frontendBackendAutoload' => false
            )
        ),

        /* Session */
        'session' => array(
            'save_path'           => APPLICATION_PATH . '/sessions',
            'remember_me_seconds' => 864000,
            'use_only_cookies'    => true,
        ),

        /* View */
        'view' => array(
            'encoding'            => 'utf-8',
            'setUseStreamWrapper' => false,
            'strictVars'          => true,
            'escape'              => 'htmlentities',
            'scriptPath'          => APPLICATION_PATH . '/templates',
            'helperPath'          => array('Singular_View_Helper_' => 'Singular/View/Helper'),
            'filterPath'          => array('Singular_View_Helper_' => 'Singular/View/Filter'),
            'doctype'             => 'HTML5',
            'debug'               => false
        ),

        /* Layout */
        'layout' => array(
            'layoutPath' => APPLICATION_PATH . '/layouts',
            'layout'     => 'main',
            'contentKey' => 'content'
        ),

        /* Locale */
        'locale' => array(
            'enable' => true
        ),

        /* Languages */
        'languages' => array(
            'enable' => true
        ),

        /* Modules */
        'modules' => array(
            'autodiscover' => true,
            'default'      => array(
                'system'
            )
        ),

        /* Navigation */
        'navigation' => array(
            'defaultPageType' => 'mvc',
            'pages'           => array(),
            'storage'         => array(
                'registry' => true
            ),
            'enable' => true
        ),

        /* Themes */
        'themes' => array(
            'path'  => 'public/themes',
            'views' => array(
                'common' => array('path' => '/templates')
            )
        ),

        /* Translate */
        'translate' => array(
            'adapter' => 'array',
            'options' => array(
                'disableNotices'  => false,
                'scan'            => 'filename',
                'clear'           => false,
                'reload'          => false,
                'ignore'          => '.',
                'logUntranslated' => false
            ),
            'isDefaultValidateTranslator' => true,
            'isDefaultFormTranslator'     => true,
            'isDefaultRouterTranslator'   => false,
            'cookie_expire'               => 31536000, // one year
            'languageSource'              => 'system_settings', // cookies, user_settings, system_settings
            'defaultLanguage'             => 'en'
        ),

        /* Events */
        'event' => array(
            'handlersDirectoryName' => 'handlers',
            'throwExceptions'       => false
        ),

        /* Output */
        'output' => array(
            'enable'               => false,
            'use_db_settings'      => false,
            'store_dir'            => ROOT_PATH . '/public/static',
            'autocreate_store_dir' => true,
            'options' => array(
                'combine_assets'               => true,
                'minify_assets'                => true,
                'process_inline_css'           => true,
                'process_inline_js'            => false,
                'css_resource_path_correction' => true,
                'print_source_path'            => true
            )
        ),

        /* Zend framework debug toolbar */
        'zfdebug' => array(
            'enabled' => false,
            'z-index' => 100000000,
            'plugins' => array(
                'Variables' => null,
                'Time'      => null,
                'Memory'    => null,
                'Html'      => null,
                'Registry'  => null,
                'Exception' => null
            )
        )
    ),

    /* Directories */
    'directories' => array(
        'vendors' => ROOT_PATH . '/vendors'
    ),

    /* htmlElement */
    'htmlElement' => array(
        'assetsPath'        => 'public/assets',
        'assetsPathModules' => 'public/assets/modules',
        'assetsPathThemes'  => 'assets',
        'imageDirName'      => 'images',
        'flashDirName'      => 'flash',
        'stylesheetDirName' => 'css',
        'javascriptDirName' => 'js',
        'commonDirName'     => 'common',
        'checkExistence'    => false
    ),

    'pageDefaults' => array(
        'frontend' => array(
            'javascriptFile' => 'frontend.js',
            'stylesheetFile' => 'frontend.css'
        ),
        'admin' => array(
            'javascriptFile' => 'admin.js',
            'stylesheetFile' => 'admin.css',
        )
    )
);

return $bootstrap;
