<?php

class Freepackage_Handler_Events extends Singular_Event_Listener_Abstract
{

    public static function bindListeners()
    {
        self::attachAggregate('buildNavigation',   array(__CLASS__, 'onNavigation'));
    }


    public static function onNavigation($navigation)
    {
        $loggedUser = Singular_Runtime::extract("loggedUser");
        if ($loggedUser->isAdmin()) {
            $page = $navigation->findBy('id', 'admin');

            if ($page instanceof Zend_Navigation_Page) {
                $page->addPage(array(
                    'id' => 'roles_example',
                    'menu_type' => 'admin-sidebar',
                    'order' => 20,
                    'image' => self::getView()->imageSrc('/icons/16/roles.png', null, true),
                    'label' => self::getView()->t('Roles'),
                    'route' => 'admin_roles',
                ));

                $page->addPage(array(
                    'id' => 'categories_example',
                    'menu_type' => 'admin-sidebar',
                    'order' => 30,
                    'image' => self::getView()->imageSrc('icon_small_categories.png', 'freepackage', false),
                    'label' => self::getView()->t('Categories'),
                    'route' => 'admin_categories',
                ));

                $page->addPage(array(
                    'id' => 'knowledge_base_example',
                    'menu_type' => 'admin-sidebar',
                    'order' => 51,
                    'image' => self::getView()->imageSrc('icon_small_knowledge_base.png', 'freepackage', false),
                    'label' => self::getView()->t('Knowledge Base'),
                    'route' => 'admin_knowledge_base',
                ));

                $page->addPage(array(
                    'id' => 'backup_example',
                    'menu_type' => 'admin-sidebar',
                    'order' => 70,
                    'image' => self::getView()->imageSrc('icon_small_backup.png', 'freepackage', false),
                    'label' => self::getView()->t('Backup'),
                    'route' => 'admin_backup',
                ));

                $page->addPage(array(
                    'id' => 'updates_example',
                    'menu_type' => 'admin-sidebar',
                    'order' => 75,
                    'image' => self::getView()->imageSrc('icon_small_updates.png', 'freepackage', false),
                    'label' => self::getView()->t('Updates'),
                    'route' => 'admin_updates',
                ));

                $page->addPage(array(
                    'id' => 'chat_example',
                    'menu_type' => 'admin-sidebar',
                    'order' => 95,
                    'image' => self::getView()->imageSrc('icon_small_chat.png', 'freepackage', false),
                    'label' => self::getView()->t('Chat'),
                    'route' => 'admin_chat',
                ));
            }
        }

    }

}