<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   Loginplus
 * @package    Loginplus_Controller
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Admin controller
 *
 * @uses       System_Controller_Abstract_Action
 * @category   Loginplus
 * @package    Loginplus_Controller
 */
class Loginplus_AdminController extends System_Controller_Abstract_Admin
{
    /**
     * Displays module configuration page
     *
     * @return void
     */
    public function indexAction ()
    {
        $form = new Loginplus_Form_Settings($this->settings->loginplus->general);

        if ($this->getRequest()->isPost()) {
            $post = $this->getRequest()->getPost();
            if ($form->isValid($post)) {
                $data = $form->getValues();
                foreach ($data as $key => $value) {
                    Singular_Core::_('settings')->changeSetting($key, $value);
                }
                $this->view->notify()->success('Login Plus settings are changed!');
            }
        }
        $this->view->form = $form;
    }

}
