<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   Resources
 * @package    Resources_Component
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * ShowComments component
 *
 * Displays comments block
 *
 * @uses       Singular_Component_Abstract
 * @category   Resources
 * @package    Resources_Component
 */
class Resources_Component_ShowComments extends Singular_Component_Abstract
{
    /**
     * Init method.
     * Used for initialize component.
     *
     * @return void
     */
    public function init()
    {
        $activeResponse = $this->getOption('activeResponse');
        $types = Singular_Runtime::extract("types");
        if ($types->findBySlug($activeResponse->type)->has_comments) {
            $form = new Resources_Form_CommentAdd();
            $form->setDefault('response_id', $activeResponse->id);

            $this->assignViewVar('form', $form);
            $this->assignViewVar('activeResponse', $activeResponse);

            Singular_AppClient::setParam('activeResponseId', $activeResponse->id);

            $this->setViewScript('show-comments');

            if ($activeResponse->countComments() > Resources_Model_DbTable_ResponsesComments::LIMIT) {
                Singular_AppClient::setParam('nextPage', 2);
            } else {
                Singular_AppClient::setParam('nextPage', 0);
            }
        }
    }
}