<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   Resources
 * @package    Resources_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * CommentEdit form
 *
 * @uses       Singular_Form
 * @category   Resources
 * @package    Resources_Form
 */
class Resources_Form_CommentEdit extends Resources_Form_Comment
{
    /**
     * Initialize form (used by extending classes)
     *
     * @return void
     */
    public function init()
    {
        $this->setAttribs(array(
            'id'     => 'comment-edit',
            'class'  => 'comment-edit-form',
            'action' => $this->getView()->url(array(), 'comments_comment_edit')
        ));
        
        parent::init();

        $this->addElement('hidden', 'comment_id', array(
            'required'   => true,
            'decorators' => array(
                'viewHelper'
            )
        ));

        $this->content->setAttrib("rows", "5");

        $this->submit->setLabel("Edit")
                     ->setAttrib("class", "button-type1 floatLeft");

        if ($this->getElement('response_status')) {
            $this->removeElement('response_status');
        }
    }
}
