<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   Resources
 * @package    Resources_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Template form
 *
 * @uses       Singular_Form
 * @category   Resources
 * @package    Resources_Form
 */
class Resources_Form_Template extends Singular_Form
{
    /**
     * Initialize form (used by extending classes)
     *
     * @return void
     */
    public function init()
    {
        $this->setDecorators(array(
            new System_Form_Decorator_FlashErrors(),
            new Zend_Form_Decorator_ViewScript(array(
                    'viewScript' => 'forms/template.phtml'
                )),
            'Form'
        ));

        $this->addElement('text', 'subject', array(
            'label'      => 'Subject',
            'allowEmpty' => false,
            'filters'    => array('StringTrim'),
            'validators' => array(),
            'order'      => 1,
            'decorators' => array(
                'ViewHelper',
                array('ViewScript', array('viewScript' => 'forms/elements/text-input.phtml'))
            ),
            'validators' => array(
                array('validator' => 'NotEmpty', 'options' => array(
                    'messages' => array(
                        Zend_Validate_NotEmpty::IS_EMPTY => 'Subject is required!'
                    )
                ))
            )
        ));

        $this->addElement('textarea', 'body', array(
            'label'      => 'Body',
            'allowEmpty' => false,
            'filters'    => array('StringTrim'),
            'validators' => array(),
            'order'      => 2,
            'decorators' => array(
                'ViewHelper',
                array('ViewScript', array('viewScript' => 'forms/elements/textarea.phtml'))
            ),
            'validators' => array(
                array('validator' => 'NotEmpty', 'options' => array(
                    'messages' => array(
                        Zend_Validate_NotEmpty::IS_EMPTY => 'Body is required!'
                    )
                ))
            )
        ));

        $this->addElement('submit', 'submit', array(
            'ignore'   => true,
            'label'    => 'Submit',
            'attribs'  => array(
                'class' => 'button-type2'
            ),
            'decorators' => array(
                'ViewHelper',
                array('ViewScript', array('viewScript' => 'forms/elements/button.phtml'))
            ),
            'order'    => 10,
        ));
    }
}
