<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   Categories
 * @package    Categories_Model
 * @subpackage Categories_Model_DbTable
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Emails_stack table model.
 *
 * @uses       System_Model_DbTable_Abstract
 * @category   Categories
 * @package    Categories_Model
 * @subpackage Categories_Model_DbTable
 */
class Resources_Model_DbTable_EmailsStack extends System_Model_DbTable_Abstract
{
    /**
     * The table name
     *
     * @var string
     */
    protected $_name = 'emails_stack';

    /**
     * The primary key column or columns.
     * A compound key should be declared as an array.
     * You may declare a single-column primary key
     * as a string.
     *
     * @var mixed
     */
    protected $_primary = 'id';

    /**
     * Row class
     *
     * @var string
     */
    protected $_rowClass = 'Resources_Model_Email';

    /**
     * @return Zend_Db_Table_Rowset
     */
    public function findCurrentMails()
    {
        $select = $this->getSelect();
        $select->where("time<?", date("Y-m-d H:i:s"));
        return $this->fetchAll($select);
    }
}
