<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   Resources
 * @package    Resources_Model
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * emails_stack row model
 *
 * @uses       System_Model_Row
 * @category   Resources
 * @package    Resources_Model
 */
class Resources_Model_Email extends System_Model_Row
{
    /**
     * Table class
     *
     * @var string
     */
    protected $_tableClass = 'Resources_Model_DbTable_EmailsStack';

    /**
     * Sends email
     *
     * Uses fields: email, subject, body
     *
     * @return int
     */
    public function send()
    {
        return Resources_Service_ApplicationMailer::sendEmail(
            $this->email,
            $this->subject,
            $this->body
        );
    }
}
