<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Service
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Api service
 *
 * @category   System
 * @package    System_Service
 */
class Resources_Service_Votes
{
    /**
     * Sets current namespace
     *
     * @param string $namespace
     */
    public static function setUserVotes($cacheId, $tags)
    {
        $loggedUser = Singular_Runtime::extract("loggedUser");
        
        if (!$loggedUser->isGuest()) {
            
            if ($tags == null) {
                $cache = Singular_Runtime::extract("cachemanager")->getCache("default");
                $metadatas = $cache->getMetadatas($cacheId);
                if ($metadatas !== false) {
                    $tags = $metadatas['tags'];
                }
            }
            if (!empty($tags)) {
                
                $types = Singular_Runtime::extract("types");
                foreach ($types as $type) {
                    $tps[] = $type->slug;
                }
                if (!empty($tps)) {
                    $tps = implode("|", $tps);
                    foreach ($tags as $tag) {
                        if (preg_match("/^($tps)_(\d+)/", $tag, $matches)) {
                            $objects[] = array(
                                'type' => $matches[1],
                                'id'   => $matches[2]
                            );
                        }
                    }
                    if (!empty($objects)) {
                        $votesDb = Singular_Loader::get('Resources_Model_DbTable_Votes');
                        $votes = $votesDb->findByObjectIdsAndUserId($objects, $loggedUser->id);            
                        if (Singular_AppClient::hasParam("user_votes")) {
                            $param = Singular_AppClient::getParam("user_votes");
                            foreach ($param as $key=>$value) {
                                $votes[$key] = $value;
                            }
                        }
                        $request = Zend_Controller_Front::getInstance()->getRequest();
                        if ($request->isXmlHttpRequest()) {
                            $view = Zend_Layout::getMvcInstance()->getView();
                            $view->user_votes = $votes;
                        } else {
                            Singular_AppClient::setParam("user_votes", $votes);
                        }
                    }
                }
            }
        }
    }
}
