<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Component
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Response sidebar component
 *
 * @uses       Singular_Component_Abstract
 * @category   System
 * @package    System_Component
 */
class System_Component_ResponseSidebar extends Singular_Component_Abstract
{
    /**
     * Init method
     *
     * Used for initialize component
     *
     * @return void
     */
    public function init ()
    {       
        $commentsSum = $this->view->activeResponse->countComments();

        $subscribersDb = Singular_Loader::get('System_Model_DbTable_ResponsesSubscribers');
        $subscribersSum = $subscribersDb->countByResponseId($this->view->activeResponse->id);

        $sidebar[] = array(
                     'id'    => 'statistics',
                     'theme' => 1,
                     'class' => 'categories-block',
                     'label' => $this->view->t('Statistics'),
                     'url'   => false,
                     'submenu' => array(
                         0 => array(
                             'id'    => 'statistics-comments',
                             'sum'   => $commentsSum,
                             'label' => $this->view->t('Comments'),
                             'url'   => false,
                         ),
                         1 => array(
                             'id'    => 'statistics-participants',
                             'sum'   => $this->view->activeResponse->getParticipantsSum(),
                             'label' => $this->view->t('Participants'),
                             'url'   => $this->view->url(array('slug' => $this->view->activeResponse->slug), 'users_participants'),
                         ),
                         2 => array(
                             'id'    => 'statistics-subscribers',
                             'sum'   => $subscribersSum,
                             'label' => $this->view->t('Subscribers'),
                             'url'   => $this->view->url(array('slug' => $this->view->activeResponse->slug), 'users_subscribers'),
                         ),
                         3 => array(
                             'id'    => 'statistics-views',
                             'sum'   => $this->view->activeResponse->views,
                             'label' => $this->view->t('Views'),
                             'url'   => false,
                         )
                     )
        );
        
        $data = new stdClass();
        $data->sidebar = $sidebar;
        Singular_Event::dispatch('responseSidebar', $data);
        ksort($data->sidebar);
        
        $this->assignViewVar('sidebar' , $data->sidebar);
        $this->setViewScript('response-sidebar');
    }
}
