<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Controller
 * @subpackage System_Controller_Abstract
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Admin controller
 *
 * @uses       System_Controller_Abstract_Action
 * @category   System
 * @package    System_Controller
 * @subpackage System_Controller_Abstract
 * @property   Singular_View $view
 * @property   System_Model_User $loggedUser
 * @property   Singular_Controller_Action_Helper_Autoresponder $autoresponder
 */
class System_Controller_Abstract_Admin extends System_Controller_Abstract_Action
{
    /**
     * Initialize object
     *
     * Called from {@link __construct()} as final step of object instantiation.
     *
     * @see parent::init();
     */
    public function init ()
    {
        parent::init();
        if (!$this->loggedUser->isAdmin()) {
            throw new Singular_Acl_Exception($this->view->t('Access denied'));
        }
        $this->view->help    = $this->getRequest()->getCookie("help", "block");
        $this->view->buttons = array();
        $this->view->layout()->setLayout('admin');

        System_Service_Environment::getInstance()->setNamespace(System_Service_Environment::ADMIN);
    }
}