<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Controller
 * @subpackage System_Controller_Abstract
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * System auth action controller
 *
 * @uses       System_Controller_Abstract_Action
 * @category   System
 * @package    System_Controller
 * @subpackage System_Controller_Abstract
 */
class System_Controller_Abstract_Auth extends System_Controller_Abstract_Action
{
    /**
     * Auth instance
     *
     * @var Zend_Auth
     */
    protected $_auth;

    /**
     * Initialize object
     *
     * Called from {@link __construct()} as final step of object instantiation.
     *
     * @return void
     */
    public function init ()
    {
        parent::init();
        $this->_auth = Zend_Auth::getInstance();
        $this->view->actionName = $this->getRequest()->getActionName();

        $this->loginForm    = $this->view->loginForm    = new System_Form_Login();
        $this->registerForm = $this->view->registerForm = new System_Form_Registration();
        $this->forgotForm   = $this->view->forgotForm   = new System_Form_PasswordForgot();

        $this->redirect = new Zend_Session_Namespace('Redirect');
        //set redirect url
        $url = $this->_getParam("redirect");
        if (isset($url)) {
            if ($url == "reset") {
                $this->redirect->unsetAll();
            } else {
                if (preg_match("/^http/ui", $url)) {
                    $this->redirect->url  = urldecode($url);
                } else {
                    $this->redirect->url = $this->view->baseUrl(urldecode($url));
                }
            }
        }
        //set form submitted (ajax)
        $formId = $this->_getParam("form_id");
        if (isset($formId)) {
            $this->redirect->formId = $formId;
        }
        
        $this->view->url = null;
        $this->view->formId = null;
        
        if (isset($this->redirect->url)) {
            $this->view->url = $this->redirect->url;
        }
        if (isset($this->redirect->formId)) {
            $this->view->formId = $this->redirect->formId;
        }
    }
}
