<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Controller
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Activity controller
 *
 * @uses       System_Controller_Abstract_Action
 * @category   System
 * @package    System_Controller
 */
class ActivityController extends System_Controller_Abstract_Action
{
    /**
     * Initialize object
     *
     * Called from {@link __construct()} as final step of object instantiation.
     */
    public function init ()
    {
        parent::init();
        if (!$this->loggedUser->canUseActivityLog() && !$this->loggedUser->isGuest()) {
            throw new Singular_Acl_Exception($this->view->t('Access denied'));
        } elseif ($this->loggedUser->isGuest()) {
            $this->_redirect($this->view->url(array('redirect' => 'activity'), 'login'));
            return;
        }
        $this->_helper->layout()->setLayout("profile");
        $this->activeUser = $this->view->activeUser = $this->loggedUser;
    }

    /**
     * Index action
     *
     * @return void
     */
    public function indexAction()
    {
        $logsDb = Singular_Loader::get('System_Model_DbTable_Logs');
        $page  = $this->_getParam("page");
        $date  = $this->view->date = $this->_getParam('date');
        $where = array('date' => $date);
        $this->view->paginator = $logsDb->getPaginator($where, $page);

        if ($this->isAjax()) {
            $this->autoresponder->setOutput(
                $this->fetchTemplate('system_activity_index.phtml')
            );
        }
    }
}
