<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Controller
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Admin controller
 *
 * @uses       System_Controller_Abstract_Admin
 * @category   System
 * @package    System_Controller
 */
class AdminController extends System_Controller_Abstract_Admin
{
    /**
     * Index action
     *
     * @return void
     */
    public function indexAction ()
    {
        $this->view->license          = Singular_Runtime::extract('license');

        $this->view->info = array(
            'version'       => Singular_Version::VERSION,
            'codename'      => Singular_Version::CODENAME,
            'zf_version'    => Zend_Version::VERSION,
            'ur_version'    => Singular_Module::getInstance()->getModule('system')->getContainer()->getVersion(),
            'php_version'   => 'PHP ' . phpversion(),
            'mysql_version' => 'MySQL ' . Zend_Db_Table::getDefaultAdapter()->getServerVersion()
        );

        $this->view->logs = Singular_Loader::get('System_Model_DbTable_Logs')->findLastActivity();
    }
    
    /**
     * Clean cache action
     *
     * @return void
     */
    public function cleanCacheAction()
    {
        Singular_Core::_('Cache')->cleanAll();
        System_Service_Files::removeDir(CACHE_PATH, false);
        
        $this->view->notify()->success('Cache is successfully cleaned!');
        $this->_helper->redirector->gotoRouteAndExit(array(), 'admin');
    }
}
