<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Controller
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Admin-languages controller
 *
 * @uses       System_Controller_Abstract_Admin
 * @category   System
 * @package    System_Controller
 */
class AdminResponsesController extends System_Controller_Abstract_Admin
{
    /**
     * Index action
     *
     * @return void
     */
    public function indexAction ()
    {
        $form = new System_Form_ResponsesSettings($this->settings->system->responses);
        if ($this->getRequest()->isPost()) {
            $post = $this->getRequest()->getPost();
            if ($form->isValid($post)) {
                $data = $form->getValues();
                foreach ($data as $key => $value) {

                    if ('response_types_order' == $key && is_array($value)) {
                        /** @var $responseTypesModel System_Model_DbTable_ResponsesTypes */
                        $responseTypesModel = Singular_Loader::get('System_Model_DbTable_ResponsesTypes');

                        foreach ($value as $order => $type) {
                            $typeRow = $responseTypesModel->findBySlug($type);
                            $order   = $order + 1;
                            if ($typeRow instanceof System_Model_ResponseType) {
                                $typeRow->is_default = (1 == $order) ? 1 : 0;
                                $typeRow->order      = $order;
                                $typeRow->save();
                            }
                        }
                    }

                    if ($value != '') {
                        Singular_Core::_('Settings')->changeSetting($key, $value);
                    }
                }
                $cacheTags = array('responses', 'comments');
                $cache = Singular_Runtime::extract('cachemanager')->getCache('default');
                Singular_Core::_('Cache')->cleanAll();
                //$cache->clean(Zend_Cache::CLEANING_MODE_MATCHING_ANY_TAG, $cacheTags);
                if (class_exists('Supercache', false)) {
                    SuperCache::getInstance()->getCache()->clean(Zend_Cache::CLEANING_MODE_ALL);
                }
                $this->view->notify()->success('Responses settings are changed!');
                $this->_helper->redirector->gotoRoute(array(), 'admin_responses');
            }
        }
        $this->view->form = $form;
    }
}
