<?php
/**
 * Singular
 *
 * LICENSE
 *
 * The SOFTWARE PRODUCT is protected by copyright treaties,
 * as well as other intellectual property laws and treaties.
 * The SOFTWARE PRODUCT is licensed, not sold.
 * Software.
 * You may install and use one copy of the SOFTWARE PRODUCT
 * for each license purchased or if a site license then you
 * may install any number of copies at the site where the
 * site license is defined.
 * Your rights to use the SOFTWARE PRODUCT are not transferable.
 *
 * @category   System
 * @package    System_Controller
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */

/**
 * Error controller
 *
 * @uses       Singular_Core_System_Controller_Error
 * @category   System
 * @package    System_Controller
 * @copyright  Copyright (c) 2009 Zenonis. (http://www.zenonis.com)
 */
class ErrorController extends Singular_Core_System_Controller_Error
{
    public function init ()
    {
        parent::init();
        $this->view->settings = Singular_Core::_('settings')->getSettings();
    }

    /**
     * Error action
     *
     * Processes error requests for showing error messages
     *
     * @return void
     */
    public function errorAction ()
    {
        $this->view->errorHandler = $this->_getParam('error_handler', null);

        if (null === $this->view->errorHandler && !Zend_Session::namespaceIsset('error')) {
            /** @var $redirector Zend_Controller_Action_Helper_Redirector */
            //$redirector = Zend_Controller_Action_HelperBroker::getStaticHelper('Redirector');
            //$redirector->gotoUrl($this->view->baseUrl());
        }

        Singular_View_Helper_HeadScript::disableCombine(true);
        Singular_View_Helper_HeadLink::disableCombine(true);

        $this->_helper->layout->setLayout('error');
        $this->renderScript('view_error.phtml');
    }
}
