<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Controller
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Index controller
 *
 * @uses       System_Controller_Abstract_Action
 * @category   System
 * @package    System_Controller
 */
class IndexController extends System_Controller_Abstract_Action
{
    /**
     * Index action
     *
     * @return void
     */
    public function indexAction ()
    {
        $this->view->form = new System_Form_SearchAdd();
        $data = new stdClass(); $data->sections = array();
        Singular_Event::dispatch('onMainPage', $data);
        ksort($data->sections);
        $this->view->sections = $data->sections;
    }
    
    /**
     * Use Mobile Interface action
     *
     * @return void
     */
    public function useMobileInterfaceAction()
    {
        Singular_Core::_('Theme')->overrideDefault('mobile');
        $this->_forward('index');
        $redirect = $this->_getParam('redirect');
        if (!empty($redirect)) {
            $this->_helper->redirector->gotoUrl($redirect);
        } else {
            $this->_helper->redirector->gotoUrl($this->getFrontController()->getBaseUrl());
        }
    }

    /**
     * Tag action
     *
     * Displays tag-sorted responses
     *
     * @return void
     */
    public function tagAction()
    {
        $tag  = $this->_request->getParam('tag');
        $page = $this->_request->getParam('page', 1);

        list($items,$pages) = $this->responses->findByTag($tag, $page);

        $this->view->items = $items;
        $this->view->pages = $pages;
    }
}
