<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Filter
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * System_Filter_ResponseTypes
 *
 * @uses       Zend_Filter_Interface
 * @category   System
 * @package    System_Filter
 */
class System_Filter_ResponseTypes implements Zend_Filter_Interface
{
    /**
     * Defined by Zend_Filter_Interface
     *
     * @param  string $types
     * @see    parent::filter()
     *
     * @return array
     */
    public function filter($types)
    {
        if (is_array($types)) {
            $filtered = array();
            foreach ($this->_getResponseTypes() as $type) {
                if (isset($types[$type->slug])) {
                    $filtered[$type->slug] = $types[$type->slug];
                }
            }
            return $filtered;
        }
        return $types;
    }

    /**
     * Returns responses types
     *
     * @return System_Model_Rowset
     */
    protected function _getResponseTypes()
    {
        $types = Singular_Runtime::extract('types');
        if (!$types instanceof System_Model_Rowset || !count($types)) {
            $types = Singular_Loader::get('System_Model_DbTable_ResponsesTypes')->findActive();
        }
        return $types;
    }
}
