<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * AdminUser form
 *
 * @uses       System_Form_User
 * @category   System
 * @package    System_Form
 */
class System_Form_AdminUser extends System_Form_User
{
    /**
     * Initialize form (used by extending classes)
     *
     * @see    parent::init()
     * @return void
     */
    public function init ()
    {
        parent::init();

        $rolesDb = Singular_Loader::get('System_Model_DbTable_Roles');
        if (Singular_Runtime::extract("loggedUser")->isAdmin()) {
            $roles = $rolesDb->findAll();
        } else {
            $roles = $rolesDb->findWithoutResources(System_Model_DbTable_Resources::ADMIN_ACCESS);
        }

        $countries = new System_Form_Element_Select(array(
            'name' => 'role',
            'options' => array(
                'label' => 'Role',
                'required' => true,
                'decorators' => array(
                    'ViewHelper',
                    array('ViewScript', array('viewScript' => 'forms/elements/select.phtml'))
                )
            ),
            'settings' => array(
                'model' => $roles,
                'val' => 'role',
                'opt' => 'name',
                'filter' => '/^(?!guest)/u'
            )
        ));
        $this->addElement($countries);
    }
}
