<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Answer form
 *
 * @uses       Singular_Form
 * @category   System
 * @package    System_Form
 *
 * @property Zend_Form_Element_Checkbox $notify
 * @property Zend_Form_Element_Button   $answer_delete
 */
class System_Form_AnswerEdit extends System_Form_Answer
{
    /**
     * Initialize form (used by extending classes)
     *
     * @see    parent::init()
     * @return void
     */
    public function init()
    {
        parent::init();

        $this->setAttrib('action', $this->getView()->url(array(), 'response_edit_answer'));
        $this->submit->setLabel('Update');

        $notify = new Zend_Form_Element_Checkbox('notify', array(
            'label'        => '<img title="' . $this->getView()->t('Notify Subscribers') .'" alt="' . $this->getView()->t('Notify Subscribers') . '" src="' . $this->getView()->imageSrc('icons/16/notify_disabled.jpg', null, false) . '"/>',
            'required'     => false,
            'labelClass'   => 'floatRight',
            'allowEmpty'   => true,
            'order'        => 1,
            'filters'      => array('StringTrim'),
            'decorators'   => array(
                array('ViewHelper'),
                array('ViewScript', array('viewScript' => 'forms/elements/checkbox.phtml'))
            ),
        ));

        $delete = new Zend_Form_Element_Button('answer_delete', array(
            'ignore'   => true,
            'label'    => 'Delete',
            'attribs'  => array(
                'class' => 'button-type1 margLeft10'
            ),
            'order'    => 4,
            'decorators' => array(
                array('ViewHelper'),
                array('ViewScript', array('viewScript' => 'forms/elements/button.phtml'))
            ),
        ));
        
        if (Singular_Core::_('Theme')->getDefault() == 'mobile') {
            $notify->setAttrib('data-role', "none");
        }

        $group = $this->getDisplayGroup('default');
        $elements = array($notify, $delete);
        $elements = array_merge_recursive($elements, $group->getElements());
        $this->removeDisplayGroup('default');
        $this->addDisplayGroup($elements, 'default');

    }
}
