<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @subpackage System_Form_Decorator
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * FlashErrors form decorator
 *
 * @uses       Zend_Form_Decorator_Abstract
 * @category   System
 * @package    System_Form
 * @subpackage System_Form_Decorator
 */
class System_Form_Decorator_FlashErrors extends Zend_Form_Decorator_Abstract
{
    /**
     * Renders errors
     *
     * @param  string $content
     * @return string
     */
    public function render ($content)
    {
        $element = $this->getElement();
        $view    = $element->getView();
        if (null === $view) {
            return '';
        }

        $errors = $element->getMessages();
        if (empty($errors)) {
            return '';
        }
        $errorsMsg = '';
        foreach ($errors as $error) {
            if (is_array($error)) {
                $errorsMsg .= current($error) . " ";
            } else {
                $errorsMsg .= $error . " ";
            }
        }
        $view->notify()->error($errorsMsg);
        return '';
    }
}
