<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @subpackage System_Form_Element
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Content form element
 *
 * @category   System
 * @package    System_Form
 * @subpackage Element
 */
class System_Form_Element_Content extends Zend_Form_Element_Textarea
{
    /**
     * Initialize object
     *
     * @return void
     */
    public function init()
    {
        $this->setDecorators(array(
            array('ViewHelper'),
            array('ViewScript', array(
                'viewScript' => 'forms/elements/content.phtml'
            ))
        ));

        $translate = Singular_Runtime::extract('Zend_Translate');
        $this->allowedCodes = array(
            0 => array(
                'bold' => array(
                    'class' => 'code',
                    'title' => $translate->translate('bold')
                ),
                'italic' => array(
                    'class' => 'code',
                    'title' => $translate->translate('italic')
                ),
                'underline' => array(
                    'class' => 'code',
                    'title' => $translate->translate('underline')
                ),
                'strike' => array(
                    'class' => 'code',
                    'title' => $translate->translate('strike')
                )
            ),
            1 => array(
                'list' => array(
                    'class' => 'code',
                    'title' => $translate->translate('list')
                ),
                'nlist' => array(
                    'class' => 'code',
                    'title' => $translate->translate('nlist')
                ),
            ),
            2 => array(
                'link' => array(
                    'class' => 'code',
                    'title' => $translate->translate('link')
                ),
                'image' => array(
                    'class' => 'code',
                    'title' => $translate->translate('image')
                ),
                'video' => array(
                    'class' => 'code',
                    'title' => $translate->translate('video')
                ),
                'source' => array(
                    'class' => 'code',
                    'title' => $translate->translate('code')
                ),
            ),
            3 => array(
                'remove-formatting' => array(
                    'class' => 'code',
                    'title' => $translate->translate('remove formatting')
                ),
            )
        );
    }
}
