<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @subpackage System_Form_Element
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * MultiButton form element
 *
 * @uses       Zend_Form_Element_Select
 * @category   System
 * @package    System_Form
 * @subpackage System_Form_Element
 */
class System_Form_Element_MultiButton extends Zend_Form_Element_Select
{
    public $firstOption = null;
    
    public $lastOptions = null;
    
    /**
     * Initialize object; used by extending classes
     *
     * @return void
     */
    public function init()
    {
        parent::init();
        
        reset($this->options);
        $firstKey = key($this->options);
        $firstOption = array($firstKey  => array_shift($this->options));
        $this->firstOption = $firstOption;
        
        end($this->options);
        $lastKey = key($this->options);
        reset($this->options);
        $this->lastOption = array ($lastKey => array_pop($this->options));
    } 
}
