<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @subpackage System_Form_Element
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Time form element
 *
 * @uses       Zend_Form_Element
 * @category   System
 * @package    System_Form
 * @subpackage System_Form_Element
 */
class System_Form_Element_Time extends Zend_Form_Element
{
    /**
     * Set element value
     *
     * @param  mixed $value
     * @return Zend_Form_Element
     */
    public function setValue($value)
    {
        if (is_array($value)) {
            $value = sprintf('%s:%s %s', $value['hour'], $value['minutes'], $value['meridiem']);
        }
        return parent::setValue($value);
    }
    
    /**
     * Retrieve filtered element value
     *
     * @return array
     */
    public function getArrayValue()
    {
        $value = parent::getValue();
        if (strpos($value, ':')) {
            list($hours, $minutesMeridiem) = explode(':', $value);
            if (strpos($minutesMeridiem, ' ')) {
                list($minutes, $meridiem) = explode(" ", $minutesMeridiem);
            } else {
                $minutes = $minutesMeridiem;
                $meridiem = 'am';
            }
        } else {
            $hours = '12';
            $minutes = '00';
            $meridiem = 'am';
        }
        return array($hours, $minutes, $meridiem);
    }
}
