<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Email form
 *
 * @uses       Singular_Form
 * @category   System
 * @package    System_Form
 */
class System_Form_Email extends Singular_Form
{
    /**
     * Initialize form (used by extending classes)
     *
     * @see    parent::init()
     * @return void
     */
    public function init ()
    {
        parent::init();
        
        $this->setDecorators(array(
            new System_Form_Decorator_FlashErrors(),
            new Zend_Form_Decorator_ViewScript(array(
                    'viewScript' => 'forms/auth.phtml'
                )),
            'Form'
        ));

        $table = Singular_Loader::get('System_Model_DbTable_Users')->getTableName();
        $this->addElement('text', 'email', array(
            'label'      => 'Email',
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                array('validator' => 'EmailAddress', 'options' => array(
                    'messages' => array(
                        Zend_Validate_EmailAddress::INVALID => 'Email is required!',
                        Zend_Validate_EmailAddress::INVALID_FORMAT => 'Email is incorrect!',
                        Zend_Validate_EmailAddress::INVALID_LOCAL_PART => 'Email is incorrect!',
                        Zend_Validate_EmailAddress::INVALID_HOSTNAME => 'Email is incorrect!',
                        Zend_Validate_EmailAddress::INVALID_SEGMENT => 'Email is incorrect!',
                        Zend_Validate_EmailAddress::INVALID_MX_RECORD => 'Email is incorrect!'
                    )
                )),
                new Zend_Validate_Db_NoRecordExists(array(
                    'table' => $table,
                    'field' => 'email'
                ))
            ),
            'decorators' => array(
                'ViewHelper'
            )
        ));

        $this->addElement('submit', 'submit', array(
            'label'      => 'Recover',
            'ignore'     => true,
            'Attribs'    => array(
                'class'  => 'button-type1'
            )
        ));
    }
}
