<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * External scripts form
 *
 * @uses       Singular_Form
 * @category   System
 * @package    System_Form
 */
class System_Form_ExternalScripts extends System_Form_Settings
{
    /**
     * Initialize form (used by extending classes)
     *
     * @see    parent::init()
     * @return void
     */
    public function init ()
    {
        parent::init();
        $this->_translateDescriptions();
        $formElements = $this->getElements();
        foreach ($formElements as $element) {
            $element->setAllowEmpty(true);
        }
    }
    
    /**
     * Translate options description
     * 
     * @return void 
     */
    protected function _translateDescriptions ()
    {
        foreach ($this->settings as $key=>$setting) {
            $this->settings[$key]['description'] = $this->getView()->t($setting['description']);
        }
    }
    
}
