<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * FtpAccess form
 *
 * @uses       Singular_Form
 * @category   System
 * @package    System_Form
 */
class System_Form_FtpAccess extends System_Form_Settings
{
    /**
     * Initialize form (used by extending classes)
     *
     * @see    parent::init()
     * @return void
     */
    public function init()
    {
        parent::init();
        
        $this->setDecorators(array(
            new System_Form_Decorator_FlashErrors(),
            new Zend_Form_Decorator_ViewScript(array(
                    'viewScript' => 'forms/ftp-access.phtml'
                )),
            'Form'
        ));
        
        $element = $this->getElement('submit');
        if ($element instanceof Zend_Form_Element_Submit) {
            $class = $element->getAttrib("class") . " inline";
            $element->setAttrib("class", $class);
        }
        
        $element = $this->getElement('ftp_folder');
        if ($element instanceof Zend_Form_Element_Text) {
            $value = $element->getValue();
            if (empty($value)) {
                $value = ROOT_PATH;
                $element->setValue($value);
            }
        }        
        
        $this->addElement('button', 'test-connect', array(
            'ignore'   => true,
            'label'    => 'Test Connection',
            'attribs'  => array(
                'class'  => 'button-type1 inline'
            ),
            'decorators' => array(
                array('ViewScript', array('viewScript' => '/forms/elements/button.phtml')),
                'ViewHelper'
            )
        ));
    }
}
