<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * PasswordForgot form
 *
 * @uses       System_Form_Email
 * @category   System
 * @package    System_Form
 */
class System_Form_PasswordForgot extends System_Form_Email
{
    /**
     * Initialize form (used by extending classes)
     *
     * @see    parent::init()
     * @return void
     */
    public function init ()
    {
        parent::init();

        $this->setAction($this->getView()->url(array(), 'forgot_password'));

        $this->email->removeValidator('Zend_Validate_Db_NoRecordExists');
        $this->email->setAttrib('id', 'forgot-email');
        $validator = new Zend_Validate_Db_RecordExists(array(
            'table' => Singular_Loader::get('System_Model_DbTable_Users')->getTableName(),
            'field' => 'email'
        ));
        $this->email->addValidator($validator);
        $this->email->getValidator("Db_RecordExists")->setMessages(array(
            Zend_Validate_Db_RecordExists::ERROR_NO_RECORD_FOUND => 'There is no such user in community!',
        ));
        $this->email->setDescription($this->getView()->t('Enter your email (login) to get instructions to recover your password'));
        
        $this->submit->setAttrib("id", "forgot-submit");
    }
}
