<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Search form
 *
 * @uses       Singular_Form
 * @category   System
 * @package    System_Form
 */
class System_Form_Search extends Singular_Form
{
    /**
     * Initialize form (used by extending classes)
     *
     * @see    parent::init()
     * @return void
     */
    public function init()
    {
        parent::init();

        $this->setDecorators(array(
            new System_Form_Decorator_FlashErrors(),
            array('ViewScript', array('viewScript' => 'forms/system.phtml')),
            'Form',
        ));

        $this->setMethod(self::METHOD_GET);
        $this->setAction($this->getView()->url(array(), "search"));
        $this->setAttrib("id", "search-form");

        $text = new Zend_Form_Element_Text('text', array(
            'id'         => 'search',
            'value'      => $this->getView()->t('Search'),
            'order'      => 2,
            'filters'    => array(
                'StringTrim',
                'StripTags'
            ),
            'decorators' => array(
                array('ViewHelper'),
                array('ViewScript', array(
                    'viewScript' => 'forms/elements/search.phtml'
                ))
            )
        ));
        $this->addElement($text);
    }
}
