<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * SearchAdd form
 *
 * @uses       Singular_Form
 * @category   System
 * @package    System_Form
 */
class System_Form_SearchAdd extends Singular_Form
{
    /**
     * Initialize form (used by extending classes)
     *
     * @see    parent::init()
     * @return void
     */
    public function init ()
    {
        parent::init();

        $this->setDecorators(array(
            new System_Form_Decorator_FlashErrors(),
            array('ViewScript', array('viewScript' => 'forms/system.phtml')),
            'Form',
        ));

        $this->setMethod(self::METHOD_GET);
        $defaultType = Singular_Runtime::extract("defaultType");
        if ($defaultType instanceof System_Model_ResponseType) {
            $this->setAction($this->getView()->url(array("type" => $defaultType->slug), "response_add"));
        } else {
            $this->setAction($this->getView()->url(array(), "response_add"));
        }
        $this->setAttrib("id", "response-add");

        $title = new Zend_Form_Element_Radio('type', array(
            'decorators' => array(
                array('ViewHelper'),
                array('ViewScript', array('viewScript' => 'forms/elements/radio-search-add.phtml'))
            )
        ));
        $this->addElement($title);

        $title = new Zend_Form_Element_Text('text', array(
            'div_class'    => 'findAddObjects-input',
            'withoutLabel' => true,
            'decorators'   => array(
                array('ViewHelper'),
                array('ViewScript', array(
                    'viewScript' => 'forms/elements/text-input.phtml'
                ))
            ),
        ));
        $this->addElement($title);

        $submit = new Zend_Form_Element_Submit('submit', array(
            'ignore'      => true,
            'label'       => 'Continue',
            'attribs'     => array(
                'class' => 'floatRight button-type1'
            ),
            'decorators' => array(array('ViewHelper'), array('ViewScript', array('viewScript' => 'forms/elements/button.phtml'))),
        ));
        $this->addElement($submit);
    }
}
