<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Status form
 *
 * @uses       Singular_Form
 * @category   System
 * @package    System_Form
 */
class System_Form_Status extends Singular_Form
{
    /**
     * Initialize form (used by extending classes)
     *
     * @see    parent::init()
     * @return void
     */
    public function init()
    {
        parent::init();

        $this->addElement('checkbox', 'allow_comments', array(
            'label'        => 'allow_comments:',
            'required'     => true,
            'filters'      => array('StringTrim'),
            'validators'   => array(),
            'checkedValue' => 1
        ));

        $this->addElement('checkbox', 'allow_votes', array(
            'label'        => 'allow_votes:',
            'required'     => true,
            'filters'      => array('StringTrim'),
            'validators'   => array(),
            'checkedValue' => 1
        ));

        $this->addElement('submit', 'submit', array(
            'label'      => 'submit:',
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array()
        ));

    }
}
