<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Form
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * WidgetFeedback form
 *
 * @uses       System_Form_Settings
 * @category   System
 * @package    System_Form
 */
class System_Form_WidgetFeedback extends System_Form_Settings
{
    /**
     * Initialize form (used by extending classes)
     *
     * @see    parent::init()
     * @return void
     */
    public function init()
    {
        parent::init();

        $this->setDecorators(array(
            new System_Form_Decorator_FlashErrors(),
            array('ViewScript', array('viewScript' => 'forms/widget-feedback.phtml')),
            'Form',
        ));

        $operation = new Zend_Form_Element_Hidden('widget_name', array(
            'decorators' => array(
                'ViewHelper'
            ),
            'value' => 'feedback'
        ));

        $this->addElement($operation);

        $element = $this->getElement('widget_side');
        if ($element instanceof Zend_Form_Element_Radio) {
            $element->setMultiOptions(array(
                'left'  => 'Left',
                'right' => 'Right'
            ));
        }
        
        $element = $this->getElement('widget_design');
        if ($element instanceof Zend_Form_Element_Radio) {
            $element->setMultiOptions(array(
                'simple'   => 'Simple',
                'advanced' => 'Advanced'
            ));
        }

        $element = $this->getElement('widget_default_tab');
        if ($element instanceof Zend_Form_Element_Select) {
            $options['all_responses'] = 'All Responses';
            $element->setMultiOptions($options);
        }

        $element = $this->getElement('widget_open');
        if ($element instanceof Zend_Form_Element_Radio) {
            $element->setMultiOptions(array(
                'widget'     => 'Widget',
                'community'  => 'Community',
            ));
        }

        $this->getElement('submit')->setAttrib('id', 'submit-feedback');
    }
}
