<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_View
 * @subpackage System_View_Helper
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * LeftBlock view helper
 *
 * @uses       Zend_View_Helper_Abstract
 * @category   System
 * @package    System_View
 * @subpackage System_View_Helper
 */
class System_View_Helper_LeftBlock extends Zend_View_Helper_Abstract
{
    /**
     * Renders left block
     *
     * @param  Zend_Db_Table_Row|array $user
     * @param  string|null $class
     * @return string
     */
    public function leftBlock()
    {
        $cache = Singular_Runtime::extract('cachemanager')->getCache('default');
        $loggedUser = Singular_Runtime::extract('loggedUser');
        $cacheId = "leftBlock_" . $loggedUser->role;
        $cacheId = preg_replace("/[^a-zA-Z0-9_]/", "", $cacheId);
        if ( ($output = $cache->load($cacheId)) === false ) {
            $output = $this->view->render('_left-block.phtml');
            $cache->save($output, $cacheId, array('types', 'left_block'));
        }
        return $output;
    }
}
