<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_View
 * @subpackage System_View_Helper
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Photo view helper
 *
 * @uses       Zend_View_Helper_Abstract
 * @category   System
 * @package    System_View
 * @subpackage System_View_Helper
 */
class System_View_Helper_PureText extends Zend_View_Helper_Abstract
{
    /**
     * Cleans up and filter input data to pure text
     *
     * @param  $string
     * @return string
     */
    public function pureText($text, $stripHigh = true)
    {
        if (!is_string($text) && !is_int($text)
            && !is_numeric($text) && !is_float($text)
        ) {
            throw new Singular_Exception(
                'Invalid argument: $text must be an string or has numeric value'
            );
        }

        if ($stripHigh) {
            $text = filter_var($text, FILTER_SANITIZE_STRING, FILTER_FLAG_STRIP_HIGH);
        } else {
            $text = filter_var($text, FILTER_SANITIZE_STRING);
        }

        $text = trim(preg_replace('!&nbsp;+!', ' ', $text));

        return $text;
    }
}