<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_View
 * @subpackage System_View_Helper
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * ResponseRow view helper
 *
 * @uses       Zend_View_Helper_Abstract
 * @category   System
 * @package    System_View
 * @subpackage System_View_Helper
 */
class System_View_Helper_ResponseRow extends Zend_View_Helper_Abstract
{
    /**
     * Displays response attributes
     *
     * @param  System_Model_Response $response
     * @return string
     */
    public function responseRow ($response)
    {        
        $params = new stdClass();
        $params->row = new DOMDocument();
        $params->response = $response;
        Singular_Event::dispatch('responseRow', $params);
        $result = '';
        // Bug with closing non-paired tags
        foreach ($params->row->childNodes as $node) {
            $result .= $params->row->saveXML($node) . "\n";
        }
        return $result;
    }
}
