<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_View
 * @subpackage System_View_Helper
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Response Type title view helper
 *
 * @uses       Zend_View_Helper_Abstract
 * @category   System
 * @package    System_View
 * @subpackage System_View_Helper
 */
class System_View_Helper_ResponseTypeTitle extends Zend_View_Helper_Abstract
{
    /**
     * Returns sanitized Response Type title
     *
     * @param  System_Model_ResponseType|string $title
     * @return string
     */
    public function responseTypeTitle ($title)
    {
        if ($title instanceof System_Model_ResponseType) {
            $title = $title->objects;
        }

        return $this->view->t(ucwords(preg_replace('/-|_/', ' ', $title)));
    }
}