<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_View
 * @subpackage System_View_Helper
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * YesNo view helper
 *
 * @uses       Zend_View_Helper_Abstract
 * @category   System
 * @package    System_View
 * @subpackage System_View_Helper
 */
class System_View_Helper_YesNo extends Zend_View_Helper_Abstract
{
    const YES = 'yes';
    const NO  = 'no';
    /**
     * Renders yes or no string
     *
     * @param  string|int|bool $value
     * @param  bool            $capitalize
     *
     * @return string
     */
    public function yesNo($value, $capitalize = true)
    {
        $value  = (bool) $value;
        $result = self::YES;
        if (!$value) {
            $result = self::NO;
        }
        $result = $this->view->t($result);
        if ($capitalize) {
            $result = mb_ucfirst($result);
        }

        return $result;
    }
}
