<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Lib
 * @copyright  USWebStyle Inc., 2011-2013 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Response report class
 * 
 * Generates a report for each response type.
 *
 * @uses       System_Lib_Analytics_Model_Report_Abstract
 * @category   System
 * @package    System_Lib
 * @subpackage System_Lib_Analytics
 */
class System_Lib_Analytics_Model_Report_Time_ResponseTypes extends System_Lib_Analytics_Model_Report_Time_Abstract
{
    /**
     * Return report
     * 
     * @return array
     */
    public function getReport() 
    {
        $report = array();
        foreach ($this->_getQueries() as $key =>$query) {
            $report[$key] = $this->_getQuantity($query);
        }
        return $report;
    }
    
    /**
     * Return db queries
     * 
     * @return array
     */
    protected function _getQueries()
    {
        $queries = array(); 
        $model = Singular_Loader::get('System_Model_DbTable_ResponsesTypes');
        if ($this->counter == 'countByType')
        {
            foreach ($model->findActive() as $responseType) {
                $queries[$responseType->slug] = array($this->_getRangeQueryPart($this->getDateFrom(), $this->getDateTo()),$responseType->slug) ;
            }
        }
        
        return $queries;
    }       
          
}
