<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Lib
 * @copyright  USWebStyle Inc., 2011-2013 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Analytics time report class
 * 
 * Generates a report for a given period of time for each day of week.
 *
 * @uses       System_Lib_Analytics_Model_Report_Abstract
 * @category   System
 * @package    System_Lib
 * @subpackage System_Lib_Analytics
 */

class System_Lib_Analytics_Model_Report_Time_WeekDays extends System_Lib_Analytics_Model_Report_Time_Abstract
{
    /**
     * 
     * @return array
     */
    public function getReport() 
    {
        $report = array();
        foreach ($this->_getQueries() as $query) {
            $report[] = $this->_getQuantity(array($query));
        }
        return $report;
    }
    
    /**
     * Return db queries 
     * 
     * @return array
     */
    protected function _getQueries()
    {
        $queries = array();
        $i = '0';
        while($i < '7')
        {
            $queries[] = 'DAYOFWEEK('.$this->actionType.') = '.$i.' AND '.$this->_getRangeQueryPart($this->getDateFrom(), $this->getDateTo());
            $i++;
        }    
        return $queries;
    } 
}
