<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2013. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_View
 * @subpackage System_View_Helper
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * class System_Lib_Analitics_View_Table_Row 
 *
 * @category   System
 * @package    System_Lib
 * @subpackage System_Lib_Analytics
 */
class System_Lib_Analytics_View_Table_Row_Total extends System_Lib_Analytics_View_Table_Row_Abstract  
{
    
    /**
     * Return data for render template
     * 
     * @return array
     */
    protected function _getTemplateData()
    {
        $filter = new System_Filter_ZeroToDash();
        return array(
            'id'        => $this->id,
            'title'     => $this->title,
            'today'     => '',
            'yesterday' => '',
            'thisWeek'  => '',
            'lastWeek'  => '',
            'thisMonth' => '',
            'lastMonth' => '',
            'total'     => $filter->filter( $this->_getQuantity($this->_getTotal()) ),
        );
    }
    
    /**
     *
     * Return "Total" query for counter.
     *
     * @return string
     */
    protected function _getTotal ()
    {
        return '';
    }
}