<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Lib
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * System_Lib_Form_Element_File
 *
 * @category   System
 * @package    System_Lib
 * @subpackage System_Lib_Form
 * @copyright  Copyright (c) 2005-2011 Zend Technologies USA Inc. (http://www.zend.com)
 * @license    http://framework.zend.com/license/new-bsd     New BSD License
 * @version    $Id: File.php 23871 2011-04-23 22:40:16Z ramon $
 */
class System_Lib_Form_Element_FileImage extends System_Lib_Form_Element_File
{
    /**
     * Image Url
     *
     * @var null|string
     */
    private $_imageUrl;

    /**
     * Image delete Url
     *
     * @var string
     */
    private $_imageDeleteUrl;

    /**
     * Sets Image Url path
     *
     * @param string $path
     *
     * @return System_Lib_Form_Element_FileImage
     */
    public function setImageUrl ($path)
    {
        if (false === strpos($path, 'http')) {
            $path = Zend_Layout::getMvcInstance()->getView()->baseUrl($path);
        }
        $this->_imageUrl = $path;

        return $this;
    }

    /**
     * Returns Image Url path
     *
     * @return null|string
     */
    public function getImageUrl ()
    {
        return $this->_imageUrl;
    }

    /**
     * Returns true if Image Url is set
     *
     * @return bool
     */
    public function hasImageUrl ()
    {
        return !empty($this->_imageUrl);
    }

    /**
     * Sets Url for image delete link
     *
     * @param string $path
     *
     * @return System_Lib_Form_Element_FileImage
     */
    public function setImageDeleteUrl ($path)
    {
        if (false === strpos($path, 'http')) {
            $path = Zend_Layout::getMvcInstance()->getView()->baseUrl($path);
        }
        $this->_imageDeleteUrl = $path;

        return $this;
    }

    /**
     * Returns Image Url path
     *
     * @return null|string
     */
    public function getImageDeleteUrl ()
    {
        return !empty($this->_imageDeleteUrl) ? $this->_imageDeleteUrl : '#';
    }
}