<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Lib
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * System_Lib_Markup_Renderer_Html
 *
 * @category   System
 * @package    System_Lib
 * @subpackage System_Lib_Markup_Renderer
 */
class System_Lib_Markup_Renderer_Html extends Zend_Markup_Renderer_Html
{
    /**
     * Constructor
     *
     * @param array|Zend_Config $options
     *
     * @return void
     */
    public function __construct($options = array())
    {
        $options['useDefaultMarkups'] = false;
        $options['useDefaultFilters'] = true;
        $options['parser'] = new Zend_Markup_Parser_Bbcode();
        
        parent::__construct($options);
        
        $this->addMarkup('b', 10, array(
            'tag'    => 'span',
            'attributes'  => array(
                'style' => 'font-weight: bold;',
            ),
            'group'  => 'inline',
            'filter' => true,
        ));
        $this->addMarkup('u', 10, array(
            'tag'    => 'span',
            'attributes'  => array(
                'style' => 'text-decoration: underline;',
            ),
            'group'  => 'inline',
            'filter' => true,
        ));
        $this->addMarkup('h4', 10, array(
            'tag'    => 'h4',
            'attributes' => array(
                'style' => 'background-color:#aaaaaa; color:#ffffff; margin:-10px -18px 10px; padding: 3px 6px;',
            ),
            'group'  => 'inline',
            'filter' => true
        ));
        $this->addMarkup('s', 10, array(
            'tag'    => 'span',
            'attributes'  => array(
                'style' => 'text-decoration: line-through;',
            ),
            'group'  => 'inline',
            'filter' => true,
        ));
        $this->addMarkup('i', 10, array(
            'tag'    => 'span',
            'attributes'  => array(
                'style' => 'font-style: italic;',
            ),
            'group'  => 'inline',
            'filter' => true,
        ));

        $this->addMarkup('ul', 10, array(
            'tag'    => 'ul',
            'group'  => 'inline',
            'filter' => true,
        ));
        $this->addMarkup('ol', 10, array(
            'tag'    => 'ol',
            'group'  => 'inline',
            'filter' => true,
        ));
        $this->addMarkup('li', 10, array(
            'tag'    => 'li',
            'group'  => 'inline',
            'filter' => true,
        ));
        $this->addMarkup('img', 6, array(
            'tag'    => 'img',
            'group'  => 'inline-empty',
            'attributes'  => array(
                'style' => 'width: 100%;',
            ),
            'filter' => true,
        ));
        $this->addMarkup(
            'url',
            Zend_Markup_Renderer_RendererAbstract::TYPE_CALLBACK,
            array(
                'callback' => new System_Lib_Markup_Renderer_Html_Urli(),
                'group'    => 'inline'
            )
        );
        $this->addMarkup(
            'co',
            Zend_Markup_Renderer_RendererAbstract::TYPE_CALLBACK,
            array(
                'callback' => new System_Lib_Markup_Renderer_Html_Source(),
                'group'    => 'inline',
            )
        );
        $this->addMarkup(
            'reply',
            Zend_Markup_Renderer_RendererAbstract::TYPE_REPLACE,
            array(
                'start' => '<div class="comment-reply-block" style="background: none repeat scroll 0 0 #f7f7f7;
    border: 1px solid #E8EAEB;
    margin-bottom: 10px;
    padding: 10px 18px 5px;
    color: #555555;">',
                'end'   => '</div>',
                'group' => 'inline'
            )
        );
        $this->addMarkup(
            'p',
            Zend_Markup_Renderer_RendererAbstract::TYPE_REPLACE,
            array(
                'start' => '',
                'end'   => '',
                'group' => 'inline'
            )
        );
        $this->addMarkup(
            'video',
            Zend_Markup_Renderer_RendererAbstract::TYPE_CALLBACK,
            array(
                 'callback' => new System_Lib_Markup_Renderer_Html_Video(),
                 'group'    => 'inline'
            )
        );
        
        Singular_Event::dispatch('initBbcode', $this);
    }
}
