<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Lib
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * System_Lib_Markup_Renderer_Html_Source
 *
 * @category   System
 * @package    System_Lib
 * @subpackage Renderer_Html
 */
class System_Lib_Markup_Renderer_Html_Video extends Zend_Markup_Renderer_Html_HtmlAbstract
{

    /**
     * Convert the token
     *
     * @param Zend_Markup_Token $token
     * @param string            $text
     *
     * @return string
     */
    public function convert(Zend_Markup_Token $token, $text)
    {
        $video = $this->_parseVideoLink($text);
        $fullyQualifiedUrl = null;

        if (isset($video['provider'])) {
            switch ($video['provider']) {
                case 'youtube':
                    $fullyQualifiedUrl = 'http://www.youtube.com/embed/' . $video['id'] . '?feature=player_detailpage';
                    break;
                case 'vimeo':
                    $fullyQualifiedUrl = 'http://player.vimeo.com/video/' . $video['id'] . '?title=0&amp;byline=0&amp;portrait=0&amp;badge=0&amp;color=e3d06f';
            }
        }

        return '<iframe width="100%" height="360" src="' . $fullyQualifiedUrl . '" original="' . $text . '" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowfullscreen></iframe>';
    }

    private function _parseVideoLink ($link)
    {
        $link .= '/';
        preg_match(
            '/^(http|https):\/\/(?:.*?)\.?(youtube|vimeo)\.com\/(watch\?[^#]*v=([a-zA-Z0-9_\-]*)|(\d+)).+$/', $link, $matches
        );
        return array(
            'provider' => $matches[2],
            'id'       => $matches[2] == 'vimeo' ? $matches[3] : $matches[4]
        );
    }
}