<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Lib
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * @uses       Zend_Validate_Abstract
 * @category   System
 * @package    System_Lib_Validate
 */
class System_Lib_Validate_Registration extends Zend_Validate_Abstract
{

    const INVALID   = 'invalidAttempt';

    /**
     * @var array
     */
    protected $_messageTemplates = array(
        self::INVALID => "Invalid registration attempt!"
    );

    /**
     * Defined by Zend_Validate_Interface
     *
     * Returns true if and only if the string length of $value is at least the min option and
     * no greater than the max option (when the max option is not null).
     *
     * @param  string $value
     * @return boolean
     */
    public function isValid($value)
    {
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $post = $request->getPost();

        if (!isset($post['full_name']) || !isset($post['email']) || !isset($post['assign'])) {
            $this->_error(self::INVALID);
            return false;
        }
        $hashData = md5($post['full_name'] . $post['email']);

        if ($hashData != $post['assign']) {
            $this->_error(self::INVALID);
        }

        if (count($this->_messages)) {
            return false;
        } else {
            return true;
        }
    }
}
