<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Model
 * @subpackage System_Model_DbTable
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * languages table model
 *
 * @uses       Singular_Core_System_Model_DbTable_Languages
 * @category   System
 * @package    System_Model
 * @subpackage System_Model_DbTable
 */
class System_Model_DbTable_Languages extends Singular_Core_System_Model_DbTable_Languages
{
    /**
     * Row class
     *
     * @var string
     */
    protected $_rowClass = 'System_Model_Language';

    /**
     * Rowset class
     *
     * @var string
     */
    protected $_rowsetClass = 'System_Model_Rowset';

    /**
     * Returns language by given code
     *
     * @param  string $code
     * @return null|Zend_Db_Table_Row_Abstract
     */
    public function findByCode ($code)
    {
        $where = $this->getAdapter()->quoteInto('code=?', $code);
        return $this->fetchRow($where);
    }
}
