<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   VotesPlus
 * @package    VotesPlus_Model
 * @subpackage VotesPlus_Model_DbTable
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * @category   System
 * @package    System_Model
 * @subpackage System_Model_DbTable
 */
class System_Model_DbTable_ResponsesVotes extends System_Model_DbTable_Responses
{
    /**
     * Row class
     *
     * @var string
     */
    protected $_rowClass = 'System_Model_ResponseVotes';
    
    /**
     * Returns response row by id
     *
     * @param  int $id
     * @return System_Model_ResponseVotes|null
     */
    public function findById ($id)
    {        
        $select = $this->select();
        $select->where('id = ?', $id);
        $response = $this->fetchRow($select);
        if ($response instanceof System_Model_ResponseVotes) {
            $loggedUser = Singular_Runtime::extract('loggedUser');
            if ($loggedUser->canSeeResponse($response)) {
                return $response;
            } else {
                return false;
            }
        }
        return null;
    }
}
