<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Model
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * response_types row class
 *
 * @uses       System_Model_Row
 * @category   System
 * @package    System_Model
 */
class System_Model_ResponseType extends System_Model_Row
{
    /**
     * Name of the class of the Zend_Db_Table_Abstract object.
     *
     * @var string
     */
    protected $_tableClass = 'System_Model_DbTable_ResponsesTypes';

    /**
     * Magic method __tostring
     *
     * @return string
     */
    public function  __toString()
    {
        $translate = Singular_Runtime::extract('Zend_Translate');
        return $translate->translate($this->title);
    }

    /**
     * Returns module
     *
     * @return System_Model_Module|bool(false)
     */
    public function getModule()
    {
        if (!isset($this->_properties['Module'])) {
            $result = Singular_Loader::get('System_Model_DbTable_Modules')
                        ->cache_find($this->module_id)->current();
            if($result instanceof System_Model_Module){
                $this->_properties['Module'] = $result;
            }else{
                $this->_properties['Module'] = false;
            }
        }
        return $this->_properties['Module'];
    }

    /**
     * Returns response type image
     *
     * @return string
     */
    public function getImage()
    {
        $view = Zend_Layout::getMvcInstance()->getView();
        return $view->imageSrc("icon_small.png", $this->getModule()->name);
    }

    /**
     * Cleans cache.
     *
     * @param array $additionalTags
     * @param bool  $onlyTags
     */
    public static function cleanCache($additionalTags = array(), $onlyTags = false)
    {
        $tags = array('type', 'types', 'response_type', 'response_types', Singular_Loader::get(__CLASS__)->getTable()
            ->getTableName());
        if (is_array($additionalTags) && count($additionalTags)) {
            if ($onlyTags) {
                $tags = $additionalTags;
            } else {
                $tags = $tags + $additionalTags;
            }
        }
        Singular_Core::_('cache')->removeAllByTags($tags);
    }
}
