<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   VotesPlus
 * @package    VotesPlus_Model
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * responses row class
 *
 * @category   System
 * @package    System_Model
 */
class System_Model_ResponseVotes extends System_Model_Response
{
    protected $_tableClass = 'System_Model_DbTable_ResponsesVotes';
    
    public function getPositiveVotedUsers ()
    {
        $ids = array();
        $votes = $this->getVotes();
        foreach ($votes as $vote) {
            if ($vote->value > 0) {
                $ids[] = $vote->created_by_id;
            }
        }
        return $ids ? Singular_Loader::get(
            'System_Model_DbTable_Users'
        )->findByIds(array_unique($ids)) : array();
    }

    public function getNegativeVotedUsers ()
    {
        $ids = array();
        $votes = $this->getVotes();
        foreach ($votes as $vote) {
            if ($vote->value < 0) {
                $ids[] = $vote->created_by_id;
            }
        }
        return $ids ? Singular_Loader::get(
            'System_Model_DbTable_Users'
        )->findByIds(array_unique($ids)) : array();
    }
}
