<?php
/**************************************************************
 * Copyright USWebStyle Inc., 2011-2012. All Rights Reserved.
 **************************************************************
 * NOTICE:  This source code is the property of USWebStyle, Inc.
 * In no case shall you rent, lease, lend, redistribute
 * any of below source code to a 3rd party individual or entity.
 *
 * @category   System
 * @package    System_Service
 * @copyright  USWebStyle Inc., 2011-2012 (http://www.uswebstyle.com)
 * @license    http:/www.useresponse.com/licensing (Commercial)
 */

/**
 * Auth service
 *
 * @category   System
 * @package    System_Service
 */
class System_Service_Auth
{
    /**
     * Authorize user in system by using email
     *
     * @param  string $email
     * @return bool
     */
    static public function loginByEmail($email)
    {
        $adapter = new Zend_Auth_Adapter_DbTable(
            Singular_Db_Table_Abstract::getDefaultAdapter()
        );

        $tablePrefix = Singular_Runtime::extract('config')
            ->resources->db->params->prefix;

        $adapter->setTableName($tablePrefix . 'users')
                ->setIdentityColumn('email')
                ->setCredentialColumn('email')
                ->setIdentity($email)
                ->setCredential($email)
                ->getDbSelect()->where('is_active = ?', 1);

        if (Zend_Auth::getInstance()->authenticate($adapter)->isValid()) {
            Zend_Auth::getInstance()->getStorage()->write($adapter->getResultRowObject());
            return true;
        }

        return false;
    }
    
    /**
     * Random password generator
     *
     * Generates random password for the new user
     *
     * @return string
     */
    static public function randPassword ()
    {
        $chars = "abcdefghijkmnopqrstuvwxyz023456789";
        srand(microtime()*1000000);
        $i = 0;
        $pass = '' ;
        while ($i <= 7) {
            $num = rand() % 33;
            $tmp = substr($chars, $num, 1);
            $pass = $pass . $tmp;
            $i++;
        }
        return $pass;
    }
}
