<?php
/**
 * Application config
 */
$config = array();

/* PHP directives */
$config['phpSettings'] = array();
$config['phpSettings']['display_startup_errors'] = 1;
$config['phpSettings']['display_errors']         = 1;

/* Application resources */
$config['resources'] = array();

/* FrontController */
$config['resources']['frontController'] = array();
$config['resources']['frontController']['defaultModule']    = 'system';
$config['resources']['frontController']['throwExceptions']  = false;
$config['resources']['frontController']['plugins'] = array();
$config['resources']['frontController']['plugins'][]        = 'System_Lib_Controller_Plugin_CrashReport';

/* Autoloader */
$config['resources']['autoloader'] = array();
$config['resources']['autoloader']['autoloader'] = 'Singular';
$config['resources']['autoloader']['singular'] = array();
$config['resources']['autoloader']['singular']['cache'] = array();
$config['resources']['autoloader']['singular']['cache']['enable'] = false;
$config['resources']['autoloader']['singular']['cache']['frontend'] = array();
$config['resources']['autoloader']['singular']['cache']['frontend']['name'] = 'Core';
$config['resources']['autoloader']['singular']['cache']['frontend']['customFrontendNaming'] = false;
$config['resources']['autoloader']['singular']['cache']['frontend']['options'] = array();
$config['resources']['autoloader']['singular']['cache']['frontend']['options']['lifetime'] = 864000;
$config['resources']['autoloader']['singular']['cache']['frontend']['options']['automatic_serialization'] = true;
$config['resources']['autoloader']['singular']['cache']['frontend']['options']['cache_id_prefix'] = 'autoloader_';
$config['resources']['autoloader']['singular']['cache']['frontend']['options']['ignore_user_abort'] = true;
$config['resources']['autoloader']['singular']['cache']['backend'] = array();
$config['resources']['autoloader']['singular']['cache']['backend']['name'] = 'File';
$config['resources']['autoloader']['singular']['cache']['backend']['customBackendNaming'] = false;
$config['resources']['autoloader']['singular']['cache']['backend']['options'] = array();
$config['resources']['autoloader']['singular']['cache']['backend']['options']['cache_dir'] = ROOT_PATH . "/cache/";
$config['resources']['autoloader']['singular']['cache']['backend']['options']['hashed_directory_level'] = 0;
$config['resources']['autoloader']['singular']['cache']['backend']['options']['read_control'] = false;
$config['resources']['autoloader']['singular']['cache']['backend']['options']['read_control_type'] = 'adler32';
$config['resources']['autoloader']['singular']['cache']['backend']['options']['metatadatas_array_max_size'] = 10;
$config['resources']['autoloader']['singular']['cache']['frontendBackendAutoload'] = false;
$config['resources']['autoloader']['zend'] = array();
$config['resources']['autoloader']['zend']['params'] = array();
$config['resources']['autoloader']['zend']['params']['enableFallbackAutoloader'] = true;
$config['resources']['autoloader']['zend']['params']['suppressNotFoundWarnings'] = false;
$config['resources']['autoloader']['zend']['params']['noZendX'] = true;
$config['resources']['autoloader']['zend']['registry_key'] = 'autoloader';
$config['resources']['autoloader']['zend']['modules'] = array();
$config['resources']['autoloader']['zend']['modules'][] = 'system';

/* Layout */
$config['resources']['layout']['layoutPath'] = APPLICATION_PATH . "/layouts";
$config['resources']['layout']['layout'] = 'main';
$config['resources']['layout']['contentKey'] = 'content';

/* View */
$config['resources']['view']['encoding'] = 'utf-8';

return $config;