<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Installation/Update of UseResponse</title>
<link type="text/css" rel="stylesheet" href="<?php echo $this->baseUrl('css/main.css')?>" media="screen, projection"  />
<!--[if IE]><link type="text/css" rel="stylesheet" href="<?php echo $this->baseUrl('css/ie-styles.css')?>" media="screen, projection"  /><![endif]-->
<script type="text/javascript" src="<?php echo $this->baseUrl('js/jquery.js')?>"></script>
<script src="<?php echo $this->baseUrl('js/jquery.textshadow.js')?>" type="text/javascript"></script>
<script type="text/javascript">
  jQuery(document).ready(function(){
    jQuery(".text-area p, .feedback").textShadow();
  });
</script>
</head>
<body>
<div class="all">
  <div class="head-area"> <a href="#" class="logo">Use Response</a>
    <div class="description-script">
      <p>This script will check the environment if it's compatible with UseResponse.</p>
      <p class="accept">- requirement is passed</p>
      <p class="warning">- warning! Some minor features won't work</p>
      <p class="del">- there are issues with that requirement</p>
    </div>
    <div class="page-title">Installation Process</div>
  </div>
  <div class="wrap-container">
    <div class="wrap-container-inner">
      <div class="mainArea-type">        
        <div class="sub-title system<?php if (!$this->hasErrors()): ?> checked<?php endif?>">
          <h1>1. System Requirements</h1>
          <p>Make sure all items are green for the system to work as expected, otherwise contact hosting administrator</p>
        </div>
        <?php if ($this->hasErrors()): ?>
            <div class="overflow">
                <div class="requirements-block floatRight">
                    <div class="requirement table-view">
                        <?php echo $this->renderResults(self::COLUMN_RIGHT)?>
                    </div>
                </div>
                <div class="requirements-block">
                    <div class="requirement table-view">
                        <?php echo $this->renderResults(self::COLUMN_LEFT)?>
                    </div>
                </div>
            </div>
        <?php endif?>
       <?php echo $this->getFinalResult()?>
       <?php if (!$this->hasErrors()): ?>
        <form action="<?php echo $this->getBaseUrl()?>/#install" method="post" enctype="multipart/form-data">
        <div class="sub-title settings<?php if ($this->_isExecute && $this->_isValid): ?> checked<?php endif?>">
          <h1>2. General Settings</h1>
          <p>Setup database before installing system as it will require to provide db access</p>
        </div>
        <div class="info-block" <?php if ($this->_isExecute && $this->_isValid): ?> style="display:none"<?php endif?>>
          <p class="title">Installation URL</p>
          <p>This value can be changed later in application/configs/application.ini</p>
          <p><a href="<?php echo $this->getBaseUrl()?>" target="_blank"><?php echo $this->getBaseUrl()?></a></p>
        </div>
        <?php if ($this->isSubFolder()): ?>
            <div class="text-area color3" style="margin-bottom:10px;"><p>After installation remove from .htaccess the line - RewriteBase /</p></div>
        <?php endif ?>
        <div class="overflow">
          <div class="wrap floatRight">
            <div class="sub-title db<?php if ($this->_isExecute && $this->_isValid): ?> checked<?php endif?>">
              <h1>4. Database </h1>
              <p>Please provide access to already created database</p>
            </div>
            <div class="access-col access-col1" <?php if ($this->_isExecute && $this->_isValid): ?> style="display:none"<?php endif?>>
              <div class="access-line">
                <label>DB Host:</label>
                <?php echo $this->renderField('text', 'db_host', 'localhost', 'empty')?>
              </div>
              <div class="access-line color-obj">
                <label>DB User: </label>
                <?php echo $this->renderField('text', 'db_user', '', 'empty')?>
              </div>
              <div class="access-line">
                <label>Password:</label>
                <?php echo $this->renderField('text', 'db_pass')?>
              </div>
              <div class="access-line color-obj">
                <label>DB Name:</label>
                <?php echo $this->renderField('text', 'db_name', '', 'empty')?>
              </div>
            </div>
          </div>
          <div class="wrap">
            <div class="sub-title admin<?php if ($this->_isExecute && $this->_isValid): ?> checked<?php endif?>">
              <h1>3. Administrator access</h1>
              <p>Please state your company and administrator access</p>
            </div>
            <div class="access-col access-col2" <?php if ($this->_isExecute && $this->_isValid): ?> style="display:none"<?php endif?>>
              <div class="access-line">
                <label>Community Name:</label>
                <?php echo $this->renderField('text', 'company_name', '', 'empty')?>
              </div>
              <div class="access-line color-obj">
                <label>Admin Email:</label>
                <?php echo $this->renderField('text', 'admin_email', '', 'email')?>
              </div>
              <div class="access-line">
                <label>Admin Password:</label>
                <?php echo $this->renderField('password', 'admin_password', '', 'empty')?>
              </div>
              <div class="access-line color-obj">
                <label>Table Prefix:</label>
                <?php echo $this->renderField('text', 'db_pref', 'ur_')?>
              </div>
            </div>
          </div>
           <div class="btn-area" <?php if ($this->_isExecute && $this->_isValid): ?> style="display:none"<?php endif?>>
             <a name="install"></a>
             <input id="validate-db" type="button" name="validate" class="button-type" value="Validate" />
	     <script type="text/javascript">
		 $("#validate-db").click(function(){
                    form = $(this).parents("form");
                    error = 0;
                    elements = form.find("input[type=text],input[type=file],input[type=password]");
                    elements.each(function(){
                        if ($(this).val() == "") {
                            if ( $(this).attr("type") == "file" ) {
                                $(this).parent().find(".textInput").addClass("error");
                            } else {
                                $(this).addClass("error");
                            }
                            error = 1;
                        } else {
                            if ( $(this).attr("type") == "file" ) {
                                $(this).parent().find(".textInput").removeClass("error");
                            } else {
                                $(this).removeClass("error");
                            }
                        }
                    });
                    if (error == 0) {
                        $.ajax({
                            type:'post',
                            async:true,
                            data:{'validate_db':'1', 'db_host':$("input[name=db_host]").val(), 'db_user':$("input[name=db_user]").val(), 'db_pass':$("input[name=db_pass]").val(), 'db_name':$("input[name=db_name]").val()},
                            beforeSend:function(){
                                $("#validate-db").val("Please Wait...");
                                $("#validate-db").attr("disabled", "disabled");
                            },
                            success:function(r){
                                if (r != 1) {
                                    $("#validate-db-msg").show();
                                } else {
                                    $("#validate-db-msg").hide();
                                    form.find(".access-line, .info-block").hide();
                                    $(".sub-title.db, .sub-title.admin, .sub-title.settings").addClass("checked");
                                    $(".license-agreement").fadeIn();
                                    $("#validate-db").parent().hide();
                                }
                            },
                            complete:function(){
                                $("#validate-db").val("Validate");
                                $("#validate-db").removeAttr("disabled");
                            }
                        });
                    }
		 });
	     </script>
           </div>
        </div>
        <div id="validate-db-msg" class="text-area color2" style="display:none;">
          <p>Can't connect to database with provided access!</p>
        </div>
        <div class="license-agreement" style="display:none">
          <div class="sub-title" style="padding:14px 0 8px 0;">
            <h1>5. License Agreement</h1>
          </div>
          <div class="textTextarea">
            <div class="divTextarea"><?php echo $this->partial('license.php')?></div>
          </div>
          <?php echo $this->renderField('checkbox', 'agreement', '1', 'yes', array('class' => 'agree', 'label' => 'I Accept the Agreement'))?>
            <script type="text/javascript">
                $("input[name=agreement]").click(function(){
                    if ($(this).is(":checked")) {
                        $(".btn-install").fadeIn();
                    } else {
                        $(".btn-install").fadeOut();
                    }
                });
            </script>
        </div>
        <div class="btn-install" style="display:none">
          <div class="btn-area">
            <a name="install"></a>
            <input type="submit" name="submit" class="button-type" value="Install" />
          </div>
        </div>
        </form>
          <p></p>
        <?php if ($this->_isExecute && !$this->_isValid) : ?>
        <div class="text-area color2">
          <p><?php echo $this->_everythingError?></p>
        </div>
       <?php endif ?>
        
        <?php if ($this->_isExecute && $this->_isValid): ?>
          <script type="text/javascript">
                preloader = function (obj) {
                    obj.find('span').addClass('preloader');
                }
                clear = function (obj) {
                    obj.find('span').removeClass('preloader');
                }
                result = function (obj, r) {
                    obj.find('span').addClass(r);
                }
                complete = function () {
                   $.post('?complete', function(r){
                       $('.complete').html(r);
                   });
                }
                step = function (objects) {
                    obj = $(objects.shift());
                    $.ajax({
                        type:'post',
                        async:true,
                        data:{step:obj.attr('id')},
                        timeout:60000, // 1 min
                        beforeSend:function(){preloader(obj)},
                        success:function(r){result(obj, r)},
                        complete:function(){
                            clear(obj);
                            if (objects.length > 0) {
                                step(objects);
                            } else {
                                complete();
                            }
                        }
                    });
                };
                install = function () {
                    objects = [];
                    $('#installBlock .requirements-block:eq(1) .obj').each(function () {
                        objects.push($(this));
                    });
                    $('#installBlock .requirements-block:eq(0) .obj').each(function () {
                        objects.push($(this));
                    });
                    step(objects);
                }
                $(document).ready(install);
          </script>
        <p class="please">Please be patient until installation process completes...</p>
        <div class="overflow" id="installBlock">
          <div class="requirements-block floatRight">
            <div class="requirement table-view">
              <div class="obj" id="installAdministrator">Setup System Administrator<span class="ico-small"></span></div>
              <div class="obj color-obj" id="installEnv">Environment Installation<span class="ico-small"></span></div>
              <div class="obj" id="installModules">Modules Installing<span class="ico-small"></span></div>
              <div class="obj color-obj" id="installVerify">Verification Process<span class="ico-small"></span></div>
            </div>
          </div>
          <div class="requirements-block">
            <div class="requirement table-view">
              <div class="obj" id="installDatabase">Database Installation<span class="ico-small"></span></div>
              <div class="obj" id="installConfig">Set Configuration File<span class="ico-small"></span></div>
              <div class="obj color-obj" id="installAcl">Set System Permissions<span class="ico-small"></span></div>
              <div class="obj" id="installSettings">Apply Default Settings<span class="ico-small"></span></div>
            </div>
          </div>
        </div>
        <div class="complete"></div>
        <?php endif ?>
        
        <?php endif ?>
      </div>
      <div class="clear"></div>
    </div>
  </div>
  <div class="footer-area">
    <div class="productBy"> Fine product of <a href="http://www.uswebstyle.com" target="_blank"><img src="<?php echo $this->baseUrl('images/logo-usw.png')?>" width="116" height="15" alt="" /></a></div>
    <div class="poweredBy"> Powered by <a href="http://www.singularcore.com" target="_blank"><img src="<?php echo $this->baseUrl('images/logo-singular.png')?>" width="76" height="24" alt="" /></a> </div>
    <div class="copyright"> &copy; <?php echo date('Y')?> — <span>UseResponse.</span> All Rights Reserved</div>
  </div>
</div>
<script type="text/javascript">
    $(document).ready(function(){
        $('.inputFile').change(function(){
            $(this).next('.textInput').html($(this).val().replace(/^.*[\/\\]/g, ""));
        });
        if ($('.inputFile').hasClass('error')) {
            $('.inputFileWrapper').addClass('error');
        }
    });
</script>
</body>
</html>