<?php

class Singular_Component
{
    public static function run ($component, $module, $options = array())
    {
        $component = ucfirst($component);
        $filePath = APPLICATION_PATH . DS . 'modules' . DS . $module .
                    DS . 'components' . DS . "{$component}.php";

        if (!file_exists($filePath)) {
            throw new Singular_Component_Exception(
                "Component {$component} in {$filePath} was not found."
            );
        }

        require_once $filePath;
        $class = Singular_Stdlib_Module::formatName($module) . '_Component_' . $component;

        if (!class_exists($class)) {
            throw new Singular_Component_Exception(
                "Component class {$class} was not found in {$filePath}."
            );
        }

        /**
         * @var $instance Singular_Component_Abstract
         */
        $instance = new $class($module, $options);

        if (!$instance instanceof Singular_Component_Abstract) {
            throw new Singular_Component_Exception(
                "Component class {$class} must be instance of Singular_Component_Abstract."
            );
        }

        return $instance->run();
    }
}
