<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Controller
 * @subpackage Singular_Controller_Action_Helper
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * AutoNoRender action helper
 * 
 * Uses setNoRender if no template was found for current action
 *
 * @uses       Zend_Controller_Action_Helper_Abstract
 * @category   Singular
 * @package    Singular_Controller
 * @subpackage Singular_Controller_Action_Helper
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_Controller_Action_Helper_AutoNoRender extends Zend_Controller_Action_Helper_Abstract
{
    public function postDispatch()
    {
        // get ViewRender instance
        $viewRenderer = Zend_Controller_Action_HelperBroker::getStaticHelper('viewRenderer');
        // specifies script name for the current action
        $name  = $viewRenderer->getViewScript();
        // get list of script paths which were this script will be matched
        $paths = $viewRenderer->view->getScriptPaths();
        // set shouldRender flag to false (disable autorendering)
        $shouldRender = false;
        
        // check all paths in cycle
        foreach ($paths as $dir) {
            if (is_readable($dir . $name)) {
                // Set flag in true if file exists
                $shouldRender = true;
            }
        }
        // on the shouldRender flag final value turn off or turn on the rendering
        if ($shouldRender) {
            $viewRenderer->setNoRender(false);
        } else {
            $viewRenderer->setNoRender(true);
        }
    }
}
