<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Controller
 * @subpackage Singular_Controller_Action_Helper
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * Firebug action helper
 *
 * @uses       Zend_Controller_Action_Helper_Abstract
 * @category   Singular
 * @package    Singular_Controller
 * @subpackage Singular_Controller_Action_Helper
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_Controller_Action_Helper_Firebug extends Zend_Controller_Action_Helper_Abstract
{
    /**
     * Use this helper as a method; proxies to log()
     *
     * @param  mixed $data
     * @param  int   $level
     * @return void
     */
    public function direct ($data, $level = Zend_Log::DEBUG)
    {
        if (false === Zend_Registry::isRegistered('firebug')) {
            /** @see Zend_Log_Writer_Firebug  */
            $firebug = new Zend_Log(new Zend_Log_Writer_Firebug());
            Zend_Registry::set('firebug', $firebug);
        } else {
            $firebug = Zend_Registry::get('firebug');
        }

        $firebug->log($data, $level);
    }
}
