<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Controller
 * @subpackage Singular_Controller_Action_Helper
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * Token action helper
 *
 * @uses       Zend_Controller_Action_Helper_Abstract
 * @category   Singular
 * @package    Singular_Controller
 * @subpackage Singular_Controller_Action_Helper
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_Controller_Action_Helper_Token extends Zend_Controller_Action_Helper_Abstract
{
    /**
     * Tokens left delimiter
     */
    const LEFT_DELIMITER = '[';

    /**
     * Tokens right delimiter
     */
    const RIGHT_DELIMITER = ']';
    
    /**
     * Assemble string with tokens
     *
     * @param  string $string
     * @param  array  $tokens
     * @return string
     */
    public function direct ($string, $tokens)
    {
        $keys = array();
        $values = array();

        if (is_array($tokens)) {
            foreach ($tokens as $key => $value) {
                $values[] = $value;
                $keys[]   = '/\\' . self::LEFT_DELIMITER . $key . '\\' . self::RIGHT_DELIMITER . '/i';
            }
            $string = preg_replace($keys, $values, $string);
        }

        return $string;
    }
}
