<?php

class Singular_Core
{
    const PROJECT_RES_NAMESPACE = 'Singular_Core_';

    private static $_resources = array();

    public static function _ ($resName)
    {
        return (true === self::_resourceLoaded($resName))
                ? self::init($resName)
                : self::_loadResource($resName);
    }

    protected static function _loadResource ($resName)
    {
        $resName = ucfirst($resName);
        $filter = new Zend_Filter_Word_UnderscoreToSeparator(DS);
        $resPath = LIBRARY_PATH
                   . DS
                   . $filter->filter(self::PROJECT_RES_NAMESPACE)
                   . $resName . '.php';
        if (file_exists($resPath)) {
            require_once $resPath;
            $resClass = self::PROJECT_RES_NAMESPACE . $resName;
            if (class_exists($resClass)) {
                self::_resourceSetLoaded($resName);

                return self::init($resName);
            }
            throw new Singular_Core_Exception("Resource file is located, but class {$resClass} was not found.");
        } else {
            throw new Singular_Core_Exception("Project resource file {$resPath} is not exists.");
        }
    }

    protected static function _resourceLoaded ($resName)
    {
        return (in_array(strtolower($resName), self::$_resources)) ? true : false;
    }

    protected static function _resourceSetLoaded ($resName)
    {
        self::$_resources[] = strtolower($resName);
    }

    public static function init ($resName)
    {
        $className = self::PROJECT_RES_NAMESPACE . $resName;
        return new $className;
    }

}
