<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System_Form
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * @abstract
 * @uses       Singular_Form
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System_Form
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
abstract class Singular_Core_System_Form_Login extends Singular_Form
{
    public function init ()
    {
        parent::init();

        // username filed
        $username = new Singular_Form_Element_Text('username');
        $username->setLabel($this->getView()->t('Username'));
        $username->setRequired(true);
        $username->addFilter('StringTrim');

        // password field
        $password = new Singular_Form_Element_Text_Password('password');
        $password->setLabel($this->getView()->t('Password'));
        $password->setRequired(true);
        $password->addFilter('StringTrim');

        // submit button
        $submit = new Zend_Form_Element_Submit('submit');
        $submit->setLabel($this->getView()->t('Login'));
        $submit->setIgnore(true);

        // add elements
        $this->addElements(array(
            $username,
            $password,
            $submit,
        ));
    }
}
