<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System_Model_DbTable
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * @abstract
 * @uses       Singular_Db_Table_Abstract
 * @throws     Singular_Exception
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System_Model_DbTable
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_Core_System_Model_DbTable_EmailTemplates
    extends Singular_Db_Table_Abstract
{
    /**
     * The table name
     *
     * @var string
     */
    protected $_name = 'email_templates';

    /**
     * The primary key column or columns.
     * A compound key should be declared as an array.
     * You may declare a single-column primary key
     * as a string.
     *
     * @var mixed
     */
    protected $_primary = 'slug';
    
    /**
     * Row class
     * 
     * @var string
     */
    protected $_rowClass = 'Singular_Core_System_Model_EmailTemplate';
    
    /**
     * Dependent Tables
     * 
     * @var array
     */
    protected $_dependentTables = array(
        'Singular_Core_System_Model_DbTable_EmailTemplatesLang',
    );
    
    /**
     * To fetch template by ID and LANG
     * 
     * @param int $id
     * @param string $lang
     * @return Singular_Core_System_Model_EmailTemplate
     */
    public function findByIdAndLang ($id, $lang)
    {
        $select = $this->select();
        $select->where('id = ?', $id, Zend_Db::INT_TYPE);
        $select->where('lang = ?', $lang);
        return $this->fetchRow($select);
    }

    /**
     * To fetch all templates
     * 
     * @return Singular_Core_System_Model_EmailTemplates 
     */
    public function findAll ()
    {
        $select = $this->select();
        return $this->fetchAll($select);
    }
}
