<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System_Model_DbTable
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * @abstract
 * @uses       Singular_Db_Table_Abstract
 * @throws     Singular_Exception
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System_Model_DbTable
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_Core_System_Model_DbTable_EmailTemplatesLang
    extends Singular_Db_Table_Abstract
{
    /**
     * The table name
     *
     * @var string
     */
    protected $_name = 'email_templates_lang';

    /**
     * The primary key column or columns.
     * A compound key should be declared as an array.
     * You may declare a single-column primary key
     * as a string.
     *
     * @var mixed
     */
    protected $_primary = 'id';
    
    /**
     * Row class
     * 
     * @var string
     */
    protected $_rowClass = 'Singular_Core_System_Model_EmailTemplateLang';
    
    /**
     * Reference map
     * 
     * @var array 
     */
    protected $_referenceMap = array(
        'EmailTemplate' => array(
            'columns'    => array('id'),
            'refTable'   => 'Singular_Core_System_Model_DbTable_EmailTemplates',
            'refColumns' => array('id'),
            'onDelete'   => self::CASCADE,
            'onUpdate'   => self::CASCADE
        ),
    );
    
    public function findByTemplateIdAndLang ($templateId, $lang = null)
    {        
        if (null === $lang) {
            $lang = Singular_Core::_('settings')
                ->getSetting('site_default_language');
        }
     
        $select = $this->select();
        $select->where('template_id = ?', $templateId, Zend_Db::INT_TYPE);
        $select->where('lang = ?', $lang);
        
        return $this->fetchRow($select);
    }
}
