<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System_Model_DbTable
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * @uses       Singular_Db_Table_Abstract
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System_Model_DbTable
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_Core_System_Model_DbTable_Modules
    extends Singular_Db_Table_Abstract
{
    /**
     * The table name
     * 
     * @var string
     */
    protected $_name = 'modules';

    /**
     * The primary key column or columns.
     * A compound key should be declared as an array.
     * You may declare a single-column primary key
     * as a string.
     *
     * @var mixed
     */
    protected $_primary = 'id';

    /**
     * Fetches all installed module
     *
     * if $active = true - fetches only active modules
     *
     * @param  bool $active
     * @return Zend_Db_Table_Rowset_Abstract
     */
    public function getModules ($active = true)
    {
        $select = $this->select();
        $select->order('load_order ASC');

        if (true === (bool) $active) {
            $select->where('active = ?', 1, Zend_Db::INT_TYPE);
        }

        return $this->fetchAll($select);
    }

    public function getInactiveModules ()
    {
        $select = $this->select();
        $select->order('id')->where('active = ?', 0, Zend_Db::INT_TYPE);

        return $this->fetchAll($select);
    }
}
