<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System_Model_DbTable
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * @uses       Singular_Db_Table_Abstract
 * @throws     Singular_Exception
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System_Model_DbTable
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_Core_System_Model_User extends Singular_Db_Table_Row
{
    protected $_tableClass = 'Singular_Core_System_Model_DbTable_Users';

    /**
     * Is active user?
     *
     * @return bool
     */
    public function isActive ()
    {
        return (bool)$this->is_active;
    }

    /**
     * Disactivate user
     *
     * @return mixed The primary key value(s), as an associative array if the
     *               key is compound, or a scalar if the key is single-column.
     */
    public function disactivate ()
    {
        $this->is_active = 0;

        Singular_Event::dispatch('disactivateUser', $this);

        return $this->save();
    }

    /**
     * Activate user
     *
     * @return mixed The primary key value(s), as an associative array if the
     *               key is compound, or a scalar if the key is single-column.
     */
    public function activate ()
    {
        $this->is_active = 1;

        Singular_Event::dispatch('activateUser', $this);

        return $this->save();
    }
}
