<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * @abstract
 * @uses       Singular_Module_Abstract
 * @category   Singular
 * @package    Singular_Core
 * @subpackage Singular_Core_System
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
abstract class Singular_Core_System_Module extends Singular_Module_Abstract
{
    /**
     * Initialize object
     *
     * Called from {@link __construct()} as final step of object instantiation.
     *
     * @return void
     */
    public function init ()
    {
        $this->_info();
    }

    /**
     * Module information
     * 
     * @return void
     */
    protected function _info ()
    {
        $this->getContainer()->setName('System module')
                ->setDescription('SingularCore.')
                ->setVersion(Singular_Version::VERSION)
                ->setAuthor('UswebStyle, LLC')
                ->setEmail('paul@uswebstyle.com')
                ->setUrl('http://www.uswebstyle.com')
                ->setReleaseDate('2011-08-24');
    }
}
