<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Date
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * Sidebar component
 *
 * @category   Singular
 * @package    Singular_Date
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_Date extends Zend_Date
{
    /**
     * MySQL DateTime format
     */
    const FORMAT_MYSQL_DATETIME = 'Y-m-d H:i:s';
    
    /**
     * MySQL datetime format ISO
     */
    const FORMAT_ISO_MYSQL_DATETIME = 'YYYY-MM-dd HH:mm:ss';
    
    /**
     * Returns the actual date as new date object
     *
     * @param  string|Zend_Locale $locale  OPTIONAL Locale for parsing input
     * @return Zend_Date
     */
    public static function now ($locale = null)
    {
        return new self(time(), self::TIMESTAMP, $locale);
    }
    
    /**
     * Convert to MySQL format
     * 
     * @return string
     */
    public function toMysql ()
    {
        if (null !== Zend_Db_Table::getDefaultAdapter()) {
            $tz = Singular_Core::_('settings')->getSetting('site_default_timezone');
            $this->setTimezone($tz);
        }

        return $this->toString(self::FORMAT_MYSQL_DATETIME);
    }
}
