<?php
/**
 * Singular
 *
 * LICENSE
 *
 * The SOFTWARE PRODUCT is protected by copyright treaties,
 * as well as other intellectual property laws and treaties.
 * The SOFTWARE PRODUCT is licensed, not sold.
 * Software.
 * You may install and use one copy of the SOFTWARE PRODUCT
 * for each license purchased or if a site license then you
 * may install any number of copies at the site where the
 * site license is defined.
 * Your rights to use the SOFTWARE PRODUCT are not transferable.
 *
 * @category   Singular
 * @package    Singular_Db
 * @subpackage Table
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */

/**
 * @category   Singular
 * @package    Singular_Controller
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */
class Singular_Db_Table_Row extends Zend_Db_Table_Row
{
    /**
     * Table class
     *
     * @var string
     */
    protected $_tableClass = 'Singular_Db_Table_Abstract';

    /**
     * Initialization
     *
     * @return void
     */
    public function init ()
    {
        parent::init();
    }

    /**
     * Saves the properties to the database.
     *
     * This performs an intelligent insert/update, and reloads the
     * properties with fresh data from the table on success.
     *
     * @return mixed The primary key value(s), as an associative array if the
     *     key is compound, or a scalar if the key is single-column.
     */
    public function save ()
    {
        Singular_Event::dispatch('beforeSave', $this);

        if (empty($this->_cleanData)) {
            Singular_Event::dispatch('beforeInsert', $this);
            $result = $this->_doInsert();
            Singular_Event::dispatch('afterInsert', $this);
        } else {
            Singular_Event::dispatch('beforeUpdate', $this);
            $result = $this->_doUpdate();
            Singular_Event::dispatch('afterUpdate', $this);
        }

        Singular_Event::dispatch('afterSave', $this);

        return $result;
    }

    /**
     * Deletes existing rows.
     *
     * @return int The number of rows deleted.
     */
    public function delete ()
    {
        Singular_Event::dispatch('beforeDelete', $this);
        $result = parent::delete();
        Singular_Event::dispatch('afterDelete', $this);

        return $result;
    }

    /**
     * Is modified fiel
     *
     * @param  string $field
     * @return bool
     */
    public function isModifiedField ($field)
    {
        return array_key_exists($field, $this->_modifiedFields);
    }
}
