<?php
/**
 * Singular
 *
 * LICENSE
 *
 * The SOFTWARE PRODUCT is protected by copyright treaties,
 * as well as other intellectual property laws and treaties.
 * The SOFTWARE PRODUCT is licensed, not sold.
 * Software.
 * You may install and use one copy of the SOFTWARE PRODUCT
 * for each license purchased or if a site license then you
 * may install any number of copies at the site where the
 * site license is defined.
 * Your rights to use the SOFTWARE PRODUCT are not transferable.
 *
 * @category   Singular
 * @package    Singular_Filter
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */

 /**
 * @category   Singular
 * @package    Singular_Filter
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */
class Singular_Filter_Paths_Styles implements Zend_Filter_Interface
{
    const DIRTY_PATH = '../';
    
    private $_path = null;
    
    /**
     * Defined by Zend_Filter_Interface
     *
     * @param  string $value
     * @return string
     */
    public function filter ($value)
    {
        // Was the passed $value a file?
        if(is_file($value)){
            $value = file_get_contents($value);
        }
        
        $value = $this->_correct($value);

        return $value;
    }
    
    public function setPath ($path)
    {
        $this->_path = trim($path);
    }
    
    public function getPath ()
    {
        return $this->_path;
    }

    /**
     * @param  string $source
     * @return string
     */
    protected function _correct ($source)
    {
        $view   = Zend_Layout::getMvcInstance()->getView();
        $path   = dirname(substr($this->getPath(), strlen(ROOT_PATH) + 1));
       
        preg_match_all("/url\(([^\)]*)\)/is", $source, $matches);
        if (isset($matches[1])) {
            $replaces = array();
            foreach ($matches[1] as $line) {
                $line = trim($line, '"\'');
                $realPath = realpath(ROOT_PATH . '/' . $path . '/' . $line);
                $replaces[$line] = $view->baseUrl(str_replace(array(ROOT_PATH, '\\'), array('', '/'), $realPath));
            }
            $source = strtr($source, $replaces);
        }
        
        return $source;
    }
}
