<?php
/**
 * Text form element
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 */
class Singular_Form_Element_Custom extends Singular_Form_Element_Xhtml
{
    /**
     * Default form view helper to use for rendering
     * @var string
     */
    public $helper = 'formText';

    /**
     * Data
     * 
     * @var string
     */
    protected $_customData;

    public function init ()
    {
        $this->_initElementViewScriptDecorator('custom');
    }

    public function setCustomData ($data)
    {
        if (!is_string($data)) {
            throw new Singular_Form_Element_Exception('Custom data must be an string, ' . gettype($data) . ' was given.');
        }

        $this->_customData = $data;
    }

    public function getCustomData ()
    {
        return $this->_customData;
    }
}
 
