<?php
/**
 * Date form element
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 */
class Singular_Form_Element_Date extends Singular_Form_Element_Text
{
    private static $_formElementDateJsLoaded = false;
    
    public function init ()
    {
        parent::init();
        $this->_initJs();

        $this->setAttrib('class', 'form-text-input date-input')
                ->setAttrib('style', 'width:200px;');
    }

    protected function _initJs ()
    {
        if (self::$_formElementDateJsLoaded) {
            return;
        }

        $view = $this->getView();

        $view->headLink()->appendStylesheet(
            $view->stylesheetSrc('jquery/plugins/date-input/style.css', null)
        );

        $view->headScript()->appendFile(
            $view->javascriptSrc('jquery/plugins/jquery.date-input.js', null)
        );

        $view->headScript()->appendScript(
            'App.onReady(function(){' . PHP_EOL .
            '/* Date Input */' . PHP_EOL .
            "$('.date-input').dateinput({format: 'yyyy-mm-dd', selectors: true});" . PHP_EOL .
            '});'
        );

        self::$_formElementDateJsLoaded = true;
    }
}
