<?php
/**
 * DateTime form element
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 */
class Singular_Form_Element_DateTime extends Singular_Form_Element_Text
{
    /**
     * Initialize object; used by extending classes
     *
     * @return void
     */
    public function init ()
    {
        parent::init();

        $this->setAttrib('class', 'form-text-input date-input')
                ->setAttrib('style', 'width:200px;');
    }

    /**
     * Render form element
     *
     * @param  Zend_View_Interface $view
     * @return string
     */
    public function render (Zend_View_Interface $view = null)
    {
        $view = $this->getView();

        $view->headLink()->appendStylesheet(
            $view->stylesheetSrc('jquery/ui/jquery-ui-timepicker-addon.css', null)
        );

        $view->headScript()->appendFile(
            $view->javascriptSrc('jquery/ui/jquery-ui-timepicker-addon.js', null)
        );

        $view->headScript()->appendScript(
            'App.onReady(function(){' . PHP_EOL .
            '/* Date Input */' . PHP_EOL .
            "$('#{$this->getId()}').datetimepicker({showSecond: true, timeFormat: 'hh:mm:ss', dateFormat: 'yy-mm-dd'});" . PHP_EOL .
            '});'
        );

        return parent::render($view);
    }
}
