<?php
/**
 * Installed languages list form element
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 */
class Singular_Form_Element_InstalledLangsList extends Singular_Form_Element_Select
{
    public function init ()
    {
        parent::init();
        $this->_initList();
    }

    protected function _initList ()
    {
        $languages = new Singular_Core_System_Model_DbTable_Languages();
        $languages = $languages->getLanguages(1);
        if (null !== $languages) {
            $languages = $languages->toArray();
            foreach ($languages as $langIdx => $langData) {
                $languages[$langData['code']] = $langData['name'];
                unset($languages[$langIdx]);
            }
            
            /** @var $locale Zend_Locale */
            $locale = Singular_Runtime::extract('Zend_Locale');
            $langList = $locale->getTranslationList('language'
                , Singular_Core::_('settings')->getSetting('site_default_locale'));

            foreach ($languages as $lKey => $lVal) {
                $languages[$lKey] = $langList[$lKey];
            }
        } else {
            $languages = array();
        }

        $this->setMultiOptions($languages);
    }
}
