<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * @abstract
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_Form_Element_IsActive extends Singular_Form_Element_Radio
{    
    /**
     * Initialization
     * 
     * @param void
     * @return void
     */
    public function init()
    {
        parent::init();
        
        // Default options
        $this->setLabel('Is Active?')
             ->setRequired(true)
             ->setAllowEmpty(false)
             ->addMultiOptions(array(
                 '1' => $this->getView()->t('Yes'),
                 '0' => $this->getView()->t('No'),
             ))
             ->setValue('1')
             ->setSeparator('')
             ->addValidator(new Zend_Validate_Between(0,1));
    }
}
