<?php
/**
 * Languages list form element
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 */
class Singular_Form_Element_LangsList extends Singular_Form_Element_Select
{
    public function init ()
    {
        parent::init();
        $this->_initList();
    }

    protected function _initList ()
    {
        /** @var $locale Zend_Locale */
        $locale = Singular_Runtime::extract('Zend_Locale');
        $langs = $locale->getTranslationList('language'
            , Singular_Core::_('settings')->getSetting('site_default_locale'));
        asort($langs, SORT_LOCALE_STRING);
        $this->setMultiOptions($langs)->setValue('en');
    }
}