<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

 /**
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_Form_Element_Languages extends Singular_Form_Element_Select
{
    /**
     * Initialization
     * 
     * @param void
     * @return void
     */
    public function init ()
    {
        parent::init();

        $languages = Singular_Loader::get('Singular_Core_System_Model_DbTable_Languages');
        
        $options = $languages->findList();
        $this->setMultiOptions($options);
        
        // Default options
        $this->setLabel('Language')
             ->setRequired(true)
             ->setAllowEmpty(false)
             ->addValidator(new Zend_Validate_InArray(array(
                'haystack' => array_keys($options),
             )));
    }
}
