<?php
/**
 * Resources list form element
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 */
class Singular_Form_Element_ResourcesList extends Singular_Form_Element_Select
{
    public function init ()
    {
        parent::init();
        $this->_initList();
    }

    protected function _initList ()
    {
        $resourcesModel = new Singular_Core_System_Model_DbTable_Resources();
        $resourcesRaw = $resourcesModel->getAllResources();

        $resources = array();
        foreach ($resourcesRaw as $resourcesRawData) {
            $resourceName = ('' != $resourcesRawData['name'])
                    ? $resourcesRawData['name']
                    : $resourcesRawData['resource'];
            $resources[$resourcesRawData['resource']] = $resourceName;
        }

        asort($resources);

        $this->setMultiOptions($resources);
    }
}
