<?php
/**
 * Roles list form element
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 */
class Singular_Form_Element_RolesList extends Singular_Form_Element_Select
{
    public function init ()
    {
        parent::init();
        $this->_initList();
        
        // Default options
        $this->setLabel('Role')
             ->setRequired(true)
             ->setAllowEmpty(false)
             ->addValidator(
                 new Zend_Validate_StringLength(1, 50, 'UTF-8'), true
             )
             ->addValidator(new Zend_Validate_InArray(array(
                'haystack' => $this->getMultiOptions(),
             )))
             ->addFilter('StringTrim');
    }

    protected function _initList ($active = false)
    {
        $rolesModel = new Singular_Core_System_Model_DbTable_Roles();
        $rolesRaw = $rolesModel->getAllRoles($active);

        $roles = array();
        foreach ($rolesRaw as $rolesRawData) {
            $roles[$rolesRawData['role']] = $rolesRawData['role'];
        }

        asort($roles);

        $this->setMultiOptions($roles);
    }

    public function setOnlyActive ($flag = true)
    {
        $this->_initList($flag);

        return $this;
    }
}
