<?php
/**
 * Submit block form element
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 */
class Singular_Form_Element_SubmitBlock extends Singular_Form_Element_Xhtml
{
    const BUTTON_POSITION_LEFT = 'left';

    const BUTTON_POSITION_RIGHT = 'right';

    protected $_submitButtonName = null;

    protected $_submitButtonValue = null;

    protected $_submitButtonParams = null;

    protected $_buttons = array(
        self::BUTTON_POSITION_LEFT => array(),
        self::BUTTON_POSITION_RIGHT => array()
    );

    /**
     * Default view helper to use
     * @var string
     */
    public $helper = 'formSubmit';

    public function __construct()
    {
        parent::__construct('submit_block');
    }

    public function init ()
    {
        $this->_initElementViewScriptDecorator('submit_block');
    }

    public function setSubmitButton ($name, $value, $params = null)
    {
        $this->setSubmitButtonName($name);
        $this->setSubmitButtonValue($value);
        $this->setSubmitButtonParams($params);
    }

    public function getSubmitButton ()
    {
        return array(
            'name' => $this->getSubmitButtonName(),
            'value' => $this->getSubmitButtonValue(),
            'params' => $this->getSubmitButtonParams()
        );
    }

    public function addButton ($name, $value, $params = null, $position = self::BUTTON_POSITION_RIGHT)
    {
        if ($position != self::BUTTON_POSITION_LEFT
            || $position != self::BUTTON_POSITION_LEFT) {
            $position = self::BUTTON_POSITION_RIGHT;
        }
        $this->_buttons[$position][$name] = array(
            'name' => $name, 'value' => $value, 'params' => $params
        );
    }

    public function getButtons ()
    {
        return $this->_buttons;
    }

    public function setSubmitButtonName ($submitButtonName)
    {
        $this->_submitButtonName = $submitButtonName;
    }

    public function getSubmitButtonName ()
    {
        return $this->_submitButtonName;
    }

    public function setSubmitButtonValue ($submitButtonValue)
    {
        $this->_submitButtonValue = $submitButtonValue;
    }

    public function getSubmitButtonValue ()
    {
        return $this->_submitButtonValue;
    }

    public function setSubmitButtonParams ($submitButtonParams)
    {
        if (!is_array($submitButtonParams)) return;
        
        $this->_submitButtonParams = $submitButtonParams;
    }

    public function getSubmitButtonParams ()
    {
        return $this->_submitButtonParams;
    }

}
