<?php

class Singular_Form_Element_Taxonomy extends Singular_Form_Element_Select
{
    public function init ()
    {
        parent::init();
        $this->_initList();
    }

    protected function _initList ()
    {
        $this->setRequired(true);
        $taxonomy = new Singular_Core_System_Model_Taxonomy();
        $activeRecord = $taxonomy->getModule('cms');
        $nodes = $taxonomy->getNodeTree($activeRecord->getId(), true);
        if (isset($nodes[0]['children'])) {
            $this->_addOptions($nodes[0]['children']);
        }
    }
    
    protected function _addOptions ($nodes, $separator = '')
    {
        if (is_array($nodes)) {
            foreach ($nodes as $node) {
                $this->addMultiOption($node['id'], $separator . $node['name']);
                if (isset($node['children']) && is_array($node['children'])) {
                    $this->_addOptions($node['children'], $separator . '--');
                }
            }
        }
    }
}
