<?php
/**
 * Languages list form element
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 */
class Singular_Form_Element_ThemesList extends Singular_Form_Element_Select
{
    protected $_env = 'frontend';
    
    public function __construct ($spec, $options = null, $env = null)
    {
        $this->_env = $env;
        parent::__construct($spec, $options);
    }
    
    public function init ()
    {
        parent::init();
        
        $list = $this->_initList();
        
        $this->setMultiOptions($list)
             ->setRequired(true)
             ->setAllowEmpty(false)
             ->addValidator(new Zend_Validate_InArray(array(
                'haystack' => array_keys($list),
             )));
    }

    protected function _initList ()
    {
        $options = array();
        $dir = new DirectoryIterator(ROOT_PATH . '/public/themes');
        foreach ($dir as $item) {
            if ($item->isFile() || $item->isDot()) {
                continue;
            }
            
            if (preg_match('#^(.+)\_'.$this->_env.'$#ui', $item->getFilename(), $matches)) {
                $options[$item->getFilename()] = $matches[1];
            }
        }
        
        return $options;
    }
}