<?php
/**
 * Users list form element
 *
 * @category   Singular
 * @package    Singular_Form
 * @subpackage Element
 */
class Singular_Form_Element_UsersList extends Singular_Form_Element_Select
{
    public function init ()
    {
        parent::init();
        $this->_initList();
    }

    protected function _initList ($active = false)
    {
        $usersModel = new Singular_Core_System_Model_DbTable_Users();
        $usersRaw = $usersModel->getAllUsers($active);

        $users = array();
        foreach ($usersRaw as $usersRawData) {
            $users[$usersRawData['username']] = $this->_formatUsername($usersRawData);
        }

        asort($users);

        $this->setMultiOptions($users);
    }

    private function _formatUsername ($row)
    {
        $username = array();
        if ('' != $row['first_name']) {
            $username[] = $row['first_name'];
        }
        if ('' != $row['last_name']) {
            $username[] = $row['last_name'];
        }

        $username = implode(' ', $username);
        if ('' == $username) {
            $username = $row['email'];
        }

        return $username;
    }

    public function setOnlyActive ($flag = true)
    {
        $this->_initList($flag);

        return $this;
    }
}
