<?php
/**
 * Singular_Form_SubForm
 *
 * @category   Singular
 * @package    Singular_Form
 */
class Singular_Form_SubForm extends Singular_Form
{
    /**
     * Whether or not form elements are members of an array
     * @var bool
     */
    protected $_isArray = true;

    /**
     * Form label
     * @var string
     */
    protected $_label;

    public function init()
    {
        parent::init();

        $this->_initSubFormViewScriptDecorator('sub_form');
    }

    protected function _initSubFormViewScriptDecorator($name)
    {
        $requestEnv = (Singular_Core::_('Environment')->isAdminRequest()) ? 'admin' : 'frontend';
        $scriptPath = $requestEnv . "/form/{$name}.phtml";
        $paths = $this->getView()->getScriptPaths();

        $scriptIsExists = false;
        foreach ($paths as $path) {
            if (file_exists($path . $scriptPath)) {
                $scriptIsExists = true;
            }
        }

        if ($scriptIsExists) {
            $this->addDecorators(
                array(
                     array('ViewScript', array(
                         'viewScript' => $scriptPath,
                         'placement' => false
                     )),
                     array('FormElements')
                )
            );
        }
    }

    /**
     * Set element label
     *
     * @param  string $label
     * @return Zend_Form_Element
     */
    public function setLabel ($label)
    {
        $this->_label = (string)$label;
        return $this;
    }

    /**
     * Retrieve element label
     *
     * @return string
     */
    public function getLabel ()
    {
        $translator = $this->getTranslator();
        if (null !== $translator) {
            return $translator->translate($this->_label);
        }

        return $this->_label;
    }
}
