<?php
/**
 * Singular
 *
 * LICENSE
 *
 * The SOFTWARE PRODUCT is protected by copyright treaties,
 * as well as other intellectual property laws and treaties.
 * The SOFTWARE PRODUCT is licensed, not sold.
 * Software.
 * You may install and use one copy of the SOFTWARE PRODUCT
 * for each license purchased or if a site license then you
 * may install any number of copies at the site where the
 * site license is defined.
 * Your rights to use the SOFTWARE PRODUCT are not transferable.
 *
 * @category   Singular
 * @package    Singular_Acl
 * @subpackage Writer
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */

 /**
 * @category   Singular
 * @package    Singular_Log
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */
class Singular_Log_Writer_Twitter extends Zend_Log_Writer_Abstract
{
    /**
     * Username
     * 
     * @var string
     */
    protected $_username;

    /**
     * Password
     * 
     * @var string
     */
    protected $_password;

    /**
     * Formatter
     *
     * @var Zend_Log_Formatter_Simple
     */
    protected $_formatter;

    /**
     * Twitter service instance
     *
     * @var Zend_Service_Twitter
     */
    protected $_twitter;

    /**
     * Constructor
     * 
     * @param string $username
     * @param string $password
     * @return void
     */
    public function __construct ($username, $password)
    {
        $this->_username = $username;
        $this->_password = $password;
        $this->_formatter = new Zend_Log_Formatter_Simple();
    }

    /**
     * Construct a Zend_Log driver
     *
     * @param  array|Zend_Config $config
     * @return Zend_Log_FactoryInterface
     */
    static public function factory($config)
    {
        
    }
    
    /**
     * Get twitter service
     *
     * @return Zend_Service_Twitter
     */
    protected function _getTwitter ()
    {
        if (null === $this->_twitter) {
            $this->_twitter = new Zend_Service_Twitter($this->_username, $this->_password);
            $response = $this->_twitter->account->verifyCredentials();
            if ($response->isError()) {
                throw new Zend_Log_Exception('Provided credentials for Twitter log writer are wrong');
            }
        }
        return $this->_twitter;
    }

    /**
     * Writing status
     *
     * @param string $event
     */
    protected function _write($event)
    {
        /// format event
        $line = $this->_formatter->format($event);

        /// write status
        $this->_getTwitter()->status->update($line);
    }
}