<?php
class Singular_Stdlib_ArrayToXML
{
    /**
     * Converts php native array to xml
     *
     * @static
     * @param  array $data
     * @param  string $startElement
     * @return string
     */
    public static function toXml ($data, $startElement = 'root')
    {
        $xml = new XmlWriter();
        $xml->openMemory();
        $xml->startDocument('1.0', 'UTF-8');
        $xml->startElement($startElement);

        self::_xmlWrite($xml, $data);

        $xml->endElement();

        return $xml->outputMemory(true);
    }

    protected static function _xmlWrite (XMLWriter $xml, $data)
    {
        foreach ($data as $key => $value) {
            if (is_array($value)) {
                $xml->startElement($key);
                self::_xmlWrite($xml, $value);
                $xml->endElement();
                continue;
            }
            $xml->writeElement($key, $value);
        }
    }
}
