<?php

class Singular_Taxonomy_Cluster_Structure
{
    /**
     * @var Zend_Config
     */
    protected $_structure;

    public function __construct ($structure = null,
        $allowModifications = true,
        $asXml = false)
    {
        if (null !== $structure) {
            $this->setStructure($structure, $allowModifications, $asXml);
            return;
        }
        
        // initial config structure
        $this->_structure = new Zend_Config(
            array(),
            true
        );
    }

    public function setStructure ($structure,
        $allowModifications = true,
        $asXml = false)
    {
        if ($structure instanceof Zend_Config) {
            $this->_structure = $structure;
        } elseif (is_array($structure)) {
            $this->_structure = new Zend_Config($structure,
                (bool) $allowModifications);
        } elseif (is_string($structure) && true === (bool) $asXml) {
            $this->_structure = new Zend_Config_Xml($structure,
                null,
                array('allowModifications' => (bool) $allowModifications)
            );
        } else {
            throw new Singular_Taxonomy_Cluster_Exception('Structure parameter must be an array, instance of Zend_Config or null. ' . gettype($structure) . ' was given.');
        }
    }

    /**
     * Get cluster structure
     *
     * Returns array if $asArray = true, Zend_Config object by default
     *
     * @param bool $asArray
     * @return array|Zend_Config
     */
    public function getStructure ($asArray = false)
    {
        $structure = $this->_structure;
        
        return (true === (bool) $asArray)
                ? $structure->toArray()
                : $structure;
    }

    public function addFieldIntoClusterRoot ($field, $value = null)
    {
        $this->getStructure()->{$field} = $value;

        return $this;
    }
}
