<?php

/**

 * Singular

 *

 * LICENSE

 *

 * The SOFTWARE PRODUCT is protected by copyright treaties,

 * as well as other intellectual property laws and treaties.

 * The SOFTWARE PRODUCT is licensed, not sold.

 * Software.

 * You may install and use one copy of the SOFTWARE PRODUCT

 * for each license purchased or if a site license then you

 * may install any number of copies at the site where the

 * site license is defined.

 * Your rights to use the SOFTWARE PRODUCT are not transferable.

 *

 * @category   Singular

 * @package    Singular_Timer

 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)

 */



 /**

 * @category   Singular

 * @package    Singular_Timer

 * @throws     Singular_Timer_Exception

 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)

 */

class Singular_Timer

{

    /**

     * Round

     *

     * @var int

     */

    private static $_round = 3;



    /**

     * Timers storage

     *

     * @var array

     */

    private static $_storage = array();



    /**

     * Start method

     *

     * @param string $name

     */

    public static function start ($name)

    {

        self::_startTimer($name);

    }



    /**

     * Stop method

     *

     * @param string $name

     */

    public static function stop ($name)

    {

        self::_stopTimer($name);

    }



    /**

     * Retrive different time

     * 

     * @param string $name

     * @return string

     */

    public static function total ($name)

    {

        return self::_different($name);

    }



    /**

     * Start timer

     *

     * @param string $name

     */

    private static function _startTimer ($name)

    {

        $params = array('start'    => self::_microtime(),

                        'end'      => null);

        

        if (array_key_exists($name, self::$_storage)) {

            throw new Singular_Timer_Exception("Timer with name '$name' is already exists");

        } else {

            self::$_storage[$name] = $params;

        }

    }



    /**

     * Stop timer

     *

     * @param string $name

     */

    private static function _stopTimer ($name)

    {

        if (!array_key_exists($name, self::$_storage)) {

            throw new Singular_Timer_Exception("Timer with name '$name' is not exists");

        } else {

            self::$_storage[$name]['end'] = self::_microtime();

        }

    }



    /**

     * Retrieve different time

     *

     * @param string $name

     * @return string

     */

    private static function _different ($name)

    {

        if (!array_key_exists($name, self::$_storage)) {

            throw new Singular_Timer_Exception("Timer with name '$name' is not exists");

        } else {

            $start = self::$_storage[$name]['start'];

            $end = self::$_storage[$name]['end'];

            return sprintf('%2.' . self::$_round . 'f', $end - $start);

        }

    }



    /**

     * Retrive current microtime

     *

     * @return int

     */

    private static function _microtime ()

    {

        $time = microtime(true);

        return $time;

    }

}
