<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    System_Validate
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * @category   Singular
 * @package    System_Validate
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_Validate_EqualInputs extends Zend_Validate_Abstract
{
    const NOT_EQUAL = 'stringsNotEqual';

    protected $_messageTemplates = array(
        self::NOT_EQUAL => 'Strings are not equal'
    );

    protected $_contextKey;

    public function __construct ($key)
    {
        $this->_contextKey = $key;
    }

    public function isValid ($value, $context = null)
    {        
        $value = (string) $value;

        if (is_array($context)) {
            if (isset($context[$this->_contextKey]) && (
                $value === $context[$this->_contextKey])
            ) {
                return true;
            }
        } else {
            if (is_string($context) && ($value === $context))  {
                return true;
            }
        }
        
        $this->_error(self::NOT_EQUAL);

        return false;
    }
}
