<?php



class Singular_Validate_Password extends Zend_Validate_Abstract

{  

    const INVALID        = 'passwordInvalid';

    const INVALID_LENGTH = 'passwordBadLength';

    const MIN_LEN        = 6;

    const MAX_LEN        = 32;

    

    protected $_messageTemplates = array(

        self::INVALID        => 'Value does not appear to be a valid password',

        self::INVALID_LENGTH => 'Value should have more than 6 and less then 32 symbols'

    );



    public function isValid ($value)

    {

        $this->_setValue($value);

        $validatorStringLength = new Zend_Validate_StringLength(self::MIN_LEN, self::MAX_LEN);

        $errors = false;



        if (!preg_match('/^[~!@#\\$%\\^&\\*\\(\\)\\-_\\+=\\\\\/\\{\\}\\[\\].,\\?<>:;a-z0-9]*$/i', $value)) {

            $this->_error(self::INVALID);

            $errors = true;

        }



        if (!$validatorStringLength->isValid($value)) {

            $this->_error(self::INVALID_LENGTH);

            $errors = true;

        }



        return $errors ? false : true;

    }

}



