<?php



class Singular_Validate_Text_Password extends Zend_Validate_Abstract

{  

    const INVALID = 'passwordInvalid';

    

    const INVALID_LENGTH = 'passwordBadLength';    

    

    protected $_messageTemplates = array(

        self::INVALID => 'Value does not appear to be a valid password',

        self::INVALID_LENGTH => 'Value should have more than 6 and less then 30 symbols'

    );



    public function isValid ($value)

    {

        $this->_setValue($value);

        $validatorStringLength = new Zend_Validate_StringLength(5, 32);

        

        if (!preg_match("/^[~!@#\\$%\\^&\\*\\(\\)\\-_\\+=\\\\\/\\{\\}\\[\\].,\\?<>:;a-z0-9]*$/i", $value)) {

            $this->_error(self::INVALID);

            return false;            

        } else {

            if (!$validatorStringLength->isValid($value)) {

                $this->_error(self::INVALID_LENGTH);

                return false;

            }

        }



        return true;

    }

}



