<?php
/**
 * Singular
 *
 * LICENSE
 *
 * The SOFTWARE PRODUCT is protected by copyright treaties,
 * as well as other intellectual property laws and treaties.
 * The SOFTWARE PRODUCT is licensed, not sold.
 * Software.
 * You may install and use one copy of the SOFTWARE PRODUCT
 * for each license purchased or if a site license then you
 * may install any number of copies at the site where the
 * site license is defined.
 * Your rights to use the SOFTWARE PRODUCT are not transferable.
 *
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */

 /**
 * @category   Singular
 * @package    Singular_View
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */
class Singular_View_Helper_Acl
{
    /**
     * @var Singular_Acl
     */
    private $_acl = null;

    private $_role = null;
    
    /**
     * Check access
     * 
     * @return Singular_View_Helper_Acl
     */
	public function acl ()
    {
        // Set ACL
        $this->_acl = Singular_Runtime::extract('acl');
        
        // Set role
        $this->_role = $this->_acl->getCurrentRole();

        return $this;
	}

    public function objectIsAllowed ($resource, $privileges = null)
    {
        return $this->_acl->isAllowed($this->_role,
                                      Singular_Acl::RESOURCE_TYPE_OBJECT
                                      . Singular_Acl::TYPE_DIVIDER
                                      . $resource,
                                      $privileges);
    }

    public function hasResource ($resource)
    {
        return $this->_acl->has($resource);
    }
}
