<?php
/**
 * Singular
 *
 * LICENSE
 *
 * The SOFTWARE PRODUCT is protected by copyright treaties,
 * as well as other intellectual property laws and treaties.
 * The SOFTWARE PRODUCT is licensed, not sold.
 * Software.
 * You may install and use one copy of the SOFTWARE PRODUCT
 * for each license purchased or if a site license then you
 * may install any number of copies at the site where the
 * site license is defined.
 * Your rights to use the SOFTWARE PRODUCT are not transferable.
 *
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */

 /**
 * @category   Singular
 * @package    Singular_View
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */
class Singular_View_Helper_Auth extends Zend_View_Helper_Abstract
{
    /**
     * @var Zend_Auth
     */
    protected $_auth = null;

    /**
     * Get auth info
     *
     * @param string $field
     * @return mixed
     */
    public function auth ($field = null)
    {
        $this->_auth = Zend_Auth::getInstance();

        if ($this->hasIdentity()) {
            if (null !== $field) {
                return $this->getField($field);
            }
        }

        return $this;
    }

    public function getFullName ()
    {
        $firstName = $this->getField('first_name');
        $lastName = $this->getField('last_name');

        $fullName = "{$firstName} {$lastName}";

        if ('' == trim($fullName)) {
            $fullName = $this->getField('email');
        }

        return $fullName;
    }

    public function getField ($field)
    {
        return $this->_auth->getIdentity()->$field;
    }

    public function hasIdentity ()
    {
        return $this->_auth->hasIdentity();
    }
}

