<?php
/**
 * Singular
 *
 * LICENSE
 *
 * The SOFTWARE PRODUCT is protected by copyright treaties,
 * as well as other intellectual property laws and treaties.
 * The SOFTWARE PRODUCT is licensed, not sold.
 * Software.
 * You may install and use one copy of the SOFTWARE PRODUCT
 * for each license purchased or if a site license then you
 * may install any number of copies at the site where the
 * site license is defined.
 * Your rights to use the SOFTWARE PRODUCT are not transferable.
 *
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */

 /**
 * @category   Singular
 * @package    Singular_View
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */
class Zend_View_Helper_Byteformat
{
    /**
     * Convert to byty format
     *
     * @param int $bytes
     * @return string
     */
    public function byteformat ($bytes)
    {
        $orig = $bytes;
        $ext = array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
        $unitCount = 0;
        for(; $bytes > 1024; $unitCount++) $bytes /= 1024;
        $human1 = sprintf("%s %s", round($bytes, 2), $ext[$unitCount]);
        $human2 = sprintf("%s %s", $orig, $ext[0]);

        return $human1 == $human2 ? $human1 : sprintf("%s (%s)", $human1, $human2);
    }
}
