<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * HtmlComment view helper
 *
 * @uses       Zend_View_Helper_Abstract
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_View_Helper_HtmlComment extends Zend_View_Helper_Abstract
{
    /**
     * Disable comments flag
     *
     * @var bool
     */
    private static $_disabled = false;

    /**
     * Retrieve text as html comment
     *
     * @param  text $text
     * @return string
     */
    public function htmlComment ($text)
    {
        if (self::$_disabled) return;
        
        return "<!-- {$text} -->" . PHP_EOL;
    }

    /**
     * Globally disable all comments
     * 
     * @static
     * @return void
     */
    public static function disableAllComments ()
    {
        self::$_disabled = true;
    }
}
