<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 */

/**
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 */

/**
 * Helper for making active links
 *
 * @example
 * <a href="<link>"
 * <?php if ($this->isActive('module:controller:action', 'module:controller', 'module') ?>
 * class="active"<? endif ?>>anhor</a>
 */
class Singular_View_Helper_IsActive extends Zend_View_Helper_Abstract
{
    public function isActive ()
    {
        $request = Zend_Controller_Front::getInstance()->getRequest();
        $module = $request->getParam('module');
        $controller = $request->getParam('controller');
        $action = $request->getParam('action');

        foreach (func_get_args() as $place) {
            $current_place = $module;
            if (2 == substr_count($place, ':')) {
                $current_place .= ':' . $controller . ':' . $action;
            } else if (1 == substr_count($place, ':')) {
                $current_place .= ':' . $controller;
            }
            if ($current_place == $place) {
                return true;
            }
        }
        return false;
    }
}
