<?php
/**
 *=BEGIN SINGULAR CORE NEW BSD
 *
 * This file is part of the SingularCore.
 *
 * Copyright(c) 2010-2011, USWebStyle, LLC.
 * http://www.singularcore.com/
 *
 * This source file is subject to the new BSD license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.singularcore.com/license
 *
 *=END SINGULAR CORE NEW BSD
 *
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle)
 * @license    http://www.singularcore.com/license     New BSD License
 */

/**
 * Helper to access to sidebar
 *
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 * @see        Singular_View_Helper_Abstract
 * @see        Singular_Controller_Action_Helper_Sidebar
 * @copyright  Copyright (c) 2011 USWebStyle, LLC. (http://www.uswebstyle.com)
 * @license    http://www.singularcore.com/license     New BSD License
 */
class Singular_View_Helper_Sidebar extends Singular_View_Helper_Abstract
{
    /**
     * Manipulates sidebar by given name
     *
     * @see    Singular_Controller_Action_Helper_Sidebar
     * @param  string $name
     * @return Singular_Controller_Action_Helper_Sidebar
     */
    public function sidebar ($name)
    {
        $helper = Zend_Controller_Action_HelperBroker::getStaticHelper('Sidebar')
                ->direct($name);
        
        return $helper;
    }
}
