<?php
/**
 * Singular
 *
 * LICENSE
 *
 * The SOFTWARE PRODUCT is protected by copyright treaties,
 * as well as other intellectual property laws and treaties.
 * The SOFTWARE PRODUCT is licensed, not sold.
 * Software.
 * You may install and use one copy of the SOFTWARE PRODUCT
 * for each license purchased or if a site license then you
 * may install any number of copies at the site where the
 * site license is defined.
 * Your rights to use the SOFTWARE PRODUCT are not transferable.
 *
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */

 /**
 * @category   Singular
 * @package    Singular_View
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */
class Singular_View_Helper_T
{
    /**
     * Translate a message
     * You can give multiple params or an array of params.
     * If you want to output another locale just set it as last single parameter
     * Example 1: translate('%1\$s + %2\$s', $value1, $value2, $locale);
     * Example 2: translate('%1\$s + %2\$s', array($value1, $value2), $locale);
     *
     * @param  string $key Id of the message to be translated
     * @return string message
     */
    public function t ($key)
    {
        /** @var $translator Singular_Translate */
        $translator = Singular_Runtime::extract('Zend_Translate');
        if (null === $translator) {
            return $key;
        }
        
        $options = func_get_args();

        array_shift($options);
        $count = count($options);

        $locale = null;
        if ($count > 0) {
            if (Zend_Locale::isLocale($options[($count - 1)], null, false) !== false) {
                $locale = array_pop($options);
            }
        }

        if ((count($options) === 1) and (is_array($options[0]) === true)) {
            $options = $options[0];
        }

        if ($translator !== null) {
            $key = $translator->translate($key, $locale);
        }

        if (count($options) === 0) {
            return $key;
        }

        /* when $options[0] is array and contains replaces pairs */
        if (is_array($options) && !is_int(key($options))) {
            $rplc = $options;
            foreach ($rplc as $rKey => $rVal) {
                if (!is_numeric($rKey)) {
                    $rplc[":{$rKey}"] = $rVal;
                    unset($rplc[$rKey]);
                }
            }
            return strtr($key, $rplc);
        }
        
        return vsprintf($key, $options);
    }
}
