<?php

/**
 * Singular
 *
 * LICENSE
 *
 * The SOFTWARE PRODUCT is protected by copyright treaties,
 * as well as other intellectual property laws and treaties.
 * The SOFTWARE PRODUCT is licensed, not sold.
 * Software.
 * You may install and use one copy of the SOFTWARE PRODUCT
 * for each license purchased or if a site license then you
 * may install any number of copies at the site where the
 * site license is defined.
 * Your rights to use the SOFTWARE PRODUCT are not transferable.
 *
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */

 /**
 * @category   Singular
 * @package    Singular_View
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */
class Singular_View_Helper_Truncate extends Zend_View_Helper_Abstract
{
    /**
     * Truncate string
     *
     * @param  string  $string
     * @param  int     $length
     * @param  string  $postfix
     * @return string
     */
    public function truncate ($string, $length = 50, $postfix = '...')
    {
        $truncated = trim($string);

        if (null === $string) {
            return $truncated;
        }

        $fullLength = mb_strlen($truncated, 'utf-8');

        if ($fullLength > $length) {
            $truncated = trim(mb_substr($truncated, 0, $length, 'utf-8')) . $postfix;
        }

        return $truncated;
    }
}

