<?php
/**
 * Singular
 *
 * LICENSE
 *
 * The SOFTWARE PRODUCT is protected by copyright treaties,
 * as well as other intellectual property laws and treaties.
 * The SOFTWARE PRODUCT is licensed, not sold.
 * Software.
 * You may install and use one copy of the SOFTWARE PRODUCT
 * for each license purchased or if a site license then you
 * may install any number of copies at the site where the
 * site license is defined.
 * Your rights to use the SOFTWARE PRODUCT are not transferable.
 *
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */

 /**
 * @category   Singular
 * @package    Singular_View
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */
class Singular_View_Helper_Url extends Zend_View_Helper_Url
{
    /**
     * Generates an url given the name of a route.
     *
     * @access public
     *
     * @param  array $urlOptions Options passed to the assemble method of the Route object.
     * @param  mixed $name The name of a Route to use. If null it will use the current Route
     * @param  bool $reset Whether or not to reset the route defaults with those provided
     * @param  bool $encode
     * @return string Url for the link href attribute.
     */
    public function url (array $urlOptions = array(), $name = null, $reset = false, $encode = true, $withoutGetParams = false)
    {
        $url = parent::url($urlOptions, $name, $reset, $encode);

        if ($withoutGetParams) {
            $requestUri = Zend_Controller_Front::getInstance()
                ->getRequest()->getRequestUri();

            $query = parse_url($requestUri, PHP_URL_QUERY);

            if ($query) {
                $url = $url . '?' . $query;
            }
        }
        
        return $url;
    }
}
