<?php
/**
 * Singular
 *
 * LICENSE
 *
 * The SOFTWARE PRODUCT is protected by copyright treaties,
 * as well as other intellectual property laws and treaties.
 * The SOFTWARE PRODUCT is licensed, not sold.
 * Software.
 * You may install and use one copy of the SOFTWARE PRODUCT
 * for each license purchased or if a site license then you
 * may install any number of copies at the site where the
 * site license is defined.
 * Your rights to use the SOFTWARE PRODUCT are not transferable.
 *
 * @category   Singular
 * @package    Singular_View
 * @subpackage Helper
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */

/**
 * @category   Singular
 * @package    Singular_View
 * @copyright  Copyright (c) 2010 Zenonis. (http://www.zenonis.com)
 */
class Singular_View_Helper_User extends Zend_View_Helper_Abstract
{
    /**
     * User id
     * 
     * @var int|null
     */
    protected $_id = null;

    /**
     * Users model
     * 
     * @var Singular_Core_System_Model_DbTable_Users
     */
    private $_model = null;

    /**
     * User helper proxy
     *
     * @param  int|null $id
     * @return Singular_View_Helper_User
     */
    public function user ($id = null)
    {
        if (null !== $id) {
            $this->setId($id);
        }

        $this->_initModel();

        return $this;
    }

    /**
     * Sets user id
     *
     * @throws Zend_View_Exception
     * @param  int $id
     * @return Singular_View_Helper_User
     */
    public function setId ($id)
    {
        if (!is_numeric($id)) {
            throw new Zend_View_Exception(
                'Incorrect argument: $id must be an integer'
            );
        }

        $this->_id = $id;

        return $this;
    }

    public function getUsername ()
    {
        return $this->_model->getRowById($this->_id)->username;
    }

    public function getModel ()
    {
        return $this->_model;
    }

    protected function _initModel ()
    {
        $this->_model = new Singular_Core_System_Model_DbTable_Users();
    }
}
