<?php
if (get_magic_quotes_gpc()) {
    function stripslashes_gpc(&$value)
    {
        $value = stripslashes($value);
    }
    array_walk_recursive($_GET, 'stripslashes_gpc');
    array_walk_recursive($_POST, 'stripslashes_gpc');
    array_walk_recursive($_COOKIE, 'stripslashes_gpc');
    array_walk_recursive($_REQUEST, 'stripslashes_gpc');
}

if (!function_exists('mb_substr')) {
    function mb_substr ($str, $start, $length = null, $encoding = null)
    {
        return substr($str, $start, $length = null);
    }
}

if (!function_exists('mb_ucfirst')) {
    function mb_ucfirst($str, $enc = 'utf-8')
    {
        return mb_strtoupper(mb_substr($str, 0, 1, $enc), $enc) . mb_substr(
            $str, 1, mb_strlen($str, $enc), $enc
        );
    }
}

if (!function_exists('get_called_class')) {
    function get_called_class($bt = false, $l = 1)
    {
        if (!$bt) {
            $bt = debug_backtrace();
        }
        if (!isset($bt[$l])) {
            throw new Exception("Cannot find called class -> stack level too deep.");
        }
        if (!isset($bt[$l]['type'])) {
            throw new Exception ('type not set');
        } else {
            switch ($bt[$l]['type']) {
                case '::':
                    $lines = file($bt[$l]['file']);
                    $i = 0;
                    $callerLine = '';
                    do {
                        $i++;
                        $callerLine
                            = $lines[$bt[$l]['line'] - $i] . $callerLine;
                    } while (
                        stripos($callerLine, $bt[$l]['function']) === false);
                    preg_match(
                        '/([a-zA-Z0-9\_]+)::' . $bt[$l]['function'] . '/',
                        $callerLine,
                        $matches
                    );
                    if (!isset($matches[1])) {
                        // must be an edge case.
                        throw new Exception ("Could not find caller class: originating method call is obscured.");
                    }
                    switch ($matches[1]) {
                        case 'self':
                        case 'parent':
                            return get_called_class($bt, $l + 1);
                        default:
                            return $matches[1];
                    }
                // won't get here.
                case '->':
                    switch ($bt[$l]['function']) {
                        case '__get':
                            // edge case -> get class of calling object
                            if (!is_object(
                                $bt[$l]['object']
                            )
                            ) {
                                throw new Exception ("Edge case fail. __get called on non object.");
                            }
                            return get_class($bt[$l]['object']);
                        default:
                            return $bt[$l]['class'];
                    }

                default:
                    throw new Exception ("Unknown backtrace method type");
            }
        }
    }
}

if (!function_exists('apache_request_headers')) {
    eval('
        function apache_request_headers() {
            foreach($_SERVER as $key=>$value) {
                if (substr($key,0,5)=="HTTP_") {
                    $key=str_replace(" ","-",ucwords(strtolower(str_replace("_"," ",substr($key,5)))));
                    $out[$key]=$value;
                }
            }
            return $out;
        }
    ');
}

if (!function_exists('apache_response_headers')) {
    function apache_response_headers ()
    {
        $arh = array(
        );
        $headers = headers_list();
        foreach ($headers as $header) {
            $header = explode(":", $header);
            $arh[array_shift($header)] = trim(implode(":", $header));
        }
        return $arh;
    }
}

function file_mime_content_type($filename)
{
    // Sanity check
    if (!file_exists($filename)) {
        return false;
    }

    $filename = escapeshellarg($filename);
    $out = `file -iL $filename 2>/dev/null`;
    if (empty($out)) {
        return 'application/octet-stream';
    }
    // Strip off filename
    $t = substr($out, strpos($out, ':') + 2);
    if (strpos($t, ';') !== false) {
        // Strip MIME parameters
        $t = substr($t, 0, strpos($t, ';'));
    }
    // Strip any remaining whitespace
    return trim($t);
}

/**
 * Returns file mime type.
 *
 * @param string $filename
 *
 * @return string|bool
 */
function get_file_mime_type ($filename)
{
    $types = array(
        'application/envoy'                       => 'evy',
        'application/fractals'                    => 'fif',
        'application/futuresplash'                => 'spl',
        'application/hta'                         => 'hta',
        'application/internet-property-stream'    => 'acx',
        'application/mac-binhex40'                => 'hqx',
        'application/msword'                      => 'doc',
        'application/msword'                      => 'dot',
        'application/octet-stream'                => '*',
        'application/octet-stream'                => 'bin',
        'application/octet-stream'                => 'class',
        'application/octet-stream'                => 'dms',
        'application/octet-stream'                => 'exe',
        'application/octet-stream'                => 'lha',
        'application/octet-stream'                => 'lzh',
        'application/oda'                         => 'oda',
        'application/olescript'                   => 'axs',
        'application/pdf'                         => 'pdf',
        'application/pics-rules'                  => 'prf',
        'application/pkcs10'                      => 'p10',
        'application/pkix-crl'                    => 'crl',
        'application/postscript'                  => 'ai',
        'application/postscript'                  => 'eps',
        'application/postscript'                  => 'ps',
        'application/rtf'                         => 'rtf',
        'application/set-payment-initiation'      => 'setpay',
        'application/set-registration-initiation' => 'setreg',
        'application/vnd.ms-excel'                => 'xla',
        'application/vnd.ms-excel'                => 'xlc',
        'application/vnd.ms-excel'                => 'xlm',
        'application/vnd.ms-excel'                => 'xls',
        'application/vnd.ms-excel'                => 'xlt',
        'application/vnd.ms-excel'                => 'xlw',
        'application/vnd.ms-outlook'              => 'msg',
        'application/vnd.ms-pkicertstore'         => 'sst',
        'application/vnd.ms-pkiseccat'            => 'cat',
        'application/vnd.ms-pkistl'               => 'stl',
        'application/vnd.ms-powerpoint'           => 'pot',
        'application/vnd.ms-powerpoint'           => 'pps',
        'application/vnd.ms-powerpoint'           => 'ppt',
        'application/vnd.ms-project'              => 'mpp',
        'application/vnd.ms-works'                => 'wcm',
        'application/vnd.ms-works'                => 'wdb',
        'application/vnd.ms-works'                => 'wks',
        'application/vnd.ms-works'                => 'wps',
        'application/winhlp'                      => 'hlp',
        'application/x-bcpio'                     => 'bcpio',
        'application/x-cdf'                       => 'cdf',
        'application/x-compress'                  => 'z',
        'application/x-compressed'                => 'tgz',
        'application/x-cpio'                      => 'cpio',
        'application/x-csh'                       => 'csh',
        'application/x-director'                  => 'dcr',
        'application/x-director'                  => 'dir',
        'application/x-director'                  => 'dxr',
        'application/x-dvi'                       => 'dvi',
        'application/x-gtar'                      => 'gtar',
        'application/x-gzip'                      => 'gz',
        'application/x-hdf'                       => 'hdf',
        'application/x-internet-signup'           => 'ins',
        'application/x-internet-signup'           => 'isp',
        'application/x-iphone'                    => 'iii',
        'application/x-javascript'                => 'js',
        'application/x-latex'                     => 'latex',
        'application/x-msaccess'                  => 'mdb',
        'application/x-mscardfile'                => 'crd',
        'application/x-msclip'                    => 'clp',
        'application/x-msdownload'                => 'dll',
        'application/x-msmediaview'               => 'm13',
        'application/x-msmediaview'               => 'm14',
        'application/x-msmediaview'               => 'mvb',
        'application/x-msmetafile'                => 'wmf',
        'application/x-msmoney'                   => 'mny',
        'application/x-mspublisher'               => 'pub',
        'application/x-msschedule'                => 'scd',
        'application/x-msterminal'                => 'trm',
        'application/x-mswrite'                   => 'wri',
        'application/x-netcdf'                    => 'cdf',
        'application/x-netcdf'                    => 'nc',
        'application/x-perfmon'                   => 'pma',
        'application/x-perfmon'                   => 'pmc',
        'application/x-perfmon'                   => 'pml',
        'application/x-perfmon'                   => 'pmr',
        'application/x-perfmon'                   => 'pmw',
        'application/x-pkcs12'                    => 'p12',
        'application/x-pkcs12'                    => 'pfx',
        'application/x-pkcs7-certificates'        => 'p7b',
        'application/x-pkcs7-certificates'        => 'spc',
        'application/x-pkcs7-certreqresp'         => 'p7r',
        'application/x-pkcs7-mime'                => 'p7c',
        'application/x-pkcs7-mime'                => 'p7m',
        'application/x-pkcs7-signature'           => 'p7s',
        'application/x-sh'                        => 'sh',
        'application/x-shar'                      => 'shar',
        'application/x-shockwave-flash'           => 'swf',
        'application/x-stuffit'                   => 'sit',
        'application/x-sv4cpio'                   => 'sv4cpio',
        'application/x-sv4crc'                    => 'sv4crc',
        'application/x-tar'                       => 'tar',
        'application/x-tcl'                       => 'tcl',
        'application/x-tex'                       => 'tex',
        'application/x-texinfo'                   => 'texi',
        'application/x-texinfo'                   => 'texinfo',
        'application/x-troff'                     => 'roff',
        'application/x-troff'                     => 't',
        'application/x-troff'                     => 'tr',
        'application/x-troff-man'                 => 'man',
        'application/x-troff-me'                  => 'me',
        'application/x-troff-ms'                  => 'ms',
        'application/x-ustar'                     => 'ustar',
        'application/x-wais-source'               => 'src',
        'application/x-x509-ca-cert'              => 'cer',
        'application/x-x509-ca-cert'              => 'crt',
        'application/x-x509-ca-cert'              => 'der',
        'application/ynd.ms-pkipko'               => 'pko',
        'application/zip'                         => 'zip',
        'audio/basic'                             => 'au',
        'audio/basic'                             => 'snd',
        'audio/mid'                               => 'mid',
        'audio/mid'                               => 'rmi',
        'audio/mpeg'                              => 'mp3',
        'audio/x-aiff'                            => 'aif',
        'audio/x-aiff'                            => 'aifc',
        'audio/x-aiff'                            => 'aiff',
        'audio/x-mpegurl'                         => 'm3u',
        'audio/x-pn-realaudio'                    => 'ra',
        'audio/x-pn-realaudio'                    => 'ram',
        'audio/x-wav'                             => 'wav',
        'image/bmp'                               => 'bmp',
        'image/cis-cod'                           => 'cod',
        'image/gif'                               => 'gif',
        'image/ief'                               => 'ief',
        'image/jpeg'                              => 'jpe',
        'image/jpeg'                              => 'jpeg',
        'image/jpeg'                              => 'jpg',
        'image/png'                               => 'png',
        'image/pipeg'                             => 'jfif',
        'image/svg+xml'                           => 'svg',
        'image/tiff'                              => 'tif',
        'image/tiff'                              => 'tiff',
        'image/x-cmu-raster'                      => 'ras',
        'image/x-cmx'                             => 'cmx',
        'image/x-icon'                            => 'ico',
        'image/x-portable-anymap'                 => 'pnm',
        'image/x-portable-bitmap'                 => 'pbm',
        'image/x-portable-graymap'                => 'pgm',
        'image/x-portable-pixmap'                 => 'ppm',
        'image/x-rgb'                             => 'rgb',
        'image/x-xbitmap'                         => 'xbm',
        'image/x-xpixmap'                         => 'xpm',
        'image/x-xwindowdump'                     => 'xwd',
        'message/rfc822'                          => 'mht',
        'message/rfc822'                          => 'mhtml',
        'message/rfc822'                          => 'nws',
        'text/css'                                => 'css',
        'text/h323'                               => '323',
        'text/html'                               => 'htm',
        'text/html'                               => 'html',
        'text/html'                               => 'stm',
        'text/iuls'                               => 'uls',
        'text/plain'                              => 'bas',
        'text/plain'                              => 'c',
        'text/plain'                              => 'h',
        'text/plain'                              => 'txt',
        'text/richtext'                           => 'rtx',
        'text/scriptlet'                          => 'sct',
        'text/tab-separated-values'               => 'tsv',
        'text/webviewhtml'                        => 'htt',
        'text/x-component'                        => 'htc',
        'text/x-setext'                           => 'etx',
        'text/x-vcard'                            => 'vcf',
        'video/mpeg'                              => 'mp2',
        'video/mpeg'                              => 'mpa',
        'video/mpeg'                              => 'mpe',
        'video/mpeg'                              => 'mpeg',
        'video/mpeg'                              => 'mpg',
        'video/mpeg'                              => 'mpv2',
        'video/quicktime'                         => 'mov',
        'video/quicktime'                         => 'qt',
        'video/x-la-asf'                          => 'lsf',
        'video/x-la-asf'                          => 'lsx',
        'video/x-ms-asf'                          => 'asf',
        'video/x-ms-asf'                          => 'asr',
        'video/x-ms-asf'                          => 'asx',
        'video/x-msvideo'                         => 'avi',
        'video/x-sgi-movie'                       => 'movie',
        'x-world/x-vrml'                          => 'flr',
        'x-world/x-vrml'                          => 'vrml',
        'x-world/x-vrml'                          => 'wrl',
        'x-world/x-vrml'                          => 'wrz',
        'x-world/x-vrml'                          => 'xaf',
        'x-world/x-vrml'                          => 'xof'
    );

    $ext = pathinfo($filename, PATHINFO_EXTENSION);
    if (in_array($ext, $types)) {
        return array_search($ext, $types);
    }

    return false;
}

if (!function_exists('mime_content_type')) {
    function mime_content_type ($filename)
    {
        return file_mime_content_type($filename);
    }
}

function array_key_exists_recursive ($needle, $haystack)
{
    foreach ($haystack as $key => $val)
    {
        if (is_array($val)) {
            if (array_key_exists_recursive($needle, $val)) {
                return true;
            }
        }
        elseif ($val == $needle)
        {
            return true;
        }
    }
    
    return false;
}

function is_multidimensional_array ($a)
{
    $rv = array_filter($a, 'is_array');
    if (count($rv) > 0) {
        return true;
    }

    return false;
}

function array_equal ($a, $b)
{
    return (is_array($a) && is_array($b) && array_diff($a, $b) === array_diff($b, $a));
}

function array_identical ($a, $b)
{
    return (is_array($a) && is_array($b) && array_diff_assoc($a, $b) === array_diff_assoc($b, $a));
}

function pr ($val, $return = false, $die = true)
{
    $debug_backtrace = debug_backtrace();

    $header = '<strong>Debug called from:</strong> ' . $debug_backtrace[0]['file'] . ' (line ' . $debug_backtrace[0]['line'] . ")<br />\n";
    $header .= '<strong>Memory usage:</strong> ' . memory_get_usage(true) . " bytes.<br /> \n";
    $header .= '<strong>Time spent:</strong> ' . round(microtime(true) - $_ENV['bench_initial'], 6) . " milliseconds.<br /> \n";
    $result = print_r($val, true);
    if ($return) {
        return strip_tags($header . "\n" . $return);
    }
    echo $header;
    echo "<pre>";
        echo $result;
    echo "</pre>";
    if ($die) {
        die();
    }
}

function debug_redirect ($url)
{
    $debug_backtrace = debug_backtrace();
    $file = '<strong> ' . $debug_backtrace[0]['file'] . '< /strong>';
    $line = '<strong>' . $debug_backtrace[0]['line'] . '< /strong>';

    echo '< div style="padding:15px 30px; margin:0px; text-align:center; font-size:16px; background-color:#ccc; ">Should redirect to: < a href="' . $url . '">' . $url . '< /a>< /div>';
    echo '< div style="padding:15px 30px; margin:0px; text-align:center; font-size:16px; background-color:#ccc; ">Called from ' . $file . ', line ' . $line . '< /div>';

    echo '< div style="background-color:yellow; border:1px solid red; padding:5px 10px; margin:20px 0px">';
    echo '< pre>COOKIES:';
    print_r($_COOKIE);
    echo '< /pre>';

    echo '< pre>SESSION:';
    print_r($_SESSION);
    echo '< /pre>';

    echo '< pre>SERVER:';
    print_r($_SERVER);
    echo '< /pre>';

    echo '< /div>';
    exit();
}
