(function($) {

    $.fn.tagging = function(options) {

        var el = this;

        var BACKSPACE		= 8;
        var ENTER		= 13;
        //const SPACE		= 32;
        var COMMA		= 44;

        el.addClass("tags");

        var html_input_field = "<li class=\"tags-new\"><input class=\"tags-input\" type=\"text\" /></li>\n";
        el.html (html_input_field);

        tag_input = el.children(".tags-new").children(".tags-input");

        $(this).click(function(e){
            if (e.target.tagName == 'I') {
                $(e.target).parent().remove();
            }
            else {
                tag_input.focus();
            }
        });

        tag_input.focusout(function(event){
            event.preventDefault();

            var typed = tag_input.val();
            typed = typed.replace(/,+$/,"");
            typed = typed.trim();

            if (typed != "") {
                if (is_new (typed)) {
                        create_choice (typed);
                }
                tag_input.val("");
            }
        });

        tag_input.keypress(function(event){
            if (event.which == BACKSPACE) {
                if (tag_input.val() == "") {
                    $(el).children(".tags-choice:last").remove();
                }
            }
            else if (event.which == COMMA || event.which == ENTER) {
                event.preventDefault();

                var typed = tag_input.val();
                typed = typed.replace(/,+$/,"");
                typed = typed.trim();

                if (typed != "") {
                    if (is_new (typed)) {
                            create_choice (typed);
                    }
                    tag_input.val("");
                }
            }
        });

        function is_new (value){
            var is_new = true;
            this.tag_input.parents("ul").children(".tags-choice").each(function(i){
                n = $(this).children("input").val();
                if (value == n) {
                    is_new = false;
                }
            })
            return is_new;
        }
        function create_choice (value){
            var el = "";
            el  = "<li class=\"tags-choice\">\n";
            el += "<i class=\"ico-small iclose\"></i>\n";
            el += value + "\n";
            el += "<input type=\"hidden\" style=\"display:none;\" value=\""+value+"\" name=\"tags[]\">\n";
            el += "</li>\n";
            var li_search_tags = this.tag_input.parent();
            $(el).insertBefore (li_search_tags);
            this.tag_input.val("");
        }
        
        if (typeof(options["defaultTags"]) != "undefined") {
            tags = options.defaultTags;
            for (i in tags) {
                create_choice(tags[i]);
            }
        }
        
    };

    String.prototype.trim = function() {
        return this.replace(/^\s+|\s+$/g,"");
    };

})(jQuery);
