var minH=100;
var startH=0;
var startY=0;
var textarea=null;
var textareaEditor=null;
var oldMouseMove=null;
var oldMouseUp=null;

function textareaResizer (e) {
    if (e == null) {e = window.event}
    if (e.preventDefault) {
        e.preventDefault();
    }; 
    resizer = (e.target != null) ? e.target : e.srcElement;
    textarea = document.getElementById(
      resizer.id.substr(0,resizer.id.length-8)
    );
    textareaEditor = document.getElementById(
      resizer.id.substr(0,resizer.id.length-8) + '_editor'
    );

    startY=e.clientY;
    if ($(textarea).is(":visible")) {
        startH=textarea.offsetHeight;        
    } else {
        startH=textareaEditor.offsetHeight;
    }
    
    oldMouseMove=document.onmousemove;
    oldMouseUp=document.onmouseup;
    document.onmousemove=textareaResizer_moveHandler;
    $(document).mouseup(textareaResizer_cleanup);
    return false;
}

function textareaResizer_moveHandler(e){
  if (e == null) {e = window.event} 
  if (e.button<=1){
     curH = (startH+(e.clientY-startY));
     if (curH<minH) curH = minH;
     textarea.style.height = curH + 'px';
     textareaEditor.style.height = curH + 'px';
     return false;
  }
}

function textareaResizer_cleanup(e) {
  document.onmousemove=oldMouseMove;
  document.onmouseup=oldMouseUp;
}

function editorCommand(editor, command, options) {
    content = editor.contentWindow;
    try {
        if ($.browser.msie) {
            if ('Inserthtml' == command) {
                content.document.selection.createRange().pasteHTML(options);
                return;
            }
        }

        content.focus();
        content.document.execCommand(command, false, options);
        content.focus();
    } catch (e) { }
}

function wrapTag(textArea, openTag, closeTag) {
    //IE
    if (document.selection) {
        textArea.focus();
        sel = document.selection.createRange();
        if (sel.text.length > 0) {
            sel.text = openTag + sel.text + closeTag;
        } else {
            sel.text = openTag + sel.text + closeTag;
        }
        textArea.focus();
    }
    //MOZILLA
    else if (textArea.selectionStart || textArea.selectionStart == '0') {
        startPos = textArea.selectionStart;
        endPos = textArea.selectionEnd;
        cursorPos = endPos;
        scrollTop = textArea.scrollTop;

        if (startPos != endPos) {
            textArea.value = textArea.value.substring(0, startPos)
            + openTag
            + textArea.value.substring(startPos, endPos)
            + closeTag
            + textArea.value.substring(endPos, textArea.value.length);
            cursorPos += openTag.length + closeTag.length;
        } else {

            textArea.value = textArea.value.substring(0, startPos)
            + openTag
            + textArea.value.substring(startPos, endPos)
            + closeTag
            + textArea.value.substring(endPos, textArea.value.length);
            cursorPos += openTag.length + closeTag.length;
        }
        textArea.focus();

        textArea.selectionStart = cursorPos;
        textArea.selectionEnd = cursorPos;
        textArea.scrollTop = scrollTop;
    } else {
        textArea.value += openTag + closeTag;
        textArea.focus();
    }
}
wysiwyg = {
    
    bbcodeToHtml_fn : [],
    
    bbcodeToHtml : function(txt) {
        var text = txt;
        
        text = text.replace(/&/g, "&amp;");
        text = text.replace(/</g, "&lt;");
        text = text.replace(/>/g, "&gt;");
        
        if ($.browser.msie) {
            text = "<p>" + text.replace(/\n/g, "&nbsp;</p><p>") + "</p>";
        } else {
            text = text.replace(/\n/g, "<br />");
        }
        if (this.bbcodeToHtml_fn.length > 0) {
            $.each(this.bbcodeToHtml_fn, function(idx, el) {
                text = el(text);
            });
        }
        
        text = text.replace(/\[h4\]/ig, '<h4 style="background-color:#aaaaaa; color:#ffffff; margin:-10px -18px 10px; padding: 3px 6px;">')
                   .replace(/\[\/h4\]/ig, '</h4>')
                   .replace(/\[reply user_id=([0-9]*|undefined)\]/ig, '<div user_id=$1 class="comment-reply-block">')
                   .replace(/\[\/reply\]/ig, '</div>')
                   .replace(/\[b\]/ig, '<span style="font-weight: bold;">')
                   .replace(/\[\/b\]/ig, "</span>")
                   .replace(/\[i\]/ig, '<span style="font-style: italic;">')
                   .replace(/\[\/i\]/ig, "</span>")
                   .replace(/\[u\]/ig, '<span style="text-decoration: underline;">')
                   .replace(/\[\/u\]/ig, '</span>')
                   .replace(/\[s\]/ig, '<span style="text-decoration: line-through;">')
                   .replace(/\[\/s\]/ig, "</span>")
                   .replace(/\[ul\]/ig, '<ul class="unorder">')
                   .replace(/\[\/ul\]/ig, "</ul>")
                   .replace(/\[ol\]/ig, '<ol class="order">')
                   .replace(/\[\/ol\]/ig, "</ol>")
                   .replace(/\[co\]/ig, '<ol class="source">')
                   .replace(/\[\/co\]/ig, '</ol>')
                   .replace(/\[li\]/ig, "<li>")
                   .replace(/\[\/li\]/ig, "</li>")
                   .replace(/\[img\](.*?)\[\/img\]/g, '<img src="$1" />')
                   .replace(/\[url=(.*?)](.*?)\[\/url\]/ig, '<a href="$1">$2</a>')
                   //.replace(/\[video\](.*?)\[\/video\]/g, function (_str, p1, p2) { return '<video>' + p1 + '</video>'; });
                   .replace(/\[video\](.*?)\[\/video\]/g, function (_str, p1, p2) { return '<img src="' + App.assets.common.image('video-player.png') + '" xtype="video" alt="' + p1 + '" />'; });

        return text;
    },
    
    htmlToBbcode_fn : [],
    
    htmlToBbcode : function (el) {
        var html = el.clone();
        if (typeof(html) == 'string') {
            html = $(html);
        }

        html.find('img[xtype="video"]').each(function (idx, elem) {
            var videoUrl = $(this).attr('alt');
            $(this).replaceWith('[video]' + videoUrl + '[/video]');
        });

        els = html.find('span');
        do {            
            els.each(function() {
               wysiwyg.replaceSpan(this);
            });
            els = html.find('span');
        } while (els.length > 0);

        els = html.find('div.comment-reply-block');
        do {            
            els.each(function() {
               $(this).replaceWith('[reply user_id=' + $(this).attr("user_id") + ']' + $(this).html() + '[/reply]');
            });
            els = html.find('div.comment-reply-block');
        } while (els.length > 0);

        if (this.htmlToBbcode_fn.length > 0) {
            $.each(this.htmlToBbcode_fn, function (idx, el) {
                html = el(html);
            });
        }
        if ($.browser.msie) {
            html.find('p').each(function(){
                if ($(this).html().trim() == "&nbsp;" || $(this).html().trim() == "") {
                    $(this).replaceWith("[br]");
                }
            });
        }
        html.find('p').each(function(){
             $(this).after("[br]");
        });
        html.find('a').each(function(){
            $(this).replaceWith('[url=' + $(this).attr("href") + ']' + $(this).html() + '[/url]');
        });
        html.find('img').each(function(){
            $(this).replaceWith('[img]' + $(this).attr("src") + '[/img]');
        });
        html.find('h4').each(function(){
            $(this).replaceWith('[h4]' + $(this).html() + '[/h4]');
        });
        html.find('b, strong').each(function(){
            $(this).replaceWith('[b]' + $(this).html() + '[/b]');
        });
        html.find('em, i').each(function(){
            $(this).replaceWith('[i]' + $(this).html() + '[/i]');
        });
        html.find('u').each(function(){
            $(this).replaceWith('[u]' + $(this).html() + '[/u]');
        });
        html.find('strike').each(function(){
            $(this).replaceWith('[s]' + $(this).html() + '[/s]');
        });
        html.find('div, br').each(function(){
            $(this).replaceWith("\n" + $(this).html());
        });
        html.find('ol.source').each(function(){
            $(this).replaceWith('[co]' + $(this).html() + '[/co]');
        });
        html.find('ul, ol').each(function(){
            tag = this.tagName.toLowerCase();
            $(this).replaceWith('[' + tag + ']' + $(this).html() + '[/' + tag + ']');
        });
        html.find('li').each(function(){
            tag = this.tagName.toLowerCase();
            $(this).replaceWith('[' + tag + ']' + $(this).html() + '[/' + tag + ']');
        });

        var text = html.html();
        text = text.replace(/\<div\>/g, "\n");
        text = text.replace(/\<\/div\>/g, "");
        text = text.replace(/\<br\>/g, "\n");
        text = text.replace(/\<[^\>]*\>/g, "");
        text = text.replace(/&nbsp;/g, " ");
        text = text.replace(/&amp;/g, "&");
        text = text.replace(/&lt;/g, "<");
        text = text.replace(/&gt;/g, ">");
        text = text.replace(/\[br\]/g, "\n");

        return text;
    },
    
    replaceSpan : function(el) {
        replaceOpenTags = replaceCloseTags = "";
        if (el.style.fontWeight == "bold") {
            replaceOpenTags += "[b]";
            replaceCloseTags = "[/b]" + replaceCloseTags;
        }
        if (el.style.fontStyle == "italic") {
            replaceOpenTags += "[i]";
            replaceCloseTags = "[/i]" + replaceCloseTags
        }
        if (el.style.textDecoration.indexOf("underline") >= 0) {
            replaceOpenTags += "[u]";
            replaceCloseTags = "[/u]" + replaceCloseTags
        }
        if (el.style.textDecoration.indexOf("line-through") >= 0) {
            replaceOpenTags += "[s]";
            replaceCloseTags = "[/s]" + replaceCloseTags
        }
        $(el).replaceWith(replaceOpenTags + $(el).html() + replaceCloseTags);
    }
}

function copyTo(body, textArea, n) {

    if (n == 1) {
        text = wysiwyg.htmlToBbcode(body);
        textArea.val(text);
    } else if (n == 0) {
        text = textArea.val();
        html = wysiwyg.bbcodeToHtml(text);
        body.html(html);
    }
}

var toVideoTag = function (_url) {
    var parseVideoURL = function (_url) {
        _url.match(/^(http|https):\/\/(?:.*?)\.?(youtube|vimeo)\.com\/(watch\?[^#]*v=(\w+)|(\d+)).+$/);
        return {
            provider: RegExp.$2,
            id: RegExp.$2 == 'vimeo' ? RegExp.$3 : RegExp.$4
        }
    };

    var _video = parseVideoURL(_url + '/'),
        fullyQualifiedUrl;

    if ('provider' in _video) {
        switch (_video.provider) {
            case 'youtube':
                fullyQualifiedUrl = 'http://www.youtube.com/v/' + _video.id;
                break;
            case 'vimeo':
                fullyQualifiedUrl = 'http://vimeo.com/moogaloop.swf?clip_id=' + _video.id + '&amp;force_embed=1&amp;server=vimeo.com&amp;show_title=0&amp;show_byline=0&amp;show_portrait=0&amp;color=e3d06f&amp;fullscreen=1&amp;autoplay=0&amp;loop=0';
                break;
        }
    }

    var tag = "<object classid='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' original='" + _url + "' codebase='http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0'>";
    tag += "<param name='movie' value='" + fullyQualifiedUrl + "' />";
    tag += "<embed width='100%' height='266' src='" + fullyQualifiedUrl + "' type='application/x-shockwave-flash'>";
    tag += "</embed>";
    tag += "</object>";

    return tag;
};

$("document").ready(function(){

    App.initEditor = function(textArea) {
        frame = $('<iframe name="textarea-editor" frameborder="0" src="javascript:true;" class="textarea-editor" >');
        frame.load(function(){

            body = $(this).contents().find("body");
            body.attr("contentEditable", "true");

            $(body).bind('click', function () {
            });
            
            head = $(this).contents().find("head");
            head.append('<link type="text/css" rel="stylesheet" media="screen" href="' + App.baseUrl('/public/assets/css/texteditor.css') + '">');
            
            container = $(this).parents(".description-topic");
            textarea = $(this).parents(".description-topic").find("textarea");
            copyTo(body, textarea, 0);
            textarea.hide();
            container.find(".textarea-editor").show();
            container.find(".change-view i").addClass("view-on");

            $(this).contents().click(function(){
                content = $(document.activeElement).parents(".description-topic");
                if (content.find(".allowed-codes-block").html() != void(0)) {
                    content.css("padding-top", "49px");
                    content.find(".allowed-codes-block").fadeIn();
                }
            });

            body.keyup(function(){
                textarea = $(document.activeElement).parents(".description-topic").find("textarea");
                copyTo($(this), textarea, 1);
            });

        });
        frame.attr("id", $(textArea).attr("id") + "_editor");
        $(textArea).after(frame);
    };

    $(".allowed-codes-block a.code").live("click", function() {
        var container = $(this).parents(".description-topic"),
            textArea = container.find("textarea"),
            textAreaEditor = container.find(".textarea-editor"),
            tag = $(this).find("i").attr("class"),
            viewOn = !textArea.is(":visible");
        if (viewOn) {
            editorCommand(textAreaEditor.get(0), "styleWithCSS", 'true');
        }
        switch (tag) {
            case 'bold':
                if (viewOn) {
                    editorCommand(textAreaEditor.get(0), 'bold');
                } else {
                    wrapTag(textArea.get(0), '[b]', '[/b]');
                }
                break;
            case 'italic':
                if (viewOn) {
                    editorCommand(textAreaEditor.get(0), 'italic');
                } else {
                    wrapTag(textArea.get(0), '[i]', '[/i]');
                }
                break;
            case 'underline':
                if (viewOn) {
                    editorCommand(textAreaEditor.get(0), 'underline');
                } else {
                    wrapTag(textArea.get(0), '[u]', '[/u]');
                }
                break;
            case 'strike':
                if (viewOn) {
                    editorCommand(textAreaEditor.get(0), 'StrikeThrough');
                } else {
                    wrapTag(textArea.get(0), '[s]', '[/s]');
                }
                break;
            case 'list':
                if (viewOn) {
                    editorCommand(textAreaEditor.get(0), 'InsertUnorderedList');
                    textAreaEditor.contents().find("ul").each(function() {
                        if ($(this).attr('class') == '' || $(this).attr('class') == undefined) {
                            $(this).addClass('unorder');
                        }
                    });
                } else {
                    wrapTag(textArea.get(0), '[ul][li]', '[/li][/ul]');
                }
                break;
            case 'nlist':
                if (viewOn) {
                    editorCommand(textAreaEditor.get(0), 'InsertOrderedList');
                    textAreaEditor.contents().find("ol").each(function() {
                        if ($(this).attr('class') == '' || $(this).attr('class') == undefined) {
                            $(this).addClass('order');
                        }
                    });
                } else {
                    wrapTag(textArea.get(0), '[ol][li]', '[/li][/ol]');
                }
                break;
            case 'source':
                if (viewOn) {
                    editorCommand(textAreaEditor.get(0), 'InsertOrderedList');
                    textAreaEditor.contents().find("ol").each(function(){
                        if ($(this).attr('class') == '' || $(this).attr('class') == undefined) {
                            $(this).addClass('source');
                        }
                    });
                } else {
                    wrapTag(textArea.get(0), '[co][li]', '[/li][/co]');
                }
                break;
            case 'remove-formatting':
                if (viewOn) {
                    editorCommand(textAreaEditor.get(0), 'HiliteColor', 'white');
                    editorCommand(textAreaEditor.get(0), 'RemoveFormat');
                } else {
                    return false;
                }
                break;
            case 'link':
                if (viewOn) {
                    win = textAreaEditor.get(0).contentWindow;
                    if (win.document.selection && win.document.selection.createRange) {
                        selectedText = win.document.selection.createRange().text;
                    } else if (win.document.getSelection) {
                        sel = win.document.getSelection(); 
                        if (sel.getRangeAt && sel.rangeCount) {
                            range = sel.getRangeAt(0);
                            selectedText = range.toString();
                        }
                    }
                    if (selectedText != "") {
                        regexp = new RegExp('^(https?:\/\/[^\s]+)|(www?\.[^\s]+)', 'g');
                        text = "";
                        if (selectedText.match(regexp)) {
                            text = selectedText;
                        }
                        url = prompt(App.t('Enter link address:'), text);
                        if (url) {
                            regexp = new RegExp('^(?:f|ht)tp(?:s)?\://([^/]+)', 'im');
                            if (url.match(regexp)) {
                                editorCommand(textAreaEditor.get(0), 'CreateLink', url);
                            } else {
                                alert(App.t("Link is not Valid!"));
                            }
                        }
                    } else {
                        alert(App.t("Please Select Text!"));
                    }
                } else {
                    wrapTag(textArea.get(0), '[url=]', '[/url]');
                }
                break;
            case 'image':
                if (App.hasParam('useImageUploader') && 1 == App.getParam('useImageUploader')) {
                    return;
                }
                if (viewOn) {
                    url = prompt(App.t('Enter Link Address:'));
                    if (url != null && url != "") {
                        editorCommand(textAreaEditor.get(0), 'InsertImage', url);
                        textAreaEditor.contents().find("body img").css("max-width", "100%");
                    }
                } else {
                    wrapTag(textArea.get(0), '[img]', '[/img]');
                }
                break;
            case 'video':
                if (viewOn) {
                    var url = prompt(App.t('Enter Video Link:'));
                    if (url != null && url != "") {
                        var video = toVideoTag(url);
                        if (!video || '' == video.provider) {
                            alert('Incorrect Video URL!');
                            return;
                        }
                        video = '<img src="' + App.assets.common.image('video-player.png') + '" xtype="video" alt="' + url + '" />';
                        editorCommand(textAreaEditor.get(0), 'Inserthtml', video);
                        textAreaEditor.contents().find("body object").css("max-width", "100%");
                    }
                } else {
                    wrapTag(textArea.get(0), '[video]', '[/video]');
                }
                break;
            default:
                break;
        }
        if (viewOn) {
            copyTo(textAreaEditor.contents().find("body") , textArea, 1);
        }
        return false;
    });

    $(".change-view").live("click", function(){
        if (!isEditable) {
            return false;
        }
        var container      = $(this).parents(".description-topic"),
            textarea       = container.find("textarea"),
            textareaEditor = container.find(".textarea-editor"),
            body           = textareaEditor.contents().find('body');
        
        if (textarea.is(":visible")) {
            $(this).find("i").addClass("view-on");
            copyTo(body, textarea, 0);
            textarea.hide();
            textareaEditor.show();
        } else {
            $(this).find("i").removeClass("view-on");
            textarea.show();
            textareaEditor.hide();
            copyTo(body, textarea, 1);
        }
        return false;
    });
    
    isEditable = false;
    
    if (document.getElementById && document.designMode)  {
        isEditable= true;
    }
    
    if (App.getParam('theme', 'default') == 'mobile') {
        isEditable = false;
    }
    
    if (isEditable) {
        $(".description-topic textarea").each(function(){
            App.initEditor(this);
        });
    }

    $(".resizer-wrap textarea").live("click", function(){
        content = $(this).parent().parent();
        if (content.find(".allowed-codes-block").html() != void(0)) {
            content.css("padding-top", "49px");
            content.find(".allowed-codes-block").fadeIn();
        }
    });
    
});
