App.module.extend({
    loginplus: {
        controllers: {
            admin: {
                index: function() {
                    App.onReady(function(){
                        $("#reset").click(function(){
                            $(".loginplus-form-settings .textInput input").val("<default_key>");
                        });
                    });
                }
            },
            adminSso: {
                index: function () {

                    function showSsoForm(type) {
                        $("#sso-method-wrapper .hidden-block").hide();
                        $("#sso-method-wrapper #sso-" + type).show();
                    }

                    function toggleNativeAuthBlock() {
                        var block           = $('div.native-auth-block'),
                            ssoActiveMethod = $("#sso_active_method").val();

                        if ('none' == ssoActiveMethod) {
                            block.hide();
                        } else {
                            block.show();
                        }
                    }

                    App.onReady(function () {
                        toggleNativeAuthBlock();

                        if ($("#enable_native_auth").is(':checked')) {
                            $('#toggle-reg-notification').hide();
                        }

                        $("input.error").live('keydown', function () {
                            $(this).removeClass('error');
                        });

                        $("#sso_active_method").change(function () {
                            if ($(this).find('option:selected').val() == 'none') {
                                App.remote.get(App.baseUrl() + 'admin/login-plus/sso/disable', null, function (r) {

                                });
                            }
                            toggleNativeAuthBlock();
                        });

                        $("#disable_native_auth").change(function () {
                            if ($(this).is(':checked')) {
                                $('#toggle-reg-notification').show();
                                App.remote.get(App.baseUrl() + 'admin/login-plus/sso/deactivate-native', null, function (r) {

                                });
                            }
                        });

                        $("#enable_native_auth").change(function () {
                            if ($(this).is(':checked')) {
                                $('#toggle-reg-notification').hide();
                                $("#enable_reg_notification").trigger('click');
                                App.remote.get(App.baseUrl() + 'admin/login-plus/sso/activate-native', null, function (r) {

                                });
                            }
                        });

                        $("#disable_reg_notification").change(function () {
                            if ($(this).is(':checked')) {
                                App.remote.get(App.baseUrl() + 'admin/login-plus/sso/deactivate-regnotify', null, function (r) {

                                });
                            }
                        });

                        $("#enable_reg_notification").change(function () {
                            if ($(this).is(':checked')) {
                                App.remote.get(App.baseUrl() + 'admin/login-plus/sso/activate-regnotify', null, function (r) {

                                });
                            }
                        });

                        $("#loginplus-form-integrationsettings").live('submit', function () {
                            $(this).find('input').removeClass('error');
                            if ($(this).find('#sso_onelogin_domain').val().length == 0) {
                                $('#sso_onelogin_domain').parent().addClass('error');
                                App.notify.error(App.t('OneLogin domain name must be specified'));
                                return false;
                            }
                        });

                        $("#loginplus-form-ldapsettings").live('submit', function () {
                            $(this).find('.loginplus-form-ldapsettings input').parent().removeClass('error');
                            var emptyFields = $('.loginplus-form-ldapsettings input[type!="submit"]').filter(function () {
                                return $(this).val() == "";
                            }).length;
                            if (emptyFields > 0) {
                                $('.loginplus-form-ldapsettings input[type!="submit"]').filter(function () {
                                    return $(this).val() == "";
                                }).parent().addClass('error');
                                App.notify.error(App.t('All fields are required!'));
                                return false;
                            }
                        });

                        // Pre-load configuration form for active SSO method on page open
                        var dropdownSelection = $("#sso_active_method").val();
                        showSsoForm(dropdownSelection);

                        // On SSO method dropdown value selection
                        $("#sso_active_method").change(function () {
                            showSsoForm($(this).val());
                        });

                    });
                }
            }
        }
    }
});
