App.onReady(function () {
    if (App.hasParam('require_sso_login') && 1 === App.getParam('require_sso_login') && !App.getParam('confirmAddResponse')) {
        setTimeout(function () {
            if ('default' == App.routeName) {
                var SSOAffected = $('#comment-add #submit, a.iLikeIt, a.iDont, a.vote-add-like, a.good-comment, #vote_poll_submit');
            } else {
                var SSOAffected = $('#response-add #submit, #comment-add #submit, a.iLikeIt, a.iDont, a.vote-add-like, a.good-comment, #vote_poll_submit, a.subscribe-link');
            }
            SSOAffected.unbind('click');
            SSOAffected.on(App.event.click(), function (e) {
                e.stopImmediatePropagation();
                e.preventDefault();
                location.href = App.baseUrl('/sso/login');
            });
        }, 300);
    }
});

App.onReady(function () {

    var popupTabs = $('ul.b-popup-tabs'),
        tab       = null;

    if (App.hasParam('loginMethod')) {
        switch (App.getParam('loginMethod')) {
            case 'sso':
                tab = popupTabs.find('li.ssoTab');
                break;
            case 'ldap':
                tab = popupTabs.find('li.ldapTab');
                break;
            case 'default':
                tab = popupTabs.find('a[rel="form-login"]').closest('li');
                break;
        }
    } else if (App.hasParam('registrationMethod')) {
        tab = popupTabs.find('a[rel="form-registration"]').closest('li');
    }

    if (null !== tab) {
        setTimeout(function () {
            tab.click();
        }, 70);
    }

    // TODO: refactor deprecated/removed "live" method.
    $("#loginplus-form-ldaplogin").live("submit", function (event) { //debug
        var form = $(this),
            data = App.getFormParams($(this));
        form.find("input[type=submit]").attr("disabled", "disabled").addClass("disabled");
        form.find(".preloader").show();

        App.remote.post($(this).attr("action"), data, function(r) {
            result = App.remote.parseResult(r);
            form.find("input[type=submit]").removeAttr("disabled").removeClass("disabled");
            $(".preloader").hide();
            if (result.data.isError()) {
                App.notify.error(result.data.getMessage());
                return false;
            }
            App.notify.success(result.data.getMessage());
            if (form.attr("id") == "loginplus-form-ldaplogin") {
                $(".l-popup-overlay, .l-popup-body").hide();
                formId = result.data.getParam("formId");
                if (formId) {
                    $("#" + formId).unbind("submit").die("submit");
                    $("#" + formId + " input[type=submit], button[type=submit]").die("click").unbind("click").click();
                } else {
                    if (result.data.getParam("url")) {
                        location.href = result.data.getParam("url");
                    } else {
                        location.reload();
                    }
                }
            } else {
                $('.b-popup-tabs li.itTab .filter').removeClass('filter-active');
                $('.b-popup-tabs li.itTab .filter .marker').hide();
                $('.b-popup-tabs li.itTab .filter').eq(0).addClass('filter-active');
                $('.b-popup-tabs li.itTab .filter').eq(0).find('.marker').show();
                $(".auth-form").remove();
                $(".inner2 .popup-powered").before(result.data.getOutput());
                App.notify.success(result.data.getMessage());
            }
        });
        return false;
    });
    
    window.submitForm =  function (form_id) {
        if (form_id) {
            $("#" + form_id).unbind("submit").die("submit");
            $("#" + form_id + " input[type=submit], #" + form_id + " button[type=submit]").die("click").unbind("click").click();
        }
    };

    /* IE >7 FIX */
    var getHref = function (element) {
        var url = $(element).attr('href');
        if (!$.browser.msie) return url;
        if (7 <= parseInt($.browser.version, 10)) {
            return url.replace('login-oauth', '/login-oauth');
        }
    }

    /* Login using Twitter */
    $("#twitter-button").on(App.event.click(), function () {
        window.open(getHref(this), 'social_login', 'width=560,height=700,left=400,top=100');
        return false;
    });

    /* Login using Facebook */
    $("#facebook-button").on(App.event.click(), function (event) {
        window.open(getHref(this), 'social_login', 'width=900,height=540,left=250,top=200');
        return false;
    });

    /* Login using Google */
    $("#google-button").on(App.event.click(), function () {
        window.open(getHref(this),'social_login','width=900,height=540,left=250,top=200');
        return false;
    });

    /* Manual user email confirmation if service doesn't provide email */
    $("body").on("submit", "#loginplus-form-email", function (event) {
        var form = $(this),
            data = App.getFormParams($(this));
        form.find("#submit").attr("disabled", "disabled").addClass("disabled");
        form.find(".preloader").show();

        App.remote.post($(this).attr("action"), data, function (r) {
            var result = App.remote.parseResult(r);
            form.find("#submit").removeAttr("disabled").removeClass("disabled");
            $(".preloader").hide();

            if (result.data.isError()) {
                App.notify.error(result.data.getMessage());
                return false;
            }

            $('.b-popup-tabs li.itTab').removeClass('selected');
            $('.b-popup-tabs li.itTab').eq(0).addClass('selected');
            $(".auth-form").remove();
            $(".inner2 .popup-powered").before(result.data.getOutput());
            App.notify.success(result.data.getMessage());

        });

        return false;
    });

    // @ROUTE: "response_add"
    if (App.route().is(['response_add', 'responses_show']) && !App.isMobileTheme()) {
        /*
         If "anonymous_responses" is on, "sso_active_method" is "integration"
         and "sso_native_auth_disabled" is switched off - proceed user to make a choice
         to post response anonymously or go to external login.
         */
        if (App.getParam('confirmAddResponse')) {
            var confirm = $('<div class="objects table-view centerAlign"></div>').appendTo('div.all > div.wrap-container'),
                message = $('<p class="result-not-found"></p>')
                    .html(App.t('To proceed, please choose required action!'))
                    .appendTo(confirm),
                butLogin = $('<a class="button-type1" href="#login"></a>')
                    .css('margin-right', '10px')
                    .html(App.t('Login')).appendTo(confirm),
                butAnon  = $('<a class="button-type1" href="#anonymously"></a>')
                    .html(App.t('Anonymously')).appendTo(confirm);

            /* Login button "click" event */
            butLogin.on(App.event.click(), function (event) {
                location.href = App.getParam('ssoLoginUrl');
                event.preventDefault();
            });

            /* Specify form block according current route */
            var form = App.route().is('response_add') ? $('#response-add') : $('div.leave-comment');

            /*
            Add "Leave Comment" button on proceed block and replace form on Response
            add page if Lock comments is not activated.
            */
            if (App.route().is('responses_show') && 0 < form.size()) {
                var leaveCommentBut = butLogin.clone(true);
                leaveCommentBut.html(App.t('Leave Comment')).appendTo(confirm);
                form.replaceWith(confirm);
                butAnon.remove();
            }

            /* Anonymously button "click" event */
            if (App.route().is('response_add')) {
                butAnon.on(App.event.click(), function (event) {
                    confirm.hide();
                    form.removeClass('hidden');
                    if ($('div.anonymous-block').is(':hidden')) {
                        $('#submit_guest_link').trigger('click');
                        /* Prevent scrolling to anonymous email input */
                        $('html, body').stop();
                    }
                    /* Show proceed block again if user cancel anonymous response adding. */
                    $('#submit_guest_link').one(App.event.click(), function (event) {
                        form.addClass('hidden');
                        confirm.show();
                    });
                    event.preventDefault();
                });
            }

            /* Remove form and anonymous button if "anonymous_responses" is switched off. */
            if (!App.getParam('anonymouslyPosting')) {
                butAnon.remove();
                form.remove();
            }

            /* Don't display proceed block if form is visible (e.x: if form is submitted and has errors). */
            if (App.route().is('response_add') && !form.hasClass('hidden')) {
                confirm.hide();
                butAnon.triggerHandler(App.event.click());
            }
        }
    }
});
