App.module.extend({
    resources: {
        controllers: {
            adminMailing: {
                edit: function() {
                    App.onReady(function(){
                        $("#email_connection_type").change(function(){
                            if ($(this).val() == 'smtp') {
                                $(".dropDown-div").fadeIn();
                            } else {
                                $(".dropDown-div").fadeOut();
                            }
                        });

                        $("input[name=email_smtp_authentication]").click(function(){
                            if ($(this).val() == 1) {
                                $("#smtp_login_pas").fadeIn();
                            } else {
                                $("#smtp_login_pas").fadeOut();
                            }
                        })

                        $('#smtp_test').click(function(){
                            $(this).parent().find(".preloader").addClass("floatRight").show();
                            url = App.baseUrl('/admin/mailing/test-connection');
                            data = {
                                'smtp[host]': $("#email_smtp_host").val(),
                                'smtp[port]': $("#email_smtp_port").val(),
                                'smtp[auth]': $("input[name=email_smtp_authentication]:checked").val(),
                                'smtp[username]': $("#email_smtp_username").val(),
                                'smtp[password]': $("#email_smtp_password").val(),
                                'smtp[security]': $("#email_smtp_security").val(),
                                'smtp[from]': $("#send_email_from_email").val(),
                                'smtp[bulk]': $("input[name=email_is_bulk]:checked").val(),
                                mod: 'resources',
                                format: 'json'
                            };
                            App.remote.post(url, data, function(r) {
                                result = App.remote.parseResult(r);
                                $(".preloader").hide();
                                if (result.data.isError()) {
                                    App.notify.error(result.data.getMessage());
                                    return;
                                }
                                App.notify.success(result.data.getMessage());
                            });
                        });
                    });
                }
            },
            adminTemplates : {
                index : function(){
                    App.onReady(function(){
                        $("#templates_languages").change(function(){
                            $(this).parent().find(".preloader").show();
                            url  = App.baseUrl('/admin/mailing/templates/' + $(this).val());
                            App.remote.get(url, {}, function(r) {
                                result = App.remote.parseResult(r);
                                if (result.data.isError()) {
                                    App.notify.error(result.data.getMessage());
                                    return;
                                }
                                $(".mainArea-type2").html(result.data.getOutput());
                                $("h1.page-title").html(result.data.getParam('title'));
                                $(".preloader").hide();
                            });
                        });
                    });
                },
                edit: function(){
                    App.onReady(function(){
                        $(".col2 .col-item a").live("click", function(){
                            text = ":" + $(this).text().trim();
                            textarea = $(".resizer-wrap textarea").get(0);
                            height = textarea.scrollTop;
                            //IE support
                            if (document.selection) {
                                textarea.focus();
                                sel = document.selection.createRange();
                                sel.text = text;
                            }
                            //MOZILLA/NETSCAPE support
                            else if (textarea.selectionStart || textarea.selectionStart == '0') {
                                var startPos = textarea.selectionStart;
                                var endPos = textarea.selectionEnd;
                                textarea.value = textarea.value.substring(0, startPos)
                                + text
                                + textarea.value.substring(endPos, textarea.value.length);
                            } else {
                                textarea.value += text;
                            }
                            textarea.focus();
                            textarea.scrollTop = height;
                            return false;
                        });
                    });
                }
            }
        }
    }
});