App.onReady(function () {
    $(window).on('beforeunload', function () {
        var textArea = $('textarea#comment_text');
        if (textArea.val().length > 0 && !(textArea.val().length === 1 && textArea.val().charCodeAt(0) === 10)) {
            return (App.t('All changes you have made to this page will be lost!'));
        }
    });

    $("#add-comment-button").click(function () {
        var form = $(".leave-comment");
        if (form != void(0)) {
            var destination = form.offset().top;
            if ($.browser.safari) {
                $('body').animate({scrollTop: destination}, 1100);
            } else {
                $('html').animate({scrollTop: destination}, 1100);
            }
        }
        return false;
    });

    $(".comment-reply").live('click', function(){
        var comment = $(this).parent().parent(),
            content = comment.find(".comment-content-text");

        if (content.length) {
            var block = content.clone();
            block.find(".spoiler-container").remove();
            var bbcode    = wysiwyg.htmlToBbcode(block),
                user      = comment.find(".comment-content-info a.user_id"),
                user_name = user.html(),
                user_id   = user.attr("id").replace(/user_/, ""),
                text      = "[reply user_id=" + user_id + "][h4][b]";

            text += comment.find(".comment-content-info a").eq(0).text().trim() + " wrote:[/b][/h4]";
            text += bbcode.trim() + "[/reply]\n";
            
            var form      = $("#comment-add"),
                container = form.find(".description-topic"),
                textarea  = container.find("textarea"),
                body     = container.find(".textarea-editor").contents().find('body');

            textarea.val(textarea.val() + text);
            if (textarea.is(":visible")) {
                textarea.focus();
                textarea.scrollTop(1000).scrollLeft(1000);
            } else {
                copyTo(body, textarea, 0);
                body.scrollTop(1000).scrollLeft(1000);
            }

            var notifyContainer = form.find("label[for=notify_user_only]"),
                notifyUsers     = notifyContainer.find('span[user_id]'),
                userExists      = notifyUsers.filter('[user_id="' + user_id + '"]').is('span'),
                userSpan        = $('<span></span>', {
                    text: ((0 < notifyUsers.size()) ? ', ' : '')  + user_name,
                    'user_id': user_id
                });

            if (!userExists && 0 == notifyUsers.size()) {
                userSpan = userSpan[0].outerHTML;
                notifyContainer.show();
                notifyContainer.html('<img title="' + App.t('Notify Only') + '" alt="' + App.t('Notify Only') + '" src="' + App.baseUrl('/public/assets/images/icons/16/notify_disabled.jpg') + '" />' + userSpan);
            } else if (!userExists) {
                notifyContainer.append(userSpan);
            }

            var destination = form.offset().top;
            if ($.browser.safari) {
                $('body').animate( {scrollTop: destination}, 1100 );
            } else {
                $('html').animate( {scrollTop: destination}, 1100 );
            }
        }
        return false;
    });

    //good-comment
    $(".good-comment").live(App.event.click(), function(e){
        e.preventDefault();
        if (!App.getParam("votes")) {
            params = {'get': {} , 'redirect' : $(this).attr("href")};
            App.openLoginPopup(params);
            return false;
        }
        var comment = $(this).parent().parent().parent();
        comment.find(".preloader").show();
        App.remote.get($(this).attr("href"), {format: 'json'}, function(r) {
            result = App.remote.parseResult(r);
            comment.find(".preloader").hide();
            if (result.data.isError()) {
                App.notify.error(result.data.getMessage());
                return false;
            }
            App.notify.success(result.data.getMessage());
            votes = comment.find(".rating-response");
            votes.text(votes.text()*1+1);
        });
        return false;
        
    });

    //filter commnets
    $("a.sort_comments").click(function(){
        $(this).parent().find(".preloader").show();
        $("a.sort_comments").removeClass("filter-active");
        $("a.sort_comments .marker").hide();
        $(this).addClass("filter-active");
        $(this).find(".marker").show();
        App.remote.get($(this).attr("href"), {}, function(r) {
            result = App.remote.parseResult(r);
            if (result.data.isError()) {
                App.notify.error(result.data.getMessage());
                return;
            }
            nextPage = result.data.getParam('nextPage');
            $(".comment").remove();
            $(".comments-title").after(result.data.getOutput());
            $(".preloader").hide();
        });
        return false;
    });
    $('input[name=is_negative]').live('change', function(){
        img = $(this).parent().find("label img");
        if ($(this).is(":checked")) {
            img.attr('src', App.baseUrl('/public/assets/images/negative_vote.png'));
        } else {
            img.attr('src', App.baseUrl('/public/assets/images/negative_vote_na.png'));
        }
    });
    $('input[name=notify_user_only]').live('change', function(){
        img = $(this).parent().find("label img");
        if ($(this).is(":checked")) {
            img.attr('src', App.baseUrl('/public/assets/images/icons/16/notify_enabled.jpg'));
        } else {
            img.attr('src', App.baseUrl('/public/assets/images/icons/16/notify_disabled.jpg'));
        }
    });
    //add comment
    $('#comment-add').live("submit", function(e){
        $(window).unbind('beforeunload');
        if ($("#comment_text").val().length < 3 && $("#comment_text").attr('disabled') == undefined) {
            App.notify.error(App.t("Comment should be at least 3 characters!"));
            return false;
        }
        if (App.getParam("isGuest")) {
            params = {'form_id' : $(this).attr("id")};
            App.openLoginPopup(params);
            return false;
        }
        form = $(this);
        form.find("#submit").attr("disabled", "disabled").addClass("disabled");
        data = App.getFormParams(form);
        $(".leave-comment .preloader").eq(0).show();
        App.remote.post(form.attr('action'), data, function(r) {
            result = App.remote.parseResult(r);
            $('.preloader').hide();
            form.find("#submit").removeAttr("disabled").removeClass("disabled");
            if (result.data.isError()) {
                App.notify.error(result.data.getMessage());
                return false;
            }
            if (result.data.getOutput()) {
                html = result.data.getOutput();
                textAreaId = $(html).find("textarea").attr("id");
                $(".leave-comment").before(html);
                textarea = $("#" + textAreaId).get(0);
                App.initEditor(textarea);

                var commentsStat    = $('#statistics-comments'),
                    commentsCounter = $("#count-comments"),
                    count;
                if (commentsStat.is('div')) {
                    count = commentsStat.text() * 1 + 1;
                    commentsStat.html(count);
                } else if (commentsCounter.is('span') || commentsCounter.is('div')) {
                    count = commentsCounter.html() * 1 + 1;
                } else {
                    count = 1;
                }

                commentsCounter.html(count);
                $("#statistics-participants").html(result.data.getParam("participants"));
            }

            if (form.find("#vote").val() != 0) {

                if (result.data.getParam("negativeVotes") != null) {
                    $(".button-object-full.iDont .how-vote").html(result.data.getParam("negativeVotes"));
                }

                if (result.data.getParam("positiveVotes") != null) {
                    $(".button-object-full.iLikeIt .how-vote").html(result.data.getParam("positiveVotes"));
                }
                disactive = $(".buttons-object-full .disactive");
                if (disactive.length) {
                    $(".button-object-full:not(.disactive)").addClass("disactive");
                    disactive.removeClass("disactive");
                } else {
                    votes = $(".title-object-full .votes center");
                    votes.html(votes.text().trim() * 1 + 1);
                }
            }
            form.find("textarea, input[type=text]").val('');
            form.find("iframe").contents().find("body").html("");
            form.find("input[type=checkbox], input[type=radio]").removeAttr('checked');
            $('input[name=is_negative]').change();
            form.find("#vote").val('0');
            App.notify.success(result.data.getMessage());
        });
        return false;
    });

    $(".comment-edit-form").live("submit", function(){
        form = $(this);
        form.find("button[type=submit]").attr("disabled", "disabled").addClass("disactive");
        data = App.getFormParams(form);
        comment = form.parents(".comment");
        comment.find(".preloader").show();
        App.remote.post(form.attr('action'), data, function(r) {
            result = App.remote.parseResult(r);
            comment.find('.preloader').hide();
            form.find("#submit").removeAttr("disabled").removeClass("disactive");
            if (result.data.isError()) {
                App.notify.error(result.data.getMessage());
                return false;
            }
            comment.hide();
            html = result.data.getOutput();
            textAreaId = $(html).find("textarea").attr("id");
            comment.after(html);
            comment.remove();
            textarea = $("#" + textAreaId).get(0);
            App.initEditor(textarea);
            App.notify.success(result.data.getMessage());
        });
        return false;
    });

    $("a.edit-comment").live("click", function(){
        comment = $(this).parent().parent();
        text = comment.find(".comment-content-text");
        form = comment.find(".comment-edit-form");
        if (form.is(":visible")) {
            form.hide();
            text.show();
        } else {
            form.show();
            text.hide();
        }
        return false;
    });

    $("a.delete-comment").live("click", function(){
        comment = $(this).parent().parent().parent();
        comment.find(".preloader").show();
        App.remote.get($(this).attr("href"), {format: 'json'}, function(r) {
            result = App.remote.parseResult(r);
            if (result.data.isError()) {
                App.notify.error(result.data.getMessage());
                return false;
            }
            App.notify.success(result.data.getMessage());
            comment.remove();

            var commentsStat    = $('#statistics-comments').eq(0),
                commentsCounter = $("#count-comments"),
                count;
            if (commentsStat.is('div')) {
                count = commentsStat.text() * 1 - 1;
                commentsStat.html(count);
            } else if (commentsCounter.is('span') || commentsCounter.is('div')) {
                count = commentsCounter.html() * 1 - 1;
            } else {
                count = 0;
            }
            commentsCounter.html(count);
        });
        return false;
    });
    
    $("a.permalink").click(function(){
        location.href = $(this).attr("href");
        return false;
    });
});
