App.module.extend({
    system: {
        controllers: {
            admin: {
                index: function () {
                    App.onReady(function () {
                        $(".sortByDate").change(function () {
                            location.href = App.baseUrl("/activity?date=" + $(this).val());
                        });

                        var doUpgrade = $('#upgrade-do');

                        doUpgrade.on(App.event.click(), function (event) {
                            location.href = App.baseUrl('/admin/modules');
                            event.preventDefault();
                        });

                        var upgradeCheck = function () {
                            var versionStatus = $('#version-status');

                            doUpgrade.addClass('hidden');

                            versionStatus.html($("<span></span>", {
                                "class": "loading",
                                "text":  App.t("Checking for updates")
                            }));

                            App.remote.post(
                                {
                                    url: App.baseUrl('/admin-version'),
                                    data: {},
                                    success: function (response) {
                                        var version    = response.data.getParam('version'),
                                            versionTxt = App.t("New version available") + ' (' + version + ')';

                                        if (null !== version) {
                                            versionStatus.html($("<span></span>", {
                                                "class": "plate success",
                                                "text":  versionTxt
                                            }));
                                            App.notify.success(versionTxt);
                                            doUpgrade.removeClass('hidden');
                                        } else {
                                            versionStatus.html($("<span></span>", {
                                                "class": "plate default",
                                                "text":  App.t("System is up-to date")
                                            }));
                                        }
                                    },
                                    complete: function (response) {
                                        versionStatus.html('');
                                    },
                                    error: function (response) {
                                        App.notify.error(response.data.getMessage());
                                    }
                                }
                            );
                        };

                        upgradeCheck();
                    });
                }
            },
            adminLanguages: {
                _init: function () {
                    App.onReady(function () {
                        $(".translation-table .button-type3").click(function () {
                            obj = $(this).parents(".obj");
                            obj.find("input,textarea").val(obj.find("td .div-td").html().trim());
                        });
                        /* Focus translation elements */
                        $('.formObject').focusin(function () {
                            $('.translation-table tr').removeClass('active');
                            $(this).parent().parent().addClass('active');
                        });
                    });
                },
                index: function () {
                    App.onReady(function () {
                        $("input[type=file]").live("change", function () {
                            filename = this.value.replace(/^.*[\/\\]/g, "");
                            $(this).parent().find("input[type=text]").val(filename);
                        });
                        $("#language-add").click(function () {
                            block = $(".new-language-block.new");
                            if (block.is(":visible")) {
                                $(".new-language-block.new").fadeOut();
                            } else {
                                $(".new-language-block").fadeOut();
                                $(".new-language-block.new").fadeIn();
                            }
                            return false;
                        });
                        $(".new-language-block form").live("submit", function () {
                            form = $(this);
                            form.find(".textInput").removeClass("error");
                            nameInput = form.find("input[name=name]");
                            if (nameInput.val() == "") {
                                App.notify.error(App.t("Language name is required!"));
                                nameInput.parent().addClass("error");
                                return false;
                            }
                            code = form.find("input[name=code]");
                            if (code.val() == "") {
                                App.notify.error(App.t("Language code is required!"));
                                code.parent().addClass("error");
                                return false;
                            }
                        });
                        $("#switch_dict .iedit").live("click", function () {
                            link = $(this);
                            background = link.css("background-image");
                            link.css("background-image", "url(" + App.baseUrl("/public/assets/images/preloader.gif") + ")");
                            App.remote.get(link.attr("href"), {format: 'json'}, function (r) {
                                $(".new-language-block").hide();
                                result = App.remote.parseResult(r);
                                link.css("background-image", background);
                                if (result.data.isError()) {
                                    App.notify.error(result.data.getMessage());
                                    return false;
                                }
                                $(".new-language-block." + result.data.getParam('code')).remove();
                                $(".mainArea-type2.floatRight").prepend(result.data.getOutput());
                                $(".new-language-block." + result.data.getParam('code')).fadeIn();
                            });
                            return false;
                        });
                        $(".idelete").live("click", function () {
                            lang = $(this).parent().find("label span").text();
                            if (confirm(App.t("Are your sure you want to delete :lang", {'lang': lang}))) {
                                link = $(this);
                                background = link.css("background-image");
                                link.css("background-image", "url(" + App.baseUrl("/public/assets/images/preloader.gif") + ")");
                                App.remote.get(link.attr("href"), {format: 'json'}, function (r) {
                                    result = App.remote.parseResult(r);
                                    if (result.data.isError()) {
                                        App.notify.error(result.data.getMessage());
                                        return false;
                                    }
                                    App.notify.success(result.data.getMessage());
                                    link.parent().remove();
                                    code = link.parent().find("input").val();
                                    $("#dict-" + code).remove();
                                    $('.color-obj').removeClass("color-obj");
                                    $('.table-view div.obj:odd').addClass("color-obj");
                                });
                            }
                            return false;
                        });
                        /* Switch dictionaries */
                        $('.lang div label').click(function () {
                                $('.lang div').removeClass('lang-active');
                                $(this).parent('div').addClass('lang-active');
                                $('.dictionary-group').hide();
                                $('.dictionary-group').eq($(this).parent().index()).show();
                            }
                        );
                    });
                }
            },
            adminRoles: {
                index: function () {
                    App.onReady(function () {
                        $("#add-new-role").click(function () {
                            $(".current-roles tr").removeClass("error");
                            block = $(".new-role-block.new");
                            if (block.is(":visible")) {
                                $(".new-role-block.new").fadeOut();
                            } else {
                                $(".new-role-block").fadeOut();
                                $(".new-role-block.new").fadeIn();
                            }
                            return false;
                        });
                        $(".iedit").live("click", function () {
                            $(".current-roles tr").removeClass("error");
                            link = $(this);
                            background = link.css("background-image");
                            link.css("background-image", 'url(' + App.baseUrl('/public/assets/images/preloader.gif') + ')');
                            App.remote.get(link.attr("href"), {format: 'json'}, function (r) {
                                $(".new-role-block").hide();
                                result = App.remote.parseResult(r);
                                link.css("background-image", background);
                                if (result.data.isError()) {
                                    App.notify.error(result.data.getMessage());
                                    return false;
                                }
                                $(".new-role-block." + result.data.getParam('roleSlug')).remove();
                                $(".mainArea-type2.floatRight").prepend(result.data.getOutput());
                                $('.table-col1 .table-col-line:odd').addClass('color-obj');
                                $('.table-col2 .table-col-line:odd').addClass('color-obj');
                                $(".new-role-block." + result.data.getParam('roleSlug')).fadeIn();
                            });
                            return false;
                        });
                        $(".idelete").live("click", function () {
                            role = $(this).parent().parent().find("td").eq(0).text();
                            if (confirm(App.t("Are your sure you want to delete role - " + role))) {
                                $(".current-roles tr").removeClass("error");
                                link = $(this);
                                background = link.css("background-image");
                                link.css("background-image", "url(" + App.baseUrl("/public/assets/images/preloader.gif") + ")");
                                App.remote.get(link.attr("href"), {format: 'json'}, function (r) {
                                    result = App.remote.parseResult(r);
                                    if (result.data.isError()) {
                                        App.notify.error(result.data.getMessage());
                                        return false;
                                    }
                                    App.notify.success(result.data.getMessage());
                                    link.parent().parent().remove();
                                    $('.color-obj').removeClass("color-obj");
                                    $('.current-roles tr:odd').addClass("color-obj");
                                });
                            }
                            return false;
                        });
                        $(".new-role-block form").live("submit", function () {
                            $(".current-roles tr").removeClass("error");
                            form = $(this);
                            roleInput = form.find(".textInput #name");
                            if (roleInput.val() == "") {
                                App.notify.error(App.t("Role name is required!"));
                                roleInput.parent().addClass("error");
                                return false;
                            }
                            error = false;
                            if (form.parent().hasClass("new")) {
                                $(".current-roles tr").each(function () {
                                    roleName = $(this).find("td").eq(0).text().trim()
                                    if (roleName == roleInput.val()) {
                                        $(this).addClass("error");
                                        roleInput.parent().addClass("error");
                                        App.notify.error("Such Role already exists!");
                                        error = true;
                                    }
                                });
                            }
                            if (error) {
                                return false;
                            }
                            data = App.getFormParams(form);
                            form.find(".preloader").show();
                            App.remote.post(form.attr("action"), data, function (r) {
                                result = App.remote.parseResult(r);
                                $(".current-roles tr").removeClass("error");
                                $(".preloader").hide();
                                if (result.data.isError()) {
                                    App.notify.error(result.data.getMessage());
                                    return false;
                                }
                                App.notify.success(result.data.getMessage());
                                form.parent().fadeOut();
                                if (result.data.getAction() == "add") {
                                    form.find("#reset").click();
                                    $(".current-roles tbody").append(result.data.getOutput());
                                    $(".color-obj").removeClass("color-obj");
                                    $(".current-roles tr:odd").addClass("color-obj");
                                } else {
                                    role = result.data.getParam("roleSlug");
                                    $("tr#" + role + " td").eq(0).html(roleInput.val());
                                }
                            });
                            return false;
                        });
                    });
                }
            },
            adminInterface: {
                widget: function () {
                    App.onReady(function () {
                        var activeWidget = $('div.widget-block:visible'),
                            activeForm = activeWidget.find('form');

                        // Widget tabs
                        $('#widget-tabs').on(App.event.click(), 'a', function (event) {
                            event.preventDefault();
                            var tabLink = $(this);
                            if (tabLink.hasClass('activ-pos')) return;
                            tabLink.addClass('activ-pos');
                            $(event.delegateTarget).find('a').not(tabLink).removeClass('activ-pos');
                            var widgets = $('div.widget-block');
                            widgets.not(':hidden').hide(0, function () {
                                activeWidget = widgets.filter('#widget-' + tabLink.attr('rel'));
                                activeWidget.show();
                                activeForm = activeWidget.find('form');
                            });
                            App.cookie.set('widget_tab', tabLink.attr('href').replace('#', ''));
                        });

                        var selectedTab = App.cookie.get('widget_tab');
                        if (null !== selectedTab) {
                            $('#widget-tabs').find('a[href="#' + selectedTab + '"]').trigger(App.event.click());
                        }

                        $('input[name=widget_side]').click(function () {
                            $('input[name=widget_side][value=' + $(this).val() + ']').attr('checked', 'checked');
                            if ($(this).val() == 'left') {
                                $('.widget-demo').removeClass('w-right').addClass('w-left');
                            } else {
                                $('.widget-demo').removeClass('w-left').addClass('w-right');
                            }
                        });
                        $('input[name=widget_background_color]').change(function () {
                            $('input[name=widget_background_color]').not(this)
                                .css('background-color', '#' + this.color).val(this.value);
                            $('.widget-demo').css('background-color', '#' + this.color);
                        });
                        $('input[name=widget_border_color]').change(function () {
                            $('input[name=widget_border_color]').not(this)
                                .css('background-color', '#' + this.color).val(this.value);
                            $('.widget-demo').css('border-color', '#' + this.color);
                        });
                        $('input[name=widget_round_corners]').click(function () {
                            var cornersHandlers = $('input[name=widget_round_corners]').not(this);
                            if ($(this).is(':checked')) {
                                cornersHandlers.attr('checked', 'checked');
                            } else {
                                cornersHandlers.removeAttr('checked');
                            }
                            $('.widget-demo').toggleClass('w-round');
                        });
                        $('input[name=widget_drop_shadow]').click(function () {
                            var shadowHandlers = $('input[name=widget_drop_shadow]').not(this);
                            if ($(this).is(':checked')) {
                                shadowHandlers.attr('checked', 'checked');
                            } else {
                                shadowHandlers.removeAttr('checked');
                            }
                            $('.widget-demo').toggleClass('w-shadow');
                        });
                        $('select[name=widget_default_tab]').change(function () {
                            $('select[name=widget_default_tab]').not(this).val(this.value);
                        });

                        // Initialization widget
                        $('.widget-demo').css('background-color', '#' + $('#widget_background_color').val());
                        $('.widget-demo').css('border-color', '#' + $('#widget_border_color').val());
                        $('input[name=widget_side]:checked').click();
                        if ($('#widget_round_corners').attr('checked')) $('.widget-demo').addClass('w-round');
                        if ($('#widget_drop_shadow').attr('checked')) $('.widget-demo').addClass('w-shadow');

                        $("#submit-feedback").click(function () {
                            $("#system-form-widgetfeedback").submit();
                        });

                        $("#submit-search").click(function () {
                            $("#system-form-widgetsearch").submit();
                        });

                        $(".get-code").click(function () {
                            var onClick = '';
                            var code = '<script type="text/javascript">';

                            var widgetName = activeForm.find("input[name=widget_name]").val();

                            if (widgetName == 'feedback') {
                                code += 'var URWidgetListener = function (event) {';
                                code += '  if (event.data.indexOf("redirect") == 0) {';
                                code += '    found = event.data.match(/redirect:url\\(([^\\)]*)\\)/);';
                                code += '    if (found.length == 2) {';
                                code += '      location.href = found[1];';
                                code += '    }';
                                code += '  }';
                                code += '};';
                                code += 'if (window.addEventListener) {';
                                code += '  window.addEventListener("message", URWidgetListener, false);';
                                code += '} else {';
                                code += '  window.attachEvent("onmessage", URWidgetListener);';
                                code += '}';
                            }
                            code += ' var head  = document.getElementsByTagName("head")[0];var link  = document.createElement("link");link.rel  = "stylesheet";link.type = "text/css";link.href = "' + App.baseUrl('/public/themes/' + App.getParam('defaultTheme', 'default') + '/assets/css/widget.css') + '";link.media = "all";head.appendChild(link);</script>';
                            if (activeForm.find("input[name=widget_open]:checked").val() == "widget") {
                                href = App.baseUrl('/widget?type=' + widgetName);
                                code += '<script type="text/javascript">widget = {url:\'' + App.baseUrl() + '\'}</script>';
                                code += '<script src="' + App.baseUrl('/public/assets/modules/system/js/widget.js') + '" type="text/javascript"></script>\n';
                                width = 600;
                                height = 400;

                                if (widgetName == 'feedback') {
                                    width = 773;
                                    height = 405;
                                }
                                onClick = 'javascript:popup(\'widget\', \'' + href + '\', ' + width + ', ' + height + ');';
                                target = "";
                            } else {
                                onClick = App.baseUrl();
                                target = "target='_blank'";
                            }
                            classes = "widget-tab";
                            if (activeForm.find("input[name=widget_side]:checked").val() == "left") {
                                classes += " widget-tab-left";
                            } else {
                                classes += " widget-tab-right";
                            }
                            if (activeForm.find("#widget_round_corners").attr("checked")) {
                                classes += " w-round";
                            }
                            if (activeForm.find("#widget_drop_shadow").attr("checked")) {
                                classes += " w-shadow";
                            }
                            style = "margin-top:-" + App.getParam('widgetMarginTop') + "px;";
                            if ($("#widget_background_color").val() != "") {
                                style += "background-color:#" + $("#widget_background_color").val() + ";";
                            }
                            if ($("#widget_border_color").val() != "") {
                                style += "border-color:#" + $("#widget_border_color").val() + ";";
                            }
                            code += '<a class="' + classes + '" style="' + style + '" title="' + $("#widget_text").val() + '" href="' + onClick + '" ' + target + ' >\n';
                            code += '  <img width="15" alt="" src="' + App.getParam('widgetTextUrl') + '" />\n';
                            code += '</a>';
                            activeWidget.find(".code-for-widget textarea").val(code);
                            activeWidget.find(".code-for-widget").fadeIn();
                        });
                    });
                }
            },
            adminSettings: {
                general: function () {
                    App.onReady(function () {
                        $("input[type=file]").change(function () {
                            filename = this.value.replace(/^.*[\/\\]/g, "");
                            $(this).parent().find("input[type=text]").val(filename);
                        });
                        $("input[name=anonymous_responses]").live('click', function () {
                            if ($(this).val() == "1") {
                                $("label[for=anonymous_captcha]").show();
                            } else {
                                $("label[for=anonymous_captcha]").hide();
                            }
                        });
                        $("input[name=anonymous_responses]:checked").click();
                    });
                }
            },
            adminResponses: {
                index: function () {
                    App.onReady(function () {
                        $("input[name=use_negative_votes]").click(function () {
                            var voteDiv = $(".negative-votes");
                            if ($(this).val() == "1") {
                                voteDiv.show();
                            } else {
                                voteDiv.hide();
                            }
                        });

                        var homepageResponses      = $('#homepage_content_responses'),
                            homepageVariantSwitcher = function () {
                                if (homepageResponses.is(':checked')) {
                                    $('#homepage-variant-block-responses').show();
                                } else {
                                    $('#homepage-variant-block-responses').hide();
                                }
                            };

                        homepageResponses.on('change', function (event) {
                            homepageVariantSwitcher();
                        });

                        homepageVariantSwitcher();


                        /*var activeVariant,
                            variantBlockSwitch = function () {
                            activeVariant = homepageVariants.filter(':checked');
                            $('div.variant-block:visible').hide();
                            $('#homepage-variant-block-' + activeVariant.val()).show();
                        }

                        homepageVariants.on(App.event.click(), function(event) {
                            variantBlockSwitch();
                        });
                        variantBlockSwitch();*/
                    });
                }
            },
            adminStatuses: {
               _init: function () {
                   "use strict";
               },
               index: function () {
                   App.onReady(function () {
                       var formBlock = $('div.new-status-block');
                       $('#add-new-status').on(App.event.click(), function(event) {
                           var form = $('#system-form-responsestatus');
                           form.attr('action', App.baseUrl('/admin/status/current/add'));
                           App.form.reset(form);
                           setDisableTypeSelect(false);
                           updateStatusForm();
                           if (formBlock.is(':visible')) {
                               $(this).trigger('blockHide');
                           } else {
                               $(this).trigger('blockShow');
                           }
                           formBlock.slideToggle('fast');
                           event.preventDefault();
                       });

                       var status    = $('#status-preview'),
                           bgColor   = $('#color'),
                           textColor = $('#text_color');

                       bgColor.on('change', function (event) {
                           status.css('backgroundColor', '#' + $(this).val());
                       });
                       textColor.on('change', function (event) {
                           status.css('color', '#' + $(this).val());
                       });
                       status.css('backgroundColor', '#' + bgColor.val());
                       status.css('color', '#' + textColor.val());

                       $('#title').on('keyup change', function (event) {
                           var titleVal = $(this).val();
                           if (titleVal == '') {
                               status.text(App.t('Status Title'));
                               $('#slug').val('');
                           } else {
                               status.text(titleVal);
                               $('#slug').val(App.slugify(titleVal, '_'));
                           }
                       });

                       $('#add-new-status').on('blockShow', function (event) {
                           $('#color, #text_color').trigger('change');
                           //$('#title').trigger('keyup');
                       });

                       var updateStatusForm = function ()
                       {
                           bgColor.css('backgroundColor', '#' + bgColor.val());
                           textColor.css('backgroundColor', '#' + textColor.val());
                           var _title = $('#title').val();
                           if ('' != _title) {
                               status.text(App.t(_title));
                           } else {
                               status.text(App.t('Status Title'));
                           }
                       };

                       var setDisableTypeSelect = function (flag) {
                           if (flag) {
                               $('#type').fadeTo('fast', 0.5).on('click focus focusin mousedown mouseup', function (event) {
                                   event.preventDefault();
                                   return false;
                               });
                           } else {
                               $('#type').fadeTo('fast', 1).off('click focus focusin mousedown mouseup');
                           }
                       };

                       if (App.hasParam('status_edit')) {
                           setDisableTypeSelect(true);
                       }


                       // Sortable initialization
                       var sortableTable = $(".response-statuses-sortable > tbody");
                       sortableTable.sortable({
                           axis: "y",
                           handle: "span.draggable-handler",
                           placeholder: "sortable-placeholder",
                           helper: "clone",
                           opacity: 0.9,
                           tolerance: "pointer",
                           items: "> tr",
                           helper: function (e, tr) {
                               var $originals = tr.children();
                               var $helper = tr.clone();
                               $helper.children().each(function (index) {
                                   // Set helper cell sizes to match the original sizes
                                   $(this).width($originals.eq(index).width());
                                   $(this).height($originals.eq(index).height());
                               });
                               return $helper;
                           },
                           update: function (event, ui) {
                               var target = $(event.target);
                               target.find('tr').removeClass("color-obj").filter(':odd').addClass("color-obj");

                               // Reorder statuses by given type
                               var typeStatuses = target.find('input[name="status_order[]"]'),
                                   order        = [],
                                   responseType = target.attr('id').replace('type-', '');
                               if (0 >= typeStatuses.length) return;

                               typeStatuses.each(function (edx, input) {
                                   order.push($(input).val());
                               });

                               App.remote.post(
                                   {
                                       url: App.baseUrl('/admin/statuses/' + responseType + '/order'),
                                       data: {order: order.join(',')},
                                       success: function (response) {
                                           App.notify.success(App.t('Order is updated!'));
                                       },
                                       complete: function (response) {
                                       },
                                       error: function (response) {
                                           App.notify.error(response.data.getMessage());
                                       }
                                   }
                               );
                           }
                       });
                       sortableTable.disableSelection();

                       $('table.response-statuses-sortable').on(App.event.click(), 'a.iedit', function (event) {
                           var link       = $(this),
                               background = link.css("background-image"),
                               slug       = link.closest('td').find('input[name="status_order[]"]').val();
                           link.css("background-image", "url(" + App.baseUrl("/public/assets/images/preloader.gif") + ")");

                           App.remote.post(
                               {
                                   url: App.baseUrl('/admin/status/' + slug + '/data'),
                                   data: {},
                                   success: function (response) {
                                       var statusData = $.parseJSON(response.data.getParam('status')),
                                           statusForm = $('#system-form-responsestatus');
                                       if (formBlock.is(':hidden')) {
                                           formBlock.slideDown('fast');
                                       }
                                       statusForm.attr('action', link.attr('href'));
                                       App.form.populate(statusForm, statusData);
                                       setDisableTypeSelect(true);
                                       $('#add-new-status').trigger('blockShow');
                                       updateStatusForm();
                                       App.utils.scrollTo(formBlock, null, -50);
                                   },
                                   complete: function (response) {
                                       link.css("background-image", background);
                                   },
                                   error: function (response) {
                                       App.notify.error(response.data.getMessage());
                                   }
                               }
                           );

                           event.preventDefault();
                       });

                       $('table.response-statuses-sortable').on(App.event.click(), 'a.idelete', function (event) {
                           if (confirm(App.t('Are you sure? You can\'t UNDO this operation!'))) {
                               var link       = $(this),
                                   background = link.css("background-image"),
                                   slug       = link.closest('td').find('input[name="status_order[]"]').val();

                               link.css("background-image", "url(" + App.baseUrl("/public/assets/images/preloader.gif") + ")");

                               App.remote.post(
                                   {
                                       url: App.baseUrl('/admin/status/' + slug + '/delete'),
                                       data: {},
                                       success: function (response) {
                                           App.notify.success(response.data.getMessage());
                                           var statusForm = $('#system-form-responsestatus');
                                           if (formBlock.is(':visible')) {
                                               App.form.reset(statusForm);
                                               setDisableTypeSelect(false);
                                               updateStatusForm();
                                               formBlock.slideUp('fast');
                                           }
                                           link.closest('tr').fadeOut('slow', function () {
                                               $(this).remove();
                                           });
                                       },
                                       complete: function (response) {
                                           link.css("background-image", background);
                                       },
                                       error: function (response) {
                                           App.notify.error(response.data.getMessage());
                                       }
                                   }
                               );
                           }
                           event.preventDefault();
                       });
                   });
               }
            },
            adminTrash: {
                index: function () {
                    App.onReady(function () {
                        $("#clear-trash").click(function () {
                            if (!confirm(App.t("Are you sure? You can't UNDO this operation!"))) {
                                return false;
                            }
                        });
                        $("#admin-trash-form").submit(function () {
                            if ($("select[name=trash-action]").val() == 'delete') {
                                if (!confirm(App.t("Are you sure? You can't UNDO this operation!"))) {
                                    return false;
                                }
                            }
                        });
                        $(".recovery, .delete").live("click", function(){
                            if ($(this).hasClass("delete")) {
                                if (!confirm(App.t("Are you sure? You can't UNDO this operation!"))) {
                                    return false;
                                }
                            }
                            object = $(this).parents(".object");
                            object.find(".checkResponse").hide();
                            object.find(".preloader").show();
                                App.remote.get($(this).attr("href"), {}, function(r){
                                result = App.remote.parseResult(r);
                                object.find(".preloader").hide();
                                if (result.data.isError()) {
                                    App.notify.error(result.data.getMessage());
                                    return false;
                                }
                                App.notify.success(result.data.getMessage());
                                object.fadeOut('slow', function(){
                                    if ($(".objects .object:visible").length == 0) {
                                        $(".objects").html("<p class='result-not-found'>" + App.t("Trash is empty") + "</p>");
                                        $(".filter-area-add").fadeOut();
                                    }
                                });
                            });
                            return false;
                        });
                    });
                }
            },
            adminAnalytics : {
                _init : function() {
                    App.onReady(function(){
                        $('.date-pick').attr('readonly', true);
                        $('.date-pick').attr('value', null);
                        var d = new Date();
                        var now = d.getFullYear()+'-'+("0" + (d.getMonth() + 1)).slice(-2)+'-'+("0" + d.getDate()).slice(-2);
                        $('.date-pick').datePicker({
                            startDate:'00.01.01',
                            endDate: now ,
                            closeOnSelect: false,
                            selectMultiple: true,
                            numSelectable: 9999,
                            verticalOffset:'30'
                        });
                        
                        $('#group_by').val('none');
                        $('#precision').attr('value','day');
                    });
                },
                index : function() {
                    App.onReady(function(){
                        $("#add-analytics-scripts").click(function(){
                            $(".current-roles tr").removeClass("error");
                            block = $(".scripts-analytics-block.new");
                            if (block.is(":visible")) {
                                $(".scripts-analytics-block.new").fadeOut();
                            } else {
                                $(".scripts-analytics-block").fadeOut();
                                $(".scripts-analytics-block.new").fadeIn();
                            }
                            return false;
                        });
                        
                        $('a[data-precision]').click(function(){
                            var thisObj = $(this);
                            var type = 'precision'
                            if (thisObj.data(type) == $('#' + type).val() ) {
                                return;
                            }
                            $('#' + type).val(thisObj.data(type)).trigger('change');
                            var activePosClass = 'activ-pos';
                            $('a[data-'+ type +']').each(function(key, obj){
                                var button = $(obj);
                                if (button.data('precision') != $('#'+ type).val()) {
                                    button.removeClass(activePosClass);
                                } else {
                                    button.addClass(activePosClass);
                                }
                            });

                        });
                        
                         var sendForm = function() {
                            var form = $('.date-pick').parents("form");
                            var data = {};
                            data[$(form).attr('id')] = App.getFormParams(form);
                            $('.analytics-diagram-container').html( $('<img>').addClass('analytics-diagram loader').attr("src", App.baseUrl("/public/assets/images/preloader.gif")) );
                            
                            params = {
                                url: App.baseUrl('/admin/analytics'),
                                data: data,
                                success:function (response) {
                                    var options = $(response.data.getParam('report_type')).html();
                                    $('#report_type').html( options );
                                    $('.analytics-diagram-container').html(response.data.getParam('diagram_img'));
                                }
                            };
                            App.remote.post(params);
                        };
                        
                        $('#report_type').change( function(){
                            sendForm(); 
                        });
                        
                        $('#group_by').change( function(){
                            switch (true) {
                                case ($('#group_by').val() == 'none'):
                                    $('#analytics_filter_date_range').show();
                                    $('#analytics_filter_precision').show();
                                    break;
                                case ($('#group_by').val() == 'weekday'):
                                    $('#analytics_filter_precision').hide();
                                    $('#analytics_filter_date_range').show();
                                    break;
                                case ($('#group_by').val() == 'type'):
                                    $('#analytics_filter_precision').hide();
                                    $('#analytics_filter_date_range').show();
                                    break;
                            } 
                            sendForm(); 
                        });
                        
                        $('.date-pick').bind('dpClosed', function(s){
                            if ($('.date-pick').val() == $('.date-pick').attr('data-initval')) {
                                return false;
                            }
                            sendForm();
                        });
                        
                        $('#precision').change( function(){
                            sendForm(); 
                        });
                        
                    });
                }
            },
            adminModules: {
                index: function () {
                    App.onReady(function () {
                        $(".udgrade").click(function () {
                            $("#upgrade-title, #upgrade-description").remove();
                            $(".dropDown-div.upgrade-form, .dropDown-div.upgrade-process").remove();
                            if (!$(".dropDown-div.upgrade-form").is(":visible")) {
                                button = $(this);
                                button.hide();
                                preloader = $(this).parents(".object").find(".preloader");
                                preloader.show();
                                params = {
                                    url: App.baseUrl('/admin/upgrade'),
                                    data: {step: 'prepare'},
                                    success: function (response) {
                                        output = response.data.getOutput();
                                        $(".mainArea-type2 .modules-area").prepend(output);
                                    },
                                    complete: function (response) {
                                        preloader.hide();
                                        button.show();
                                    },
                                    error: function (response) {
                                        App.notify.error(response.data.getMessage());
                                    }
                                };
                                App.remote.post(params);
                            }
                            return false;
                        });

                        step = function (objects) {
                            obj = $(objects.shift());
                            obj.find('i').addClass('preloader');
                            params = {
                                url: App.baseUrl('/admin/upgrade'),
                                data: {step: obj.attr('id')},
                                success: function (response) {
                                    if (objects.length > 0) {
                                        step(objects);
                                    } else {
                                        App.notify.success(response.data.getMessage());
                                        setTimeout(function () {
                                            location.reload();
                                        }, 5000);
                                    }
                                },
                                complete: function (response) {
                                    if (!jQuery.isPlainObject(response.data)) {
                                        obj.find('i').removeClass('preloader').addClass('delete');
                                        ;
                                        $(objects).each(function () {
                                            $(this).find("i").addClass('delete');
                                        });
                                        $("#rollback").show();
                                        return;
                                    }
                                    obj.find('i').removeClass('preloader')
                                        .addClass(response.data.getParam('icon'));
                                },
                                error: function (response) {
                                    App.notify.error(response.data.getMessage());
                                    $(objects).each(function () {
                                        $(this).find("i").addClass('delete');
                                    });
                                    $("#rollback").show();
                                }
                            };
                            App.remote.post(params);
                        };

                        $("#start-upgrade").live("click", function () {
                            var objects = [];
                            form = $(this).parents("form");
                            data = {};
                            data['settings'] = App.getFormParams(form);
                            data['step'] = 'start';
                            params = {
                                url: App.baseUrl('/admin/upgrade'),
                                data: data,
                                success: function (response) {
                                    if (!jQuery.isPlainObject(response.data)) {
                                        return;
                                    }
                                    $(".upgrade-form").remove();
                                    output = response.data.getOutput();
                                    descr = response.data.getParam('description');
                                    $("#upgrade-description").html(descr);
                                    $("#upgrade-description").after(output);
                                    $('.upgrade-process .table-col-line').each(function () {
                                        if ($(this).attr("id") != "rollback") {
                                            objects.push($(this));
                                        }
                                    });
                                    step(objects);
                                }
                            };
                            App.remote.post(params);
                            return false;
                        });

                        $("#testconnect").click(function () {
                            form = $("#system-form-ftpaccess");
                            form.find(".preloader").show();
                            params = {
                                url: App.baseUrl('/admin/modules/ftp-test-connect'),
                                data: App.getFormParams(form),
                                success: function (response) {
                                    App.notify.success(response.data.getMessage());
                                    $('#ftp_folder').val(response.data.getParam('path'));
                                },
                                complete: function () {
                                    form.find(".preloader").hide();
                                },
                                error: function (response) {
                                    App.notify.error(response.data.getMessage());
                                }
                            };
                            App.remote.post(params);
                        });
                        $(".activeCheckbox input").click(function () {
                            var input = $(this);
                            input.hide();
                            input.parent().css("margin-top", "0px");
                            input.parent().append('<i class="preloader" style="display:block;margin:0"></i>');
                            if (input.is(":checked")) {
                                value = 1;
                                input.attr("title", App.t('Disactivate Module'));
                            } else {
                                value = 0;
                                input.attr("title", App.t('Activate Module'));
                            }
                            params = {
                                url: App.baseUrl('/admin/modules/activation'),
                                data: {'name': input.attr('name'), 'value': value},
                                success: function (response) {
                                    input.show();
                                    input.parent().css("margin-top", "3px");
                                    input.parent().find(".preloader").remove();
                                    App.notify.success(response.data.getMessage());
                                },
                                error: function (response) {
                                    App.notify.error(response.data.getMessage());
                                }
                            };
                            App.remote.get(params);
                        });
                        $("a.delete-module").click(function () {
                            module = $(this).parent().find(".content-object-title a").text().trim();
                            if (!confirm(App.t('You want to uninstall ":moduleName" module. There is no UNDO action. Continue?', {moduleName: module}))) {
                                return false;
                            }
                        });
                    });
                }
            }
        }
    }
});

$(document).ready(function () {
    /* Help Block On\Off */
    $('.info-block-head').click(function () {
        if ($(this).next().css('display') == 'none') {
            document.cookie = "help=block; path=/;";
            $(this).next().slideDown('fast');
            $(this).children('i').removeClass('over');
        } else {
            document.cookie = "help=none; path=/;";
            $(this).next().slideUp('fast');
            $(this).children('i').addClass('over');
        }
        return false;
    });
    $('.checkAllREsponses input').live("click", function () {
        if ($(this).is(':checked')) {
            $('.objects .object').addClass('active');
            $('.checkResponse input').attr('checked', 'checked');
        } else {
            $('.objects .object').removeClass('active');
            $('.checkResponse input').removeAttr('checked');
        }
    });
    $(".table-col-line input[type=checkbox]").live("click", function () {
        if ($(this).is(":checked")) {
            $(this).parents(".table-col-line").addClass("active");
        } else {
            $(this).parents(".table-col-line").removeClass("active");
        }
    });
});