<?php
/* benchmark */
$_ENV['bench_initial'] = microtime(true);
/* set system paths */
define('DS',               DIRECTORY_SEPARATOR);
define('ROOT_PATH',        realpath(dirname(__FILE__) . "/.."));
define('CACHE_PATH',       ROOT_PATH . DS . 'cache');
define('APPLICATION_PATH', ROOT_PATH . DS . 'application');
define('LIBRARY_PATH',     ROOT_PATH . DS . 'library');
define('MODULES_PATH',     APPLICATION_PATH . DS . 'modules');
define('FILES_TEMP_PATH',  ROOT_PATH . DS . 'public' . DS . 'files' . DS . 'temp');
define('FILES_TEMP_URI',   '/public/files/temp');
define('AVATAR_PATH',      ROOT_PATH . DS . 'public' . DS . 'files' . DS . 'avatars');
define('AVATAR_URI',       '/public/files/avatars');

$_ENV['TMPDIR'] = APPLICATION_PATH . DS . 'temp';

/* set include path */
set_include_path(LIBRARY_PATH);

/* load Singular autostart instructions */
require_once 'SingularAutostart.php';

/* set application environment */
define(
    'APPLICATION_ENV', getenv('APPLICATION_ENV')
        ? getenv('APPLICATION_ENV')
        : (getenv('REDIRECT_APPLICATION_ENV')
                ? getenv('REDIRECT_APPLICATION_ENV')
                : 'production')
);

if (isset($disableMvc)) {
    return;
}

require_once 'Singular/Bootstrap.php';

$app = new Singular_Bootstrap(
    APPLICATION_ENV,
    APPLICATION_PATH . '/configs/application.inc'
);
/* bootstrap application */
$app->bootstrap();

require_once 'Useresponse.php';

//logged user
$loggedUser = new System_Model_User();
$loggedUser->role = 'guest';
Singular_Runtime::store('loggedUser', $loggedUser);

//types
$types = Singular_Loader::get('System_Model_DbTable_ResponsesTypes')
            ->cache_findActive();
Singular_Runtime::store('types', $types);
$defaultType = $types->findByField("is_default", 1);
if (!($defaultType instanceof System_Model_ResponseType)) {
    $defaultType = $types->rewind()->current();
}
Singular_Runtime::store('defaultType', $defaultType);

//statuses
$statuses = Singular_Loader::get('System_Model_DbTable_ResponsesStatuses')
                    ->cache_findAll();
Singular_Runtime::store('statuses', $statuses);

//environment
System_Service_Environment::getInstance()
    ->setNamespace(System_Service_Environment::FRONTEND);