<?php
/**
 * Application config
 */

/* PRODUCTION environment */
$config = array();

/** Errors displaying */
$config['show_errors'] = false;

/* PHP directives */
$config['phpSettings'] = array();

/* Application resources */
$config['resources'] = array();
/* Database */
$config['resources']['db'] = array();
$config['resources']['db']['adapter']            = 'pdo_mysql';
$config['resources']['db']['params'] = array();
$config['resources']['db']['params']['host']     = '{db_host}';
$config['resources']['db']['params']['port']     = 3306;
$config['resources']['db']['params']['dbname']   = '{db_name}';
$config['resources']['db']['params']['username'] = '{db_user}';
$config['resources']['db']['params']['password'] = '{db_pass}';
$config['resources']['db']['params']['prefix']   = '{db_pref}';

/* FrontController */
$config['resources']['frontController'] = array();
$config['resources']['frontController']['defaultModule'] = 'system';
$config['resources']['frontController']['baseUrl']       = '{base_url}';
$config['resources']['frontController']['plugins']       = array();
$config['resources']['frontController']['plugins'][]     = 'System_Lib_Controller_Plugin_CrashReport';

/* Router */
$config['resources']['router'] = array();
$config['resources']['router']['routes'] = array();
$config['resources']['router']['routes']['default'] = array();
$config['resources']['router']['routes']['default']['defaults'] = array();
$config['resources']['router']['routes']['default']['defaults']['module'] = 'system';

/* Modules */
$config['resources']['modules'] = array();
$config['resources']['modules']['default'] = array();

/* Cachemanager */
$config['resources']['cachemanager'] = array();
$config['resources']['cachemanager']['globalCacheEnabled'] = true;

/* Supercache */
$config['supercache_enabled'] = false;

/* Translate */
$config['resources']['translate'] = array();
// available values: cookies, user_settings, system_settings
$config['resources']['translate']['languageSource'] = 'system_settings';

/* View */
$config['resources']['view'] = array();
$config['resources']['view']['doctype'] = 'XHTML1_TRANSITIONAL';

/* Navigation */
$config['resources']['navigation'] = array();
$config['resources']['navigation']['enable'] = true;

/* Assets combining/minifying */
$config['resources']['output']['enable'] = true;

/* Directories */
$config['directories'] = array();
$config['directories']['files']      = ROOT_PATH . '/public/assets/files';
$config['directories']['media']      = ROOT_PATH . '/public/assets/files/media';
$config['directories']['temp']       = ROOT_PATH . '/public/assets/files/tmp';
$config['directories']['user_files'] = ROOT_PATH . '/public/assets/files/user';

/**
 * Environment overrides
 */
switch (APPLICATION_ENV) {

    /* DEVELOPMENT environment */
    case 'development':
        $config['show_errors']                                      = true;
        $config['resources']['db']['params']['profiler'] = array();
        $config['resources']['db']['params']['profiler']['enabled'] = true;
        $config['resources']['db']['params']['profiler']['class']   = 'Zend_Db_Profiler_Firebug';
        $config['resources']['view']['debug']                       = false;
        $config['resources']['output']['enable']                    = false;
        $config['perfomance_test']                                  = false;
    break;
}
return $config;