<?php
/* set system paths */
define('DS', DIRECTORY_SEPARATOR);
define('ROOT_PATH', realpath(dirname(__FILE__) . "/.."));
define('CACHE_PATH', ROOT_PATH . DS . 'cache');
define('APPLICATION_PATH', ROOT_PATH . DS . 'application');
define('LIBRARY_PATH', ROOT_PATH . DS . 'library');
define('MODULES_PATH', APPLICATION_PATH . DS . 'modules');
define('FILES_TEMP_PATH', ROOT_PATH . DS . 'public' . DS . 'files'. DS . 'temp');
define('FILES_TEMP_URI', '/public/files/temp');
define('AVATAR_PATH', ROOT_PATH . DS . 'public' . DS . 'files' . DS . 'avatars');
define('AVATAR_URI', '/public/files/avatars');

$_ENV['TMPDIR'] = ROOT_PATH . DS . 'temp';

/* set include path */
set_include_path(LIBRARY_PATH);

/* set application environment */
define(
'APPLICATION_ENV', getenv('APPLICATION_ENV')
    ? getenv('APPLICATION_ENV')
    : (getenv('REDIRECT_APPLICATION_ENV')
        ? getenv('REDIRECT_APPLICATION_ENV')
        : 'production')
);

define('UPGRADE', true);
define('UPGRADE_PATH', dirname(__FILE__));

$upgradeConfigFile = UPGRADE_PATH . '/templates/application.upgrade.inc';
$upgradeConfig = include_once $upgradeConfigFile;
require_once 'Zend/Config.php';

//GET DB SETTINGS
$newConfig = ROOT_PATH . '/application/configs/application.inc';
$oldConfig = ROOT_PATH . '/application/configs/application.ini';

if (file_exists($newConfig)) {
    $config = include_once $newConfig;
    /* Database */
    $upgradeConfig['resources']['db'] = array_merge($upgradeConfig['resources']['db'], $config['resources']['db']);
    /* Cachemanager */
    $bootstrapConfig = include_once ROOT_PATH . '/application/configs/bootstrap.inc';
    $upgradeConfig['resources']['cachemanager'] = $bootstrapConfig['resources']['cachemanager'];

    /* FrontController */
    $upgradeConfig['resources']['frontController'] = $config['resources']['frontController'];

} elseif (file_exists($oldConfig)) {
    $config = new Zend_Config($oldConfig);
    /* Database */
    $upgradeConfig['resources']['db'] = array_merge($upgradeConfig['resources']['db'], $config->db->toArray());
    /* Cachemanager */
    $upgradeConfig['resources']['cachemanager'] = $config->cachemanager->toArray();
    /* FrontController */
    $upgradeConfig['resources']['frontController'] = $config->frontController->toArray();

} else {
    exit('Config not Found!');
}

$upgradeConfig = new Zend_Config($upgradeConfig, true);

require_once 'Singular/Bootstrap.php';
$app = new Singular_Bootstrap(APPLICATION_ENV, $upgradeConfig, false);

require 'Useresponse.php';
$app->bootstrap();

require_once 'upgrade.php';
$upgrade = new Upgrade();
if ('POST' == strtoupper($_SERVER['REQUEST_METHOD'])
    && isset($_POST['action'])
) {
    switch ($_POST['action']) {
        case 'login':
            echo $upgrade->login();
            break;
        case 'upgrade':
            echo $upgrade->execute();
            break;
        default :
            echo $upgrade;
            break;
    }
} elseif (array_key_exists('complete', $_REQUEST)) {
    echo $upgrade->renderComplete();
} else {
    echo $upgrade;
}