<?php

// Table "<prefix>settings": Extend "key" field varchar() type value from 32 to 50
$tableName = Singular_Core::_('Db')->getTablePrefix('settings');
$fields    = Singular_Core::_('Db')->getAdapter()->fetchAll("SHOW FIELDS FROM `{$tableName}`");
if ('key' == $fields[1]['Field'] && 'varchar(32)' == $fields[1]['Type']) {
    Singular_Core::_('Db')->getAdapter()->query(
        "ALTER TABLE `{$tableName}` CHANGE `key` `key` VARCHAR(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL"
    );
}

// Change title for "top_responses" setting
if (Singular_Core::_('Settings')->hasSetting('top_responses')) {
    if ('Top Respones' == Singular_Core::_('Settings')->getSetting('top_responses', true)->title) {
        Singular_Core::_('Settings')->changeSetting(
            'top_responses',
            array(
                 'title' => 'Default Filter'
            )
        );
    }
}

// Knowledge-base module
if (isset($installedModules['knowledge-base'])) {
    Singular_Core::_('Settings')->deleteSetting(
        'knowledge_base_homepage_display'
    );
    if (!Singular_Core::_('Settings')->hasSetting(
        'homepage_content_knowledge_base'
    )
    ) {
        Singular_Core::_("settings")->addSettings(
            array(
                 'key'         => 'homepage_content_knowledge_base',
                 'value'       => '0',
                 'type'        => 'checkbox',
                 'title'       => 'Knowledge Base',
                 'description' => '',
                 'module'      => 'knowledge-base',
                 'section'     => 'responses'
            )
        );
    }
}

if (isset($installedModules['system'])) {
    $setting = Singular_Core::_("settings")->getSetting('analytics_header_script');
    if (is_null($setting)) {
        Singular_Core::_("settings")->addSettings(
            array(
                 'key'         => 'analytics_header_script',
                 'value'       => '',
                 'type'        => 'textarea',
                 'title'       => 'Header Script (Code)',
                 'description' => 'Paste external tracking code that should go before closing &#8249;/head&#8250;',
                 'module'      => 'system',
                 'section'     => 'analytics'
            )
        );
    }

    $setting = Singular_Core::_("settings")->getSetting('analytics_body_script');
    if (is_null($setting)) {
        Singular_Core::_("settings")->addSettings(
            array(
                 'key'         => 'analytics_body_script',
                 'value'       => '',
                 'type'        => 'textarea',
                 'title'       => 'Body Script (Code)',
                 'description' => 'Paste external tracking code that should go before closing &#8249;/body&#8250;',
                 'module'      => 'system',
                 'section'     => 'analytics'
            )
        );
    }
}

if (isset($installedModules['categories'])) {

    $setting = Singular_Core::_("settings")->getSetting('categories_filter_value');
    if (is_null($setting)) {
        Singular_Core::_("settings")->addSettings(
            array(
                 'key'         => 'categories_filter_value',
                 'value'       => 'all',
                 'type'        => 'select',
                 'title'       => '',
                 'description' => '',
                 'module'      => 'categories',
                 'section'     => 'general'
            )
        );
    }

    $setting = Singular_Core::_("settings")->getSetting('config_category_required');
    if (is_null($setting)) {
        Singular_Core::_("settings")->addSettings(
            array(
                 'key'         => 'config_category_required',
                 'value'       => '0',
                 'type'        => 'radio',
                 'title'       => 'Category Usage',
                 'description' => 'Force users to choose category while adding topic',
                 'module'      => 'categories',
                 'section'     => 'config'
            )
        );
    }
}

// Loginplus module
if (isset($installedModules['loginplus'])) {

    if (is_null(Singular_Core::_('settings')->getSetting('sso_native_auth_disabled'))) {
        Singular_Core::_("settings")->addSettings(
            array(
                 'key'         => 'sso_native_auth_disabled',
                 'value'       => '0',
                 'type'        => 'text',
                 'title'       => 'Toggles native auth interface visibility',
                 'description' => '',
                 'module'      => 'loginplus',
                 'section'     => 'default'
            )
        );
    }

    if (is_null(Singular_Core::_('settings')->getSetting('sso_reg_notification_disabled'))) {
        Singular_Core::_("settings")->addSettings(
            array(
                 'key'         => 'sso_reg_notification_disabled',
                 'value'       => '0',
                 'type'        => 'text',
                 'title'       => 'Toggles registration notification email',
                 'description' => '',
                 'module'      => 'loginplus',
                 'section'     => 'default'
            )
        );
    }

}

if (Singular_Core::_('Settings')->hasSetting('widget_design')) {
    Singular_Core::_('Settings')->deleteSetting('widget_design');
}

if (!Singular_Core::_('Db')->hasTableField('has_votes', 'response_types')) {
    $table = Singular_Core::_('Db')->getTablePrefix('response_types');
    Singular_Core::_('Db')->execute(
        "ALTER TABLE `{$table}` ADD COLUMN `has_votes` TINYINT(1) UNSIGNED NOT NULL DEFAULT '1' AFTER `has_negative_vote`;"
    );
}

if (!Singular_Core::_('Db')->hasTableField('text_color', 'response_statuses')) {
    $table = Singular_Core::_('Db')->getTablePrefix('response_statuses');
    Singular_Core::_('Db')->execute(
        "ALTER TABLE `{$table}` ADD COLUMN `text_color` VARCHAR(7) DEFAULT '#ffffff' NOT NULL AFTER `color`;"
    );
}

if (!Singular_Core::_('Db')->hasTableField('is_protected', 'response_statuses')) {
    $table = Singular_Core::_('Db')->getTablePrefix('response_statuses');
    Singular_Core::_('Db')->execute(
        "ALTER TABLE `{$table}` ADD COLUMN `is_protected` TINYINT(1) DEFAULT '1' NOT NULL AFTER `is_default`;"
    );
}

// Chat module
if (isset($installedModules['chat'])) {
    if (!Singular_Core::_('Settings')->hasSetting('chat_auto_open')) {
        Singular_Core::_("settings")->addSettings(
            array(
                 'key'         => 'chat_auto_open',
                 'value'       => '0',
                 'type'        => 'yes_no',
                 'title'       => 'Auto Open',
                 'description' => 'Open widget automatically after set number of seconds',
                 'module'      => 'chat',
                 'section'     => 'general'
            )
        );
    }

    if (!Singular_Core::_('Settings')->hasSetting('chat_auto_open_seconds')) {
        Singular_Core::_("settings")->addSettings(
            array(
                 'key'         => 'chat_auto_open_seconds',
                 'value'       => '10',
                 'type'        => 'select',
                 'title'       => 'Time in Seconds',
                 'description' => 'User is located on page before widget opens',
                 'module'      => 'chat',
                 'section'     => 'general'
            )
        );
    }
}

if (!Singular_Core::_('Settings')->hasSetting('homepage_responses_items_num')) {
    Singular_Core::_("settings")->addSettings(
        array(
             'key'         => 'homepage_responses_items_num',
             'value'       => '3',
             'type'        => 'select',
             'title'       => 'Number of Items per Type',
             'description' => '',
             'module'      => 'system',
             'section'     => 'responses'
        )
    );
}

if (!Singular_Core::_('Settings')->hasSetting('homepage_responses_display_variant')) {
    Singular_Core::_("settings")->addSettings(
        array(
             'key'         => 'homepage_responses_display_variant',
             'value'       => 'divided_by_type',
             'type'        => 'select',
             'title'       => 'Display Responses',
             'description' => '',
             'module'      => 'system',
             'section'     => 'responses'
        )
    );
}

if (!Singular_Core::_('Settings')->hasSetting('homepage_content_responses')) {
    Singular_Core::_("settings")->addSettings(
        array(
             'key'         => 'homepage_content_responses',
             'value'       => 1,
             'type'        => 'checkbox',
             'title'       => 'Responses on Home Page',
             'description' => '',
             'module'      => 'system',
             'section'     => 'responses'
        )
    );
} else {
    if ('Home Page Content' == Singular_Core::_('Settings')
        ->getSetting('homepage_content_responses', true)->title
    ) {
        Singular_Core::_('Settings')->changeSetting(
            'homepage_content_responses',
            array(
                 'title' => 'Responses on Home Page'
            )
        );
    }
}

// Table indexes "<prefix>responses"
$tableName = Singular_Core::_('Db')->getTablePrefix('responses');
$indexes = Singular_Core::_('Db')->getAdapter()->fetchAll("SHOW INDEX FROM `{$tableName}`");
$collection = array();
if (is_array($indexes)) {
    foreach ($indexes as $index) {
        $collection[] = $index['Key_name'];
    }
}
if (!in_array('created_by_id', $collection)) {
    try {
        Singular_Core::_('Db')->getAdapter()->query(
            "ALTER TABLE `{$tableName}` ADD INDEX `created_by_id` (`created_by_id`)"
        );
    } catch (Exception $e) {}
}
if (!in_array('updated_by_id', $collection)) {
    try {
        Singular_Core::_('Db')->getAdapter()->query(
            "ALTER TABLE `{$tableName}` ADD INDEX `updated_by_id` (`updated_by_id`)"
        );
    } catch (Exception $e) {}
}

// Table indexes "<prefix>users"
$tableName = Singular_Core::_('Db')->getTablePrefix('users');
$indexes = Singular_Core::_('Db')->getAdapter()->fetchAll("SHOW INDEX FROM `{$tableName}`");
$collection = array();
if (is_array($indexes)) {
    foreach ($indexes as $index) {
        $collection[] = $index['Key_name'];
    }
}
if (!in_array('hidden', $collection)) {
    try {
        Singular_Core::_('Db')->getAdapter()->query(
            "ALTER TABLE `{$tableName}` ADD INDEX `hidden` (`hidden`)"
        );
    } catch (Exception $e) {}
}

// Table indexes "<prefix>response_comments"
$tableName = Singular_Core::_('Db')->getTablePrefix('response_comments');
$indexes = Singular_Core::_('Db')->getAdapter()->fetchAll("SHOW INDEX FROM `{$tableName}`");
$collection = array();
if (is_array($indexes)) {
    foreach ($indexes as $index) {
        $collection[] = $index['Key_name'];
    }
}
if (!in_array('created_by_id', $collection)) {
    try {
        Singular_Core::_('Db')->getAdapter()->query(
            "ALTER TABLE `{$tableName}` ADD INDEX `created_by_id` (`created_by_id`)"
        );
    } catch (Exception $e) {}
}

// Table indexes "<prefix>response_statuses"
$tableName = Singular_Core::_('Db')->getTablePrefix('response_statuses');
$indexes = Singular_Core::_('Db')->getAdapter()->fetchAll("SHOW INDEX FROM `{$tableName}`");
$collection = array();
if (is_array($indexes)) {
    foreach ($indexes as $index) {
        $collection[] = $index['Key_name'];
    }
}
if (!in_array('type', $collection)) {
    try {
        Singular_Core::_('Db')->getAdapter()->query(
            "ALTER TABLE `{$tableName}` ADD INDEX `type` (`type`)"
        );
    } catch (Exception $e) {}
}

// Table indexes "<prefix>modules"
$tableName = Singular_Core::_('Db')->getTablePrefix('modules');
$indexes = Singular_Core::_('Db')->getAdapter()->fetchAll("SHOW INDEX FROM `{$tableName}`");
$collection = array();
if (is_array($indexes)) {
    foreach ($indexes as $index) {
        $collection[] = $index['Key_name'];
    }
}
if (!in_array('load_order_n_active', $collection)) {
    try {
        Singular_Core::_('Db')->getAdapter()->query(
            "ALTER TABLE `{$tableName}` ADD INDEX `load_order_n_active` (`load_order`, `active`)"
        );
    } catch (Exception $e) {}
}

// Table indexes "<prefix>activity_logs"
$tableName = Singular_Core::_('Db')->getTablePrefix('activity_logs');
$indexes = Singular_Core::_('Db')->getAdapter()->fetchAll("SHOW INDEX FROM `{$tableName}`");
$collection = array();
if (is_array($indexes)) {
    foreach ($indexes as $index) {
        $collection[] = $index['Key_name'];
    }
}
if (!in_array('created_at', $collection)) {
    try {
        Singular_Core::_('Db')->getAdapter()->query(
            "ALTER TABLE `{$tableName}` ADD INDEX `created_at` (`created_at`)"
        );
    } catch (Exception $e) {}
}

// Table indexes "<prefix>votes"
$tableName = Singular_Core::_('Db')->getTablePrefix('votes');
$indexes = Singular_Core::_('Db')->getAdapter()->fetchAll("SHOW INDEX FROM `{$tableName}`");
$collection = array();
if (is_array($indexes)) {
    foreach ($indexes as $index) {
        $collection[] = $index['Key_name'];
    }
}
if (!in_array('created_at', $collection)) {
    try {
        Singular_Core::_('Db')->getAdapter()->query(
            "ALTER TABLE `{$tableName}` ADD INDEX `created_by_id` (`created_by_id`)"
        );
    } catch (Exception $e) {}
}

// Update "system_version" setting to 2.3
Singular_Core::_('Settings')->changeSetting(
    'system_version',
    array(
         'value' => '2.3'
    )
);

return true;
