<?php
$tpls = new Resources_Model_DbTable_Templates();

// Modify "new_comment" template
$tpl = $tpls->findBySlug('new_comment');

// "English" language
$tplLang = $tpl->getLangRow('en');
if ($tplLang instanceof Resources_Model_TemplateLang
    && false === strpos($tplLang->subject, ':response_status')
) {
    $tplLang->subject = ':response_statusNew comment on ":response_name" :response_type has been posted';
    $tplLang->save();
}
// "Russian" language
$tplLang = $tpl->getLangRow('ru');
if ($tplLang instanceof Resources_Model_TemplateLang
    && false === strpos($tplLang->subject, ':response_status')
) {
    $tplLang->subject = ':response_statusДобавлен новый комментарий в ":response_name" :response_type';
    $tplLang->save();
}

// Modify "official_answer" template
$tpl = $tpls->findBySlug('official_answer');

// "English" language
$tplLang = $tpl->getLangRow('en');
if ($tplLang instanceof Resources_Model_TemplateLang
    && false === strpos($tplLang->subject, ':response_status')
) {
    $tplLang->subject = ':response_statusNew official answer on ":response_name" :response_type has been posted';
    $tplLang->save();
}
// "Russian" language
$tplLang = $tpl->getLangRow('ru');
if ($tplLang instanceof Resources_Model_TemplateLang
    && false === strpos($tplLang->subject, ':response_status')
) {
    $tplLang->subject = ':response_statusДобавлен официальный ответ в ":response_name" :response_type';
    $tplLang->save();
}
unset($tpls, $tpl, $tplLang);

// Fix invalid closing "<a/>" tag in email templates body
$templatesModel = new Resources_Model_DbTable_TemplatesLang();
$templates      = $templatesModel->fetchAll();
if ($templates instanceof System_Model_Rowset) {
    foreach ($templates as $template) {
        if ($template instanceof Resources_Model_TemplateLang) {
            if (false !== strpos($template->body, '<a/>')) {
                $template->body = str_replace('<a/>', '</a>', $template->body);
                $template->save();
            }
        }
    }
}
unset($templatesModel, $templates);

// Add "object:can_see_users" resource
$resourcesModel = new System_Model_DbTable_Resources();
if (null === $resourcesModel->findByResource('object:can_see_users')) {
    $resourcesModel->insert(
        array(
             'type'         => 'object',
             'resource'     => 'object:can_see_users',
             'parent'       => new Zend_Db_Expr('NULL'),
             'name'         => 'See Users',
             'is_protected' => 1
        )
    );
}
unset($resourcesModel);

// Add privileges for "object:can_see_users" resource
$privilegesModel = new System_Model_DbTable_Privileges();
if (null === $privilegesModel->findByRoleAndResource('guest', 'object:can_see_users')) {
    $privilegesModel->insert(
        array(
             'type'         => 'allow',
             'roles'        => 'guest',
             'resources'    => 'object:can_see_users',
             'privileges'   => new Zend_Db_Expr('NULL'),
             'assert'       => new Zend_Db_Expr('NULL'),
             'is_active'    => 1,
             'is_protected' => 0
        )
    );
}
if (null === $privilegesModel->findByRoleAndResource('user', 'object:can_see_users')) {
    $privilegesModel->insert(
        array(
             'type'         => 'allow',
             'roles'        => 'user',
             'resources'    => 'object:can_see_users',
             'privileges'   => new Zend_Db_Expr('NULL'),
             'assert'       => new Zend_Db_Expr('NULL'),
             'is_active'    => 1,
             'is_protected' => 0
        )
    );
}
if (null === $privilegesModel->findByRoleAndResource('official-representative', 'object:can_see_users')) {
    $privilegesModel->insert(
        array(
             'type'         => 'allow',
             'roles'        => 'official-representative',
             'resources'    => 'object:can_see_users',
             'privileges'   => new Zend_Db_Expr('NULL'),
             'assert'       => new Zend_Db_Expr('NULL'),
             'is_active'    => 1,
             'is_protected' => 0
        )
    );
}
if (null === $privilegesModel->findByRoleAndResource('administrator', 'object:can_see_users')) {
    $privilegesModel->insert(
        array(
             'type'         => 'allow',
             'roles'        => 'administrator',
             'resources'    => 'object:can_see_users',
             'privileges'   => new Zend_Db_Expr('NULL'),
             'assert'       => new Zend_Db_Expr('NULL'),
             'is_active'    => 1,
             'is_protected' => 0
        )
    );
}
unset($privilegesModel);

// Update "system_version" setting to 2.3.4
Singular_Core::_('Settings')->changeSetting(
    'system_version',
    array('value' => '2.3.4')
);

return true;
