<?php
/**
 * Application config
 */
$config = array();

/** Errors displaying */
$config['show_errors'] = true;

/* PHP directives */
$config['phpSettings'] = array();

/* Application resources */
$config['resources'] = array();

/* Database */
$config['resources']['db'] = array();
$config['resources']['db']['isDefaultTableAdapter'] = true;

/* FrontController */
$config['resources']['frontController'] = array();
$config['resources']['frontController']['defaultModule']    = 'system';
$config['resources']['frontController']['throwExceptions']  = false;
$config['resources']['frontController']['plugins'] = array();
$config['resources']['frontController']['plugins'][]        = 'System_Lib_Controller_Plugin_CrashReport';

/* Autoloader */
$config['resources']['autoloader'] = array();
$config['resources']['autoloader']['autoloader'] = 'Singular';
$config['resources']['autoloader']['singular'] = array();
$config['resources']['autoloader']['singular']['cache'] = array();
$config['resources']['autoloader']['singular']['cache']['enable'] = false;
$config['resources']['autoloader']['singular']['cache']['frontend'] = array();
$config['resources']['autoloader']['singular']['cache']['frontend']['name'] = 'Core';
$config['resources']['autoloader']['singular']['cache']['frontend']['customFrontendNaming'] = false;
$config['resources']['autoloader']['singular']['cache']['frontend']['options'] = array();
$config['resources']['autoloader']['singular']['cache']['frontend']['options']['lifetime'] = 864000;
$config['resources']['autoloader']['singular']['cache']['frontend']['options']['automatic_serialization'] = true;
$config['resources']['autoloader']['singular']['cache']['frontend']['options']['cache_id_prefix'] = 'autoloader_';
$config['resources']['autoloader']['singular']['cache']['frontend']['options']['ignore_user_abort'] = true;
$config['resources']['autoloader']['singular']['cache']['backend'] = array();
$config['resources']['autoloader']['singular']['cache']['backend']['name'] = 'File';
$config['resources']['autoloader']['singular']['cache']['backend']['customBackendNaming'] = false;
$config['resources']['autoloader']['singular']['cache']['backend']['options'] = array();
$config['resources']['autoloader']['singular']['cache']['backend']['options']['cache_dir'] = ROOT_PATH . "/cache/";
$config['resources']['autoloader']['singular']['cache']['backend']['options']['hashed_directory_level'] = 0;
$config['resources']['autoloader']['singular']['cache']['backend']['options']['read_control'] = false;
$config['resources']['autoloader']['singular']['cache']['backend']['options']['read_control_type'] = 'adler32';
$config['resources']['autoloader']['singular']['cache']['backend']['options']['metatadatas_array_max_size'] = 10;
$config['resources']['autoloader']['singular']['cache']['frontendBackendAutoload'] = false;
$config['resources']['autoloader']['zend'] = array();
$config['resources']['autoloader']['zend']['params'] = array();
$config['resources']['autoloader']['zend']['params']['enableFallbackAutoloader'] = true;
$config['resources']['autoloader']['zend']['params']['suppressNotFoundWarnings'] = false;
$config['resources']['autoloader']['zend']['params']['noZendX'] = true;
$config['resources']['autoloader']['zend']['registry_key'] = 'autoloader';
$config['resources']['autoloader']['zend']['modules'] = array();
$config['resources']['autoloader']['zend']['modules'][] = 'system';

/* Modules */
$config['resources']['modules'] = array();
$config['resources']['modules']['default'] = array();

/* Layout */
$config['resources']['layout']['layoutPath'] = APPLICATION_PATH . "/layouts";
$config['resources']['layout']['layout'] = 'main';
$config['resources']['layout']['contentKey'] = 'content';

/* Session */
$config['resources']['session'] = array();
$config['resources']['session']['use_only_cookies'] = true;
$config['resources']['session']['remember_me_seconds'] = 864000;

/* View */
$config['resources']['view']['encoding'] = 'utf-8';
$config['resources']['view']['setUseStreamWrapper'] = false;
$config['resources']['view']['strictVars'] = true;
$config['resources']['view']['escape'] = 'htmlentities';
$config['resources']['view']['scriptPath'] = APPLICATION_PATH . '/templates';
$config['resources']['view']['helperPath'] = array('Singular_View_Helper_' => 'Singular/View/Helper');
$config['resources']['view']['filterPath'] = array('Singular_View_Helper_' => 'Singular/View/Filter');
$config['resources']['view']['doctype'] = 'HTML5';
$config['resources']['view']['debug'] = false;

/* Cache Manager */
$config['resources']['cachemanager']['globalCacheEnabled']  = true;

/* Auth */
$config['resources']['auth']['table_name'] = 'users';
$config['resources']['auth']['columns'] = array();
$config['resources']['auth']['columns']['identity'] = 'email';
$config['resources']['auth']['columns']['credential'] = 'password';
$config['resources']['auth']['columns']['is_active'] = 'is_active';
$config['resources']['auth']['allow_value'] = '1';
$config['resources']['auth']['enable'] = true;

/* htmlElement */
$config['htmlElement'] = array();
$config['htmlElement']['assetsPath'] = 'public/assets';
$config['htmlElement']['assetsPathModules'] = 'public/assets/modules';
$config['htmlElement']['assetsPathThemes'] = 'assets';
$config['htmlElement']['imageDirName'] = 'images';
$config['htmlElement']['flashDirName'] = 'flash';
$config['htmlElement']['stylesheetDirName'] = 'css';
$config['htmlElement']['javascriptDirName'] = 'js';
$config['htmlElement']['commonDirName'] = 'common';
$config['htmlElement']['checkExistence'] = false;

return $config;